'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 28 July 2002 at 2:56:25 pm'!
"Change Set:		MaSqueakDomain
Date:			26 December 2001
Author:			Chris Muller

<This change set contains classes that represent squeak artifacts, such as classes, methods, change sets, etc.>"!

Object subclass: #MaMethodSelector
	instanceVariableNames: 'methods isCaseSensitive '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma ide-Code domain'!

!MaMethodSelector commentStamp: 'cmm 7/23/2002 21:25' prior: 0!
I'm useful for finding methods in the image.  Be wary, I was ported from VA and, though some methods have been ported, I haven't been through a full quality check yet.!


!MaMethodSelector methodsFor: 'accessing' stamp: 'cmm 4/22/2002 23:20'!
classes
	"Returns the set of classes that all methods in the receiver span."

	^self methods collect: [ :each | each maMethodClass ]
! !

!MaMethodSelector methodsFor: 'accessing'!
isCaseSensitive

	^isCaseSensitive
! !

!MaMethodSelector methodsFor: 'accessing'!
methods

	"Returns the selected methods."

	^methods
! !

!MaMethodSelector methodsFor: 'accessing'!
methods: aSet

	methods := aSet
! !

!MaMethodSelector methodsFor: 'actions'!
clear

	self methods: Set new
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 2/17/2002 16:43'!
addAll
	"Selects all methods in the image.  This can take an incredibly
	long time.  We should analyze a faster way of doing this."

	Smalltalk allClasses do: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/23/2002 00:04'!
addAllChangeSetsInCategoryNamed: aString

	(ChangeSorter changeSetCategoryNamed: aString) changeSetList
		do:
			[ :each | self addChangeSetNamed: each ]! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/23/2002 00:03'!
addAllExtendedChangeSets

	self addAllChangeSetsInCategoryNamed: 'Extended'
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 2/17/2002 16:46'!
addCategories: categoryString
	"Add all methods in the system which are in the category categoryString."

	Smalltalk do:
		[ :each | | selectors |
		selectors :=
			each
				methodNamesCategorizedIn: categoryString substrings
				all: false.
		self methods
			addAll: (selectors collect: [ :eachSelector | each compiledMethodAt: eachSelector ]) ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/22/2002 23:48'!
addChangeSet: aChangeSet

	| changesDictionary |
	changesDictionary _ aChangeSet methodChanges.
	changesDictionary keysAndValuesDo:
		[ :eachClassName :eachChangesDict |
		| class |
		class _ eachClassName substrings size = 1
			ifTrue:
				[ Smalltalk
					at: eachClassName
					ifAbsent: [ nil ] ]
			ifFalse:
				[ Smalltalk
					at: (eachClassName substrings first asSymbol)
					ifAbsent: [ nil ] ].
		class ifNotNil:
			[ eachClassName substrings size > 1 "if it is a class method"
				ifTrue: [ class _ class class ].
			eachChangesDict keysAndValuesDo:
				[ :eachSelector :eachChangeType |
				(#(add change) includes: eachChangeType)
					ifTrue:
						[ (class methodDict includesKey: eachSelector)
							ifTrue:
								[ self methods add: (class compiledMethodAt: eachSelector) ] ] ] ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/22/2002 23:02'!
addChangeSetNamed: aString

	^self addChangeSet: (ChangeSorter changeSetNamed: aString)! !

!MaMethodSelector methodsFor: 'adding'!
addClass: aClass

	"Adds all methods in aClass"

	self methods addAll: aClass methodDictionary values
! !

!MaMethodSelector methodsFor: 'adding'!
addClassHierarchy: aClass
	"Adds the methods in aClass as well as all of its superclasses."

	self addSuperclassHierarchy: aClass.
	self addSubclassHierarchy: aClass
! !

!MaMethodSelector methodsFor: 'adding'!
addClasses: classesCollection

	"Adds all methods in each class in classesCollectoin"

	classesCollection do: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/26/2002 00:29'!
addClassesNamed: classNameArgumentString

	| classes |

self maMarked: 'dev'.  "not converted from visualage.."
"
	classes :=
		System
			findClassUsing: classNameArgumentString
			ifCancel: [ ^OrderedCollection new ]."
	classes isClass
		ifTrue:
			[ self addClass: classes ]
		ifFalse:
			[ classes do: [ :each | self addClass: each ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/27/2002 18:17'!
addMethodsNamed: aString

	ProtoObject withAllSubclassesDo:
		[ :eachClass |
		eachClass methodDict keysAndValuesDo:
			[ :eachSelector :eachMethod |
			(eachSelector maBeginsWith: aString) ifTrue: [ self methods add: eachMethod ] ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/26/2002 00:30'!
addMethodsReferencing: aString
	"Add all methods whose names reference the literal aString"
self maMarked: 'dev'.  "not converted from va"

"
	System classHierarchyRoots
		do: [ :each | self methods addAll: (each allMethodsReferencingLiteral: aString) ]
"
! !

!MaMethodSelector methodsFor: 'adding'!
addMethodsReferencingAny: aCollection
	"Add all methods whose names reference any of the the literals in aCollection."

	aCollection do: [ :each | self addMethodsReferencing: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/26/2002 00:30'!
addMethodsReferencingInstanceVariableNamed: aString

	"Add all methods whose names reference the literal aString"
self maMarked: 'dev'.  "not converted from va"
"
	System classHierarchyRoots
		do: [ :each | self methods addAll: (each whichMethodsReferenceInstVarName: aString) ]
"! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 5/1/2002 23:45'!
addMethodsSending: aString

	"Present a window with all that matches aString.  From
	that the user selects a list of methods that are then added
	to the receiver."

	| selectors |

	selectors := Symbol selectorsContaining: aString.
	selectors isEmpty ifTrue: [ ^self ].  "shortcut"
	ProtoObject withAllSubclasses do:
		[ :eachClass |
		selectors do:
			[ :eachSelector |
			self methods addAll: (eachClass allCallsOn: eachSelector) ] ]
! !

!MaMethodSelector methodsFor: 'adding'!
addSubclassHierarchy: aClass

	"Adds the methods in aClass as well as all of its subclasses."

	aClass withAllSubclassesDo: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding'!
addSuperclassHierarchy: aClass
	"Adds the methods in aClass as well as all of its subclasses."

	aClass withAllSuperclassesDo: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'configuring'!
beCaseInsensitive

	isCaseSensitive := false
! !

!MaMethodSelector methodsFor: 'configuring'!
beCaseSensitive

	isCaseSensitive := true
! !

!MaMethodSelector methodsFor: 'initializing'!
initialize

	methods := Set new.
	isCaseSensitive := false
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 4/22/2002 23:19'!
selectCategories: anArray
	"Select all methods from the receiver which are in anArray of category
	names."

	self methods: (
		self classes
			inject: Set new
			into:
				[ :set :eachClass | 
				anArray
					inject: set
					into:
						[ :sameSet :eachCategory |
						sameSet addAll: ((eachClass organization listAtCategoryNamed: eachCategory)
							collect: [ :eachClassSelector | eachClass compiledMethodAt: eachClassSelector ]); yourself ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 2/17/2002 16:16'!
selectClass: aClass

	"Select all methods in the receiver which exist in an aClass"

	self methods: (self methods select: [ :each | each maMethodClass == aClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 2/17/2002 16:16'!
selectClassHierarchy: aClass

	"Select all methods in the receiver which exist in aClass as
	well as all of its super and subclasses."

	| hierarchy |

	hierarchy := (Array with: aClass) , aClass allSubclasses , aClass allSuperclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each maMethodClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 2/17/2002 16:17'!
selectClassesNamed: classNameArgumentString

	"Filter out all methods in the receiver that don't belong to one of the
	classes that begin with classNameArgumentString."

	self methods: (
		self methods select:
			[ :each |
			each maMethodClass printString
				maBeginsWith: classNameArgumentString
				ignoringCase: self isCaseSensitive ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodNamesContaining: aString
	"Removes all but the method names that include aString"

	self methods: (
		self methods select:
			[ :each |
			each selector asString
				maIncludesString: aString
				ignoringCase: self isCaseSensitive not ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsContainingString: aString
	"Returns all of the methods in the image containing string aString.  This can
	take quite a bit of time."

	self methods: (
		self methods select:
			[ :each |
			each sourceString notNil
				and: [ (each sourceString maIncludesString: aString)
				or: [ each comment maIncludesString: aString ] ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 4/23/2002 00:13'!
selectMethodsInChangeSet: aChangeSet

	self methods:
		(self methods select:
			[ :each |
			(ChangeSorter
				allChangeSetsWithClass: each maMethodClass
				selector: each selector) includes: aChangeSet ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 4/23/2002 00:14'!
selectMethodsInChangeSetNamed: aString

	^self selectMethodsInChangeSet: (ChangeSorter changeSetNamed: aString)
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 7/27/2002 18:41'!
selectMethodsInNoChangeSet

	| count |
	count _ 0.
	self methods:
		(self methods select:
			[ :each |
			count _ count + 1.
			count \\ 10 = 0 ifTrue: [ ProgressNotification signal: count printString, ' classes searched.' ].
			(ChangeSorter
				allChangeSetsWithClass: each maMethodClass
				selector: each selector) size = 0 ])! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsNamed: aString
	"Removes all but the method names that begin with aString"

	self methods: (
		self methods select:
			[ :each |
			each selector asString
				maBeginsWith: aString
				ignoringCase: self isCaseSensitive not ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsReferencing: aString

	"Add all methods whose names reference the instance variable aString"

	self methods: (self methods select: [ :each | each referencesLiteral: aString ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsReferencingAny: anArray

	self methods: (
		self methods select:
			[ :each | anArray maIncludesWhere: [ :eachString | each referencesLiteral: eachString ] ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsReferencingInstanceVariableNamed: aString

	"Add all methods whose names reference the instance variable aString"

	self methods: (self methods select: [ :each | each referencesInstVar: aString ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsSending: selector

	"Select all methods which send aString"

	self methods: (
		self methods select:
			[ :each |
			(each sendsNormalSelector: selector) or: [ each sendsSpecialSelector: selector ] ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectMethodsSendingAny: anArray
	"Select all methods which send aString"

	self methods: (
		self methods select:
			[ :each |
			anArray maIncludesWhere:
				[ :eachSelector |
				(each sendsNormalSelector: eachSelector)
					or: [ each sendsSpecialSelector: eachSelector ] ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 7/27/2002 18:26'!
selectMethodsWhere: aBlock

	self methods: (self methods select: aBlock)! !

!MaMethodSelector methodsFor: 'removing'!
selectPrivate

	self methods: (self methods select: [ :each | each isPrivate ])
! !

!MaMethodSelector methodsFor: 'removing'!
selectPublic

	self methods: (self methods select: [ :each | each isPublic ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 2/17/2002 16:17'!
selectSubclassHierarchy: aClass
	"Select all methods in the receiver which exist in a aClass as
	well as all of aClass subclasses."

	| hierarchy |

	hierarchy := (Array with: aClass) , aClass allSubclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each maMethodClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 2/17/2002 16:16'!
selectSuperclassHierarchy: aClass

	"Select all methods in the receiver which exist in a aClass as
	well as all of aClass superclasses."

	| hierarchy |

	hierarchy := aClass withAllSuperclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each maMethodClass ])
! !


!MaMethodSelector class methodsFor: 'creation'!
new

	^super new initialize
! !


!MaMethodSelector reorganize!
('accessing' classes isCaseSensitive methods methods:)
('actions' browseAs: clear)
('adding' addAll addAllChangeSetsInCategoryNamed: addAllExtendedChangeSets addCategories: addChangeSet: addChangeSetNamed: addClass: addClassHierarchy: addClasses: addClassesNamed: addMethodsNamed: addMethodsReferencing: addMethodsReferencingAny: addMethodsReferencingInstanceVariableNamed: addMethodsSending: addSubclassHierarchy: addSuperclassHierarchy:)
('configuring' beCaseInsensitive beCaseSensitive)
('initializing' initialize)
('removing' selectCategories: selectClass: selectClassHierarchy: selectClassesNamed: selectMethodNamesContaining: selectMethodsContainingString: selectMethodsInChangeSet: selectMethodsInChangeSetNamed: selectMethodsInNoChangeSet selectMethodsNamed: selectMethodsReferencing: selectMethodsReferencingAny: selectMethodsReferencingInstanceVariableNamed: selectMethodsSending: selectMethodsSendingAny: selectMethodsWhere: selectPrivate selectPublic selectSubclassHierarchy: selectSuperclassHierarchy:)
!

"Postscript:
"
!

