'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 1 August 2002 at 7:10:31 pm'!
MaBufferedObjectProxy subclass: #MaOdbmsProxy
	instanceVariableNames: 'session '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObject subclass: #MaBasicReadStrategy
	instanceVariableNames: 'minimumDepth '
	classVariableNames: 'Default SystemReadStrategy '
	poolDictionaries: ''
	category: 'Magma-Client'!

!MaBasicReadStrategy commentStamp: '<historical>' prior: 0!
This class operates on the client and server.!

MaObject subclass: #MaChangedKeySpecification
	instanceVariableNames: 'object attribute oldHashValue newHashValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObject subclass: #MaCollectionSegment
	instanceVariableNames: 'pageSize startIndex objects lastKnownSize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaObject subclass: #MaCommitPackage
	instanceVariableNames: 'objects readSet allLargeCollectionChanges '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaCommitPackage commentStamp: '<historical>' prior: 0!
The main structure of this class is a dictionary (objectSpaceId -> OrderedCollection of changed objects).
Once #serializeObjectsUsing: is called, it is (objectSpaceId -> aMaSerializedGraphBuffer
(serialized OrderedCollection of changed objects)).

If any new classes were discovered in the client while calculating the changed objects, they are assigned
to the system objectSpace (where they belong).

	65534 -> new classes
	01 -> objects changed in objectSpace 01
!

MaObject subclass: #MaIndexDefinition
	instanceVariableNames: 'attribute '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaCollectionSegment subclass: #MaIndexedCollectionSegment
	instanceVariableNames: 'lowKey highKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaObject subclass: #MaLargeCollectionChanges
	instanceVariableNames: 'collectionLoid changes isNewCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!

!MaLargeCollectionChanges commentStamp: '<historical>' prior: 0!
This is a private class.  Applications should have no need to use this class directly.
!

MaObject subclass: #MaObjectLinkDescription
	instanceVariableNames: 'mainOid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObjectLinkDescription subclass: #MaByteObjectLinkDescription
	instanceVariableNames: 'bytes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObjectLinkDescription subclass: #MaFirstClassObjectLinkDescription
	instanceVariableNames: 'linkedOids '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaStorageForClass subclass: #MaOdbmsClassDefinition
	instanceVariableNames: 'instVarNames version upgradeBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaOdbmsClassDefinition commentStamp: '<historical>' prior: 0!
The purpose of this class is to allow the classDefinitions to be materialized
without being converted to their true-form (the class itself).

This is needed to maintain the classDefinitionsById dictionary (kept in the
classIdManager), which is a dictionary that helps us keep track of
classUpgrades.
!

MaDefaultClassIdManager subclass: #MaOdbmsClassIdManager
	instanceVariableNames: 'classesSet '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaOdbmsClassIdManager commentStamp: '<historical>' prior: 0!
The purpose of this class is to keep a reference to the object
repository's classesSet, which is necessary for retrieving the
repository root when initially opening the repository (we can't
materialize the complex classDefinitions without knowing all of
the classId's of the classes of objects that make up the
classDefinitions).
!

MaBasicReadStrategy subclass: #MaReadStrategy
	instanceVariableNames: 'depths '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!

!MaReadStrategy commentStamp: '<historical>' prior: 0!
This class operates on the client and server.

This class manages a simple structure, a Dictionary of Arrays whose keys are
classIds.  Each element in the array is the depth to read for that instVarIndex.

This is built using the Building methods so that the Testing methods can then
answer whether a particular depth should be read on a particular object or
class.
!

MaObject subclass: #MaRefreshViewResult
	instanceVariableNames: 'connection toBeRefreshed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!
MaRefreshViewResult subclass: #MaCommitResult
	instanceVariableNames: 'permanentLoids '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!

!MaCommitResult commentStamp: '<historical>' prior: 0!
This class is instantiated on the server and returned to the client.
!

MaCommitResult subclass: #MaFailedCommitResult
	instanceVariableNames: 'commitConflicts dirtyReads largeCollectionConflicts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!
MaObject subclass: #MaRepositoryControllerFacade
	instanceVariableNames: 'link session requestPrototypes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaServerRequest subclass: #MaRepositoryRequest
	instanceVariableNames: 'sessionId repositoryController '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaRepositoryRequest subclass: #MaAbortTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaRepositoryRequest subclass: #MaAbstractReadRequest
	instanceVariableNames: 'readStrategy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaAbstractReadRequest subclass: #MaAnchorRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaAbstractReadRequest subclass: #MaLargeCollectionSegmentRequest
	instanceVariableNames: 'quantity collectionLoid attribute '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaRepositoryRequest subclass: #MaLargeCollectionSizeRequest
	instanceVariableNames: 'collectionOid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaLargeCollectionSizeRequest subclass: #MaKeyIntervalInfoRequest
	instanceVariableNames: 'attribute lowKey highKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!

!MaKeyIntervalInfoRequest commentStamp: '<historical>' prior: 0!
This request is used to get sizes of sub-magmacollections, either with or without
index.
!

MaAbstractReadRequest subclass: #MaReadRequest
	instanceVariableNames: 'oid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaRepositoryRequest subclass: #MaRepositoryConnectionRequest
	instanceVariableNames: 'userId maximumNumberOfChallengers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaRepositoryRequest subclass: #MaRepositoryDisconnectRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObject subclass: #MaRootAnchor
	instanceVariableNames: 'object '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaRootAnchor commentStamp: '<historical>' prior: 0!
This class represents the real root of every objectSpace.  It provides us with a
replaceable root, since the locations of objects can never change.  It also makes
it cleaner to write the root, since all we have to do is write this object using special
code, then we can write the root by simply changing this object.

This class will live on the client and server, since the client can ask for to replace
the root.
!

MaLargeCollectionSegmentRequest subclass: #MaSegmentByIndexRequest
	instanceVariableNames: 'lowIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaLargeCollectionSegmentRequest subclass: #MaSegmentByKeyRequest
	instanceVariableNames: 'lowKey highKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaIndexedCollectionSegment subclass: #MaSegmentRequestResult
	instanceVariableNames: 'indexOfHighestKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections private'!
MaObject subclass: #MaTransaction
	instanceVariableNames: 'readSet session largeCollectionChanges '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaTransaction commentStamp: '<historical>' prior: 0!
This class is private.  Applications should use the transaction control provided on
MagmaSession.
!

MaRepositoryRequest subclass: #MaTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaIndexDefinition subclass: #MaValueIndexDefinition
	instanceVariableNames: 'keySize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaValueIndexDefinition subclass: #MaByteSequenceIndexDefinition
	instanceVariableNames: 'meaningfulCharacters '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaByteSequenceIndexDefinition subclass: #MaAsciiStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaByteSequenceIndexDefinition subclass: #MaSearchStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaRepositoryRequest subclass: #MaWriteRequest
	instanceVariableNames: 'package '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!
MaObject subclass: #MagmaClientConnection
	instanceVariableNames: 'sessionId userId maximumNumberOfChallengers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!
MaObject subclass: #MagmaCollection
	instanceVariableNames: 'indexes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaObject subclass: #MagmaCollectionReader
	instanceVariableNames: 'collection absoluteLowIndex absoluteHighIndex readStrategy index '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Large collections'!
MaObject subclass: #MagmaCommitConflict
	instanceVariableNames: 'connection conflictingOids conflictingObjects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!
MaObject subclass: #MagmaPreferences
	instanceVariableNames: 'refreshPersistentObjectsEvenWhenChangedOnlyByMe '
	classVariableNames: 'DebugProxies '
	poolDictionaries: ''
	category: 'Magma-Client'!
MaObject subclass: #MagmaSession
	instanceVariableNames: 'id serializer transaction facade readStrategy largeCollections preferences '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client'!
MaSoftwareError subclass: #MagmaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Exceptions'!
MaUserError subclass: #MagmaUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Exceptions'!
MagmaUserError subclass: #MagmaClassConflictNotification
	instanceVariableNames: 'conflictingDefinitions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Exceptions'!

!MaOdbmsProxy methodsFor: 'testing'!
= object

	object maIsBufferedObjectProxy ifTrue: [ ^super = object ].
	^self mutant = object
! !

!MaOdbmsProxy methodsFor: 'creation'!
copy

	^self mutant copy
! !

!MaOdbmsProxy methodsFor: 'private accessing' stamp: 'cmm 2/26/2002 22:50'!
mutant

	^self session realObjectFor: self oid
! !

!MaOdbmsProxy methodsFor: 'private accessing'!
session

	^session! !

!MaOdbmsProxy methodsFor: 'printing' stamp: 'cmm 7/16/2002 00:21'!
printOn: aStream

	MagmaPreferences debugProxys
		ifTrue:
			[ super printOn: aStream ]
		ifFalse:
			[ self mutant printOn: aStream ]
! !

!MaOdbmsProxy methodsFor: 'private building'!
session: aMagmaSession

	session _ aMagmaSession
! !

!MaOdbmsProxy methodsFor: 'commenting' stamp: 'cmm 5/28/2002 00:36'!
identityHash

	^self mutant identityHash
! !

!MaOdbmsProxy methodsFor: 'commenting'!
whyNoHash

	"Because we don't want to allow the receiver to ever be added to a hashed
	collection.  We want it to mutate and then be added, otherwise we'd have to
	know which hashed collections to rehash once the receiver was mutated."
! !


!Object methodsFor: 'events' stamp: 'cmm 5/13/2002 22:28'!
maPostmaterialize
	"This method is called just after the receiver has been materialized from a Magma repository into the local image.  Overriding this may be useful for resetting transient instance variables."! !

!Object methodsFor: 'events' stamp: 'cmm 5/13/2002 00:09'!
maPreserialize
	"This method is called just before the receiver is serialized for its journey into a Magma repository.  Overriding this method may be useful for making some variables transient."! !

!Object methodsFor: 'testing' stamp: 'cmm 7/16/2002 22:15'!
maIsChangedFrom: anotherObject

	^((1 to: self maInstSize)
		maConform: [ :index | (self instVarAt: index) == (anotherObject instVarAt: index) ]) not ! !

!Object methodsFor: 'testing' stamp: 'cmm 2/15/2002 00:02'!
maIsException

	^false
! !

!Object methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:46'!
maIsImmutable

	^self maIsImmutableInBuffer or: [ self maInstSize = 0 ]
! !

!Object methodsFor: 'testing'!
maIsLargeCollection

	^false
! !

!Object methodsFor: 'building' stamp: 'cmm 3/4/2002 00:18'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession
	"If this implementation changes, be sure to check the implementation in
	Interval.  It will most likely need to change as well."

	1
		to: self maInstSize
		do:
			[ :instVarIndex | | oid |
			self
				instVarAt: instVarIndex
				put: (
					aMagmaSession serializer
						objectWithOid: (oid _ aMaObjectLinkDescription linkedOids at: instVarIndex)
						ifAbsent: [ aMagmaSession serializer proxyFor: oid ]) ]
! !

!Object methodsFor: 'building'!
maRestoreFrom: anObject
	"If this implementation changes, be sure to check the implementation in
	Interval.  It will most likely need to change as well."

	1
		to: self maInstSize
		do:
			[ :instVarIndex |
			self
				instVarAt: instVarIndex
				put: (anObject instVarAt: instVarIndex) ]
! !


!Collection methodsFor: 'building' stamp: 'cmm 7/9/2002 23:12'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession

	self maMarked: 'performance'.
	"The most common methods to send to a collection are one of the enumeration methods.
	So if there are a lot of proxies added here, and then we enumerate, they will be
	materialized one at a time.

	Two possible solutions are: 
		1) when any new Collection is committed, have the server add it to the payload of the RefreshViewResult of every other client, not as challengers, obviously, but as additional refreshed.
		2) the philosophical problem w/ #1 is that it adds cost without potential gain, e.g., if the new collection is not enumerated.  So, instead, create a new server request that can get the objects for multiple oids all in one call.  Sounds good, but we can't do that here in this method.  How do we know, when we materialize a proxy, that it is referenced by a collection that may reference other proxies..  Hmm, maybe #1 is the best solution after all.."

	self removeAll: self copy.
	aMaObjectLinkDescription linkedOids do:
		[ :each |
		self add: (
			aMagmaSession serializer
				objectWithOid: each
				ifAbsent: [ aMagmaSession serializer proxyFor: each ]) ]
! !

!Collection methodsFor: 'building' stamp: 'cmm 5/29/2002 00:41'!
maRestoreFrom: aCollection

	self removeAll: self copy.
	aCollection do: [ :each | self add: each ]
! !


!Bag methodsFor: 'testing'!
maIsChangedFrom: anotherCollection

	^(self maConsistsOf: anotherCollection) not
! !

!Bag methodsFor: 'testing' stamp: 'cmm 7/9/2002 00:16'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession

	| hasProxies aUniqueObject |
	aUniqueObject _ ''.
	hasProxies _ aMaObjectLinkDescription linkedOids maIncludesWhere:
		[ :eachOid |
		(aMagmaSession serializer
			objectWithOid: eachOid
			ifAbsent: [ aUniqueObject ]) == aUniqueObject ].
	hasProxies
		ifTrue:
			[ aMagmaSession readStrategy: (MaBasicReadStrategy minimumDepth: 2).
			aMagmaSession realObjectFor: (aMagmaSession oidFor: self) ].
	self removeAll: self copy.
	aMaObjectLinkDescription linkedOids do:
		[ :each |
		self add: (
			aMagmaSession serializer
				objectWithOid: each
				ifAbsent: [ aMagmaSession realObjectFor: each ]) ]
! !


!Exception methodsFor: 'exceptionDescription' stamp: 'cmm 7/8/2002 14:23'!
maPreserialize

	super maPreserialize.
	initialContext _ nil.
	handlerContext _ nil.
	activeHandler _ nil! !


!Float methodsFor: 'Magma' stamp: 'cmm 7/11/2002 00:29'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession
	"Never try to refresh a Float.  They cannot change."! !


!LargePositiveInteger methodsFor: 'testing'!
maIsImmutable

	^true
! !


!MaBasicReadStrategy methodsFor: 'accessing'!
depthOfAttribute: attributeIndex onClassWithId: classId
	"The only chance of this being anything but 0 is if the System has
	an entry for classId.  If it doesn't, it'll return 0 as well."

	^SystemReadStrategy
		depthOfAttribute: attributeIndex
		onClassWithId: classId
! !

!MaBasicReadStrategy methodsFor: 'accessing'!
minimumDepth

	^minimumDepth
! !

!MaBasicReadStrategy methodsFor: 'building'!
makeReadyForUseUsing: aMaClassIdManager
	"No preparation necessary for a MaBasicReadStrategy."
! !

!MaBasicReadStrategy methodsFor: 'building'!
minimumDepth: anInteger

	minimumDepth _ anInteger
! !


!MaBasicReadStrategy class methodsFor: 'creation'!
deep

	^self minimumDepth: 99999
! !

!MaBasicReadStrategy class methodsFor: 'creation'!
default

	^Default! !

!MaBasicReadStrategy class methodsFor: 'creation'!
minimumDepth: anInteger

	^self new minimumDepth: anInteger
! !

!MaBasicReadStrategy class methodsFor: 'initializing'!
initialize

	SystemReadStrategy _ MaReadStrategy new.
	Default _ self minimumDepth: 3
! !

!MaBasicReadStrategy class methodsFor: 'initializing' stamp: 'cmm 5/29/2002 23:08'!
initializeSystemReadStrategyUsing: aMaDefaultClassIdManager

	SystemReadStrategy _ MaReadStrategy new.
	SystemReadStrategy
		readToDepth: 99999
		for: CompiledMethod;

		readToDepth: 99999
		for: BlockContext;

		readToDepth: 99999
		for: MaOdbmsClassDefinition;

		readToDepth: 3
		for: Dictionary;

		readToDepth: 3
		for: IdentityDictionary;

		readToDepth: 3
		for: Set;

		readToDepth: 3
		for: IdentitySet;

		readToDepth: 4
		for: Bag;

		readToDepth: 4
		for: IdentityBag;

		readToDepth: 3
		for: OrderedCollection;

		readToDepth: 2
		for: Array.

	SystemReadStrategy makeReadyForUseUsing: aMaDefaultClassIdManager
! !


!MaChangedKeySpecification methodsFor: 'accessing'!
attribute

	^attribute! !

!MaChangedKeySpecification methodsFor: 'accessing'!
newHashValue

	^newHashValue! !

!MaChangedKeySpecification methodsFor: 'accessing'!
object

	^object! !

!MaChangedKeySpecification methodsFor: 'accessing'!
oid

	^object
! !

!MaChangedKeySpecification methodsFor: 'accessing'!
oldHashValue

	^oldHashValue! !

!MaChangedKeySpecification methodsFor: 'private building'!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaChangedKeySpecification methodsFor: 'private building'!
newHashValue: anInteger

	newHashValue _ anInteger
! !

!MaChangedKeySpecification methodsFor: 'private building'!
object: anObject

	object _ anObject
! !

!MaChangedKeySpecification methodsFor: 'private building'!
oldHashValue: anInteger

	oldHashValue _ anInteger
! !

!MaChangedKeySpecification methodsFor: 'building'!
serializeUsing: aMaObjectSerializer

	object _ (aMaObjectSerializer oidFor: object)
! !


!MaChangedKeySpecification class methodsFor: 'creation'!
object: anObject attribute: aSymbol oldHashValue: oldHashValueInteger newHashValue: newHashValueInteger

	^self new
		object: anObject;
		attribute: aSymbol;
		oldHashValue: oldHashValueInteger;
		newHashValue: newHashValueInteger
! !


!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:40'!
at: anInteger

	^objects at: anInteger - startIndex + 1
! !

!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:40'!
firstCachedElement

	^objects first
! !

!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:40'!
lastCachedElement

	^objects last
! !

!MaCollectionSegment methodsFor: 'accessing'!
lastKnownSize

	^lastKnownSize! !

!MaCollectionSegment methodsFor: 'accessing'!
objects

	^objects! !

!MaCollectionSegment methodsFor: 'accessing'!
pageSize

	^pageSize! !

!MaCollectionSegment methodsFor: 'accessing'!
startIndex

	^startIndex! !

!MaCollectionSegment methodsFor: 'accessing'!
startingPageIndexFor: anInteger
	"Obtain objects on either side of anInteger to facilitate fast backward scrolling."

	^(anInteger - (pageSize // 2)) max: 1
! !

!MaCollectionSegment methodsFor: 'building'!
lastKnownSize: anInteger

	lastKnownSize _ anInteger
! !

!MaCollectionSegment methodsFor: 'building'!
loadFrom: aMaSegmentRequestResult

	self
		startIndex: aMaSegmentRequestResult startIndex;
		lastKnownSize: aMaSegmentRequestResult lastKnownSize;
		objects: aMaSegmentRequestResult objects
! !

!MaCollectionSegment methodsFor: 'building'!
objects: aCollection

	objects _ aCollection
! !

!MaCollectionSegment methodsFor: 'building'!
pageSize: anInteger

	pageSize _ anInteger
! !

!MaCollectionSegment methodsFor: 'building'!
startIndex: anObject

	startIndex _ anObject
! !

!MaCollectionSegment methodsFor: 'testing'!
includes: anObject

	^objects includes: anObject
! !

!MaCollectionSegment methodsFor: 'testing'!
includesIndex: anInteger

	self isLoaded ifFalse: [ ^false ].
	^anInteger
		between: self low
		and: self high
! !

!MaCollectionSegment methodsFor: 'testing' stamp: 'cmm 7/8/2002 12:40'!
isEmpty

	^objects isEmpty
! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 7/8/2002 12:40'!
high
	"Answer the index within the large-collection or reader of the last element
	in the receivers objects collection."

	^startIndex + objects size - 1
! !

!MaCollectionSegment methodsFor: 'private'!
initializeCollection

	self objects: (OrderedCollection new: pageSize + 25)
! !

!MaCollectionSegment methodsFor: 'private'!
isLoaded

	^startIndex notNil
! !

!MaCollectionSegment methodsFor: 'private'!
low

	^startIndex
! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 7/8/2002 12:38'!
remoteHigh
	"Answer the highest index not accounting for any merged changes.."

	^startIndex + (pageSize min: objects size) - 1! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 7/7/2002 22:07'!
reset

	startIndex _ nil! !


!MaCollectionSegment class methodsFor: 'private accessing'!
defaultPageSize

	^250
! !

!MaCollectionSegment class methodsFor: 'creation'!
new: anInteger

	^self new
		pageSize: anInteger;
		initializeCollection
! !


!MaCommitPackage methodsFor: 'building'!
addLargeCollectionChanges: aMaLargeCollectionChanges using: aMagmaSession

	allLargeCollectionChanges isNil ifTrue: [ allLargeCollectionChanges _ Set new ].
	allLargeCollectionChanges add: aMaLargeCollectionChanges copyForSerialization.
	"Make sure we get new objects that may only be referenced by a LargeCollection."
	self
		addNewAdditionsIn: aMaLargeCollectionChanges
		using: aMagmaSession
! !

!MaCommitPackage methodsFor: 'building'!
addObject: anObject

	^objects add: anObject
! !

!MaCommitPackage methodsFor: 'building'!
addUnchangedObject: anObject
	"Used to detect dirty reads.  Any object which was read by the client
	session, but not changed, may not be changed by any other session
	while this session was in a transaction if the application attempts to
	commit 'clean'."

	^readSet add: anObject
! !

!MaCommitPackage methodsFor: 'building'!
allLargeCollectionChanges: aSet

	allLargeCollectionChanges _ aSet
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 5/29/2002 00:05'!
serializeObjectsUsing: aMagmaSession
	"Serialize all objects into MaSerializedObjectGraph's since
	the server does not deal with objects, just their graph buffers."

	| mustReserialize serializer numberOfClassesBefore |

	serializer _ aMagmaSession serializer.
	numberOfClassesBefore _ serializer classIdManager numberOfClasses.
	mustReserialize _ false.
	objects _
		serializer
			serializeGraph: objects
			do:
				[ :each |
				each maPreserialize.
				"Look for any newly created LargeCollections.."
				each maIsLargeCollection
					ifTrue:
						[ (aMagmaSession imageDefinitionIncludesLargeCollection: each)
							ifFalse:
								[ mustReserialize _ true.
								aMagmaSession addLargeCollection: each ] ] ].
	self serializeLargeCollectionsChangesUsingCopyOf: serializer.
	^mustReserialize or: [ serializer classIdManager numberOfClasses > numberOfClassesBefore ]
! !

!MaCommitPackage methodsFor: 'private building'!
addNewAdditionsIn: aMaLargeCollectionChanges using: aMagmaSession

	aMaLargeCollectionChanges additionsDo:
		[ :eachObject :eachHashIndexValues |
		(aMagmaSession isPersistent: eachObject) ifFalse: [ self addObject: eachObject ] ]
! !

!MaCommitPackage methodsFor: 'private building' stamp: 'cmm 5/29/2002 00:07'!
serializeLargeCollectionsChangesUsingCopyOf: aMaObjectSerializer
	"The objects are serialized, now serialize the allLargeCollectionChanges of
	the receiver."

	| copiedSerializer |
	copiedSerializer _ nil.
	self allLargeCollectionChangesDo:
		[ :eachChanges | 
		copiedSerializer isNil ifTrue: [ copiedSerializer _ aMaObjectSerializer copyWithNewBuffer ].
		eachChanges serializeUsing: copiedSerializer ]
! !

!MaCommitPackage methodsFor: 'private building' stamp: 'cmm 4/21/2002 23:11'!
setSize: anInteger

	objects _ IdentitySet new: anInteger
! !

!MaCommitPackage methodsFor: 'accessing'!
allLargeCollectionChanges
	"a Set of MaLargeCollectionChanges"

	^allLargeCollectionChanges
! !

!MaCommitPackage methodsFor: 'accessing'!
objects

	^objects! !

!MaCommitPackage methodsFor: 'private actions'!
allLargeCollectionChangesDo: aBlock

	allLargeCollectionChanges isNil ifTrue: [ ^self ].
	allLargeCollectionChanges do: aBlock
! !

!MaCommitPackage methodsFor: 'creation'!
copyWithNewLargeCollectionChanges

	^self copy
		allLargeCollectionChanges: (self allLargeCollectionChanges collect: [ :each | each copy ])
! !

!MaCommitPackage methodsFor: 'actions'!
hasNewIndexes
	"Don't use conform: or detect: because it forces creation of a collection for
	the new indexes."

	self
		allLargeCollectionChangesDo: [ :eachChanges | eachChanges hasAddedIndexes ifTrue: [ ^true ] ].
	^false
! !

!MaCommitPackage methodsFor: 'actions'!
newIndexesDo: twoArgBlock
	"For all largeCollections that have had one or more indexes added on this
	transaction, evaluate twoArgBlock.  The first argument is collection (or oid of
	the colection if the receiver has serialized itself, the second is a collection of
	the indexes."

	self allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges hasAddedIndexes
			ifTrue:
				[ twoArgBlock
					value: eachChanges collection
					value: eachChanges addedIndexes ] ]
! !

!MaCommitPackage methodsFor: 'actions'!
newObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifTrue: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'actions'!
objectsDo: aBlock

	objects maIsCollection
		ifTrue:
			[ objects do: aBlock ]
		ifFalse:
			[ | isRootBuffer |
			"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
			isRootBuffer _ true.
			objects buffersDo:
				[ :each |
				isRootBuffer ifTrue: [ isRootBuffer _ false ] ifFalse: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'actions'!
persistentObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifFalse: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'actions' stamp: 'cmm 7/8/2002 13:38'!
readObjectsDo: aBlock

	readSet do: aBlock
! !

!MaCommitPackage methodsFor: 'testing'!
shouldCheckForDirtyReads

	^readSet maNotEmpty
! !

!MaCommitPackage methodsFor: 'testing'!
shouldServerRefresh
	"Anytime a largeCollection domain object changes, the server should
	refresh so we process all of the new large collections or their new
	indexes."

	self allLargeCollectionChanges isNil ifTrue: [ ^false ].
	^self allLargeCollectionChanges maIncludesWhere: [ :each | each requiresServerRefresh ]
! !


!MaCommitPackage class methodsFor: 'creation'!
new
	"Don't have unnecessarily large physicalSize.  Keep the work on the client."

	^self new: 8
! !

!MaCommitPackage class methodsFor: 'creation'!
new: anInteger

	^super new setSize: anInteger
! !


!MaDefaultClassIdManager methodsFor: 'accessing'!
numberOfClasses

	^self classesById size
! !


!MaDefaultOidManager methodsFor: 'building'!
permanentLoidFor: oldOid is: newOid

	| object |

	object _ (self
		objectWithOid: oldOid
		ifAbsent: [ ^nil ]).
	self clean: oldOid.
	self
		oidOf: object
		is: newOid.
	object maIsLargeCollection ifTrue: [ object setLoid: newOid ]
! !


!MaIndexDefinition methodsFor: 'accessing'!
attribute
	"the accessor symbol for any kind of object that has this attribute.
	These are used to determine what whether the receiver is appropriate to restrict
	or sort a Query."

	^attribute
! !

!MaIndexDefinition methodsFor: 'accessing'!
keySize

	^64
! !

!MaIndexDefinition methodsFor: 'accessing'!
recordSize

	^30
! !

!MaIndexDefinition methodsFor: 'accessing'!
sortBlock

	^[ :a :b | (self indexHashFor: a) < (self indexHashFor: b) ]
! !

!MaIndexDefinition methodsFor: 'private building'!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaIndexDefinition methodsFor: 'testing'!
canIndex: anObject

	^anObject respondsTo: attribute
! !

!MaIndexDefinition methodsFor: 'private accessing'!
highestPossibleKey

	^(2 raisedTo: self keySize) - 1
! !

!MaIndexDefinition methodsFor: 'private accessing'!
indexHashFor: anObject 
	"Answer an Integer or Array of Integers that will be used to locate the receiver."

	self validateCanIndex: anObject.
	^self indexHashForIndexObject: (self indexObjectFor: anObject)
! !

!MaIndexDefinition methodsFor: 'private accessing'!
indexHashForIndexObject: anObject

	^anObject maIndexHash
! !

!MaIndexDefinition methodsFor: 'private accessing'!
indexObjectFor: anObject

	^anObject perform: attribute
! !

!MaIndexDefinition methodsFor: 'private accessing'!
uniqueFileIdentifier

	^self attribute
! !

!MaIndexDefinition methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self attribute
! !

!MaIndexDefinition methodsFor: 'actions' stamp: 'cmm 5/1/2002 23:12'!
validateCanIndex: anObject

	(self canIndex: anObject)
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate the hashIndexFor: ' , anObject printString ]
! !


!MaIndexDefinition class methodsFor: 'creation'!
attribute: aSymbol

	^self new attribute: aSymbol
! !


!MaIndexedCollectionSegment methodsFor: 'accessing'!
highKey

	^highKey! !

!MaIndexedCollectionSegment methodsFor: 'accessing'!
lowKey

	^lowKey! !

!MaIndexedCollectionSegment methodsFor: 'building'!
highKey: anInteger

	highKey _ anInteger
! !

!MaIndexedCollectionSegment methodsFor: 'building'!
loadFrom: aMaSegmentRequestResult

	super loadFrom: aMaSegmentRequestResult.
	self
		lowKey: aMaSegmentRequestResult lowKey;
		highKey: aMaSegmentRequestResult highKey
! !

!MaIndexedCollectionSegment methodsFor: 'building'!
lowKey: anInteger

	lowKey _ anInteger
! !

!MaIndexedCollectionSegment methodsFor: 'building' stamp: 'cmm 7/8/2002 12:41'!
merge: aCollection using: aMaIndexDefinition

	aCollection do:
		[ :each |
		((aMaIndexDefinition indexHashFor: each)
			between: self lowKey
			and: self highKey)
				ifTrue:
					[ objects add: each ] ]
! !


!MaIndexedCollectionSegment class methodsFor: 'creation'!
sortBlock: twoArgBlock

	^(self new: self defaultPageSize)
		objects: ((SortedCollection new: self defaultPageSize) sortBlock: twoArgBlock)
! !


!MaLargeCollectionChanges methodsFor: 'building'!
add: anObject at: hashIndexesCollection

	| removed |

	((removed _ self removed) includesKey: anObject)
		ifTrue:
			[ removed removeKey: anObject ]
		ifFalse:
			[ self added
				at: anObject
				put: hashIndexesCollection ]
! !

!MaLargeCollectionChanges methodsFor: 'building'!
add: anObject at: indexHashValueInteger toIndexForAttribute: aSymbol

	(self newIndexValues
		at: aSymbol
		ifAbsentPut: [ OrderedCollection new ])
			add: (
				Association
					key: indexHashValueInteger
					value: anObject)
! !

!MaLargeCollectionChanges methodsFor: 'building'!
addIndex: aMaIndexDefinition

	self hasRemovedIndexes
		ifTrue:
			[ (self removedIndexes includes: aMaIndexDefinition attribute)
				ifTrue:
					[ self removedIndexes remove: aMaIndexDefinition attribute ]
				ifFalse:
					[ self addedIndexes add: aMaIndexDefinition ] ]
		ifFalse:
			[ self addedIndexes add: aMaIndexDefinition ].
	self appendIndexValuesFor: aMaIndexDefinition
! !

!MaLargeCollectionChanges methodsFor: 'building'!
beNewCollection

	isNewCollection _ true
! !

!MaLargeCollectionChanges methodsFor: 'building'!
collection: aMagmaCollection

	self
		maVirtualInstVarNamed: #collection
		put: aMagmaCollection
! !

!MaLargeCollectionChanges methodsFor: 'building'!
collectionLoid: anInteger

	collectionLoid _ anInteger
! !

!MaLargeCollectionChanges methodsFor: 'building'!
move: anObject from: oldHashValue to: newHashValue forIndexedAttribute: aSymbol

	(self changedKeys
		at: aSymbol
		ifAbsentPut: [ Set new ])
			add: (
				MaChangedKeySpecification
					object: anObject
					attribute: aSymbol
					oldHashValue: oldHashValue
					newHashValue: newHashValue)
! !

!MaLargeCollectionChanges methodsFor: 'building'!
remove: anObject at: hashIndexesCollection

	| added |

	((added _ self added) includesKey: anObject)
		ifTrue:
			[ added removeKey: anObject ]
		ifFalse:
			[ self removed
				at: anObject
				put: hashIndexesCollection ]
! !

!MaLargeCollectionChanges methodsFor: 'building' stamp: 'cmm 5/1/2002 23:09'!
removeIndexOn: attributeSymbol

	self removeIndexValuesFor: (self collection indexNamed: attributeSymbol).
	(self hasAddedIndexes
		and: [ self addedIndexes maIncludesWhere: [ :each | each attribute = attributeSymbol ] ])
			ifTrue:
				[ self addedIndexes
					remove: (self addedIndexes 
						detect: [ :each | each attribute = attributeSymbol ]
						ifNone: [ MagmaSoftwareError signal: 'Apparent bug in MaLargeCollectionChanges>>removeIndexOn:' ]) ]
			ifFalse:
				[ self removedIndexes add: attributeSymbol ]
! !

!MaLargeCollectionChanges methodsFor: 'building'!
serializeUsing: aMaObjectSerializer

	self
		serializeAddedUsing: aMaObjectSerializer;
		serializeRemovedUsing: aMaObjectSerializer;
		serializeNewIndexValuesUsing: aMaObjectSerializer;
		serializeChangedIndexValuesUsing: aMaObjectSerializer;
		serializeChangedKeysUsing: aMaObjectSerializer
! !

!MaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
added
	"On the client, answers an IdentityDictionary whose key is the object to be added,
	value is a collection of its calculated hashIndex values.
	On the server, the key is the oid of the object, not the object itself."

	^changes
		at: #added
		ifAbsentPut: [ IdentityDictionary new ]
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
addedIndexes

	^changes
		at: #addedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
changedKeys
	"answer a dictionary of Sets.  attribute -> (aMaChangedKeySpecification...)"

	^changes
		at: #changedKeys
		ifAbsentPut: [ Dictionary new ]
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
collection

	^self maVirtualInstVarNamed: #collection
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
collectionLoid

	^collectionLoid
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
deltaSize

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo: [ :eachObject :eachHashIndexValues | numberAdded _ numberAdded + 1 ].
	numberRemoved _ 0.
	self removedDo: [ :eachObject :eachHashIndexValues | numberRemoved _ numberRemoved + 1 ].
	^numberAdded - numberRemoved
! !

!MaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
newIndexValues
	"A dictionary of Dictionarys, (attribute Symbol -> (key->oid)...) used to
	populate all new indexes being built in this transaction."

	^changes
		at: #newIndexValues
		ifAbsentPut: [ Dictionary new ]
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
occurrencesOf: anObject

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberAdded _ numberAdded + 1 ] ].
	numberRemoved _ 0.
	self removedDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberRemoved _ numberRemoved + 1 ] ].
	^numberAdded - numberRemoved
! !

!MaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
removed

	^changes
		at: #removed
		ifAbsentPut: [ IdentityDictionary new ]
! !

!MaLargeCollectionChanges methodsFor: 'accessing'!
removedIndexes

	^changes
		at: #removedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
addedIndexesDo: oneArgBlock

	self hasAddedIndexes ifFalse: [ ^self ].
	self addedIndexes do: oneArgBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
additionsDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasAdditions ifFalse: [ ^self ].
	self added keysAndValuesDo: twoArgBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
changedKeySpecificationsDo: oneArgBlock

	self hasChangedKeys ifFalse: [ ^self ].
	self changedKeys do: oneArgBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
newIndexValuesDo: aBlock

	self hasNewIndexValues ifFalse: [ ^self ].
	self newIndexValues do: aBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
removedDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasRemoved ifFalse: [ ^self ].
	self removed keysAndValuesDo: twoArgBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
removedIndexesDo: oneArgBlock

	self hasRemovedIndexes ifFalse: [ ^self ].
	self removedIndexes do: oneArgBlock
! !

!MaLargeCollectionChanges methodsFor: 'actions'!
reset

	self initialize
! !

!MaLargeCollectionChanges methodsFor: 'private building'!
appendIndexValuesFor: aMaIndexDefinition
	"An index has been added.  Now we need to make sure we add
	the hash index values to the objects that have already been added
	to the receiver."

	self additionsDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashFor: eachObject) ].
	self removedDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashFor: eachObject) ]
! !

!MaLargeCollectionChanges methodsFor: 'private building'!
changes: aDictionary

	changes _ aDictionary
! !

!MaLargeCollectionChanges methodsFor: 'private building' stamp: 'cmm 7/3/2002 00:13'!
removeIndexValuesFor: aMaIndexDefinition
	"An index is being removed.  We need to make sure we remove
	the hash index values to the objects that have already been added or
	removed from the receiver."

	| position |

	position _ self collection indexes indexOf: aMaIndexDefinition.
	self additionsDo: [ :eachObject :eachCollection | eachCollection removeAt: position ].
	self removedDo: [ :eachObject :eachCollection | eachCollection removeAt: position ]
! !

!MaLargeCollectionChanges methodsFor: 'private building'!
serializeAddedUsing: aMaObjectSerializer

	| added |

	self hasAdditions ifFalse: [ ^self ].
	(added _ self added) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		added
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]
! !

!MaLargeCollectionChanges methodsFor: 'private building'!
serializeNewIndexValuesUsing: aMaObjectSerializer

	self newIndexValuesDo:
		[ :eachValues |
		eachValues do:
			[ :eachAssociation |
			eachAssociation value: (aMaObjectSerializer oidFor: eachAssociation value) ] ]
! !

!MaLargeCollectionChanges methodsFor: 'private building'!
serializeRemovedUsing: aMaObjectSerializer

	| removed |

	self hasRemoved ifFalse: [ ^self ].
	(removed _ self removed) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		removed
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]
! !

!MaLargeCollectionChanges methodsFor: 'creation'!
copy

	^super copy collection: self collection
! !

!MaLargeCollectionChanges methodsFor: 'creation'!
copyForSerialization

	| newChanges |

	newChanges _ changes class new.
	changes keysAndValuesDo:
		[ :eachKey :eachValue |
		newChanges
			at: eachKey
			put: eachValue copy ].
	^self copy changes: newChanges
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasAddedIndexes

	^(changes includesKey: #addedIndexes) and: [ self addedIndexes notEmpty ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasAdditions

	^(changes includesKey: #added) and: [ self added notEmpty ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasChangedKeys

	^(changes includesKey: #changedKeys) and: [ self changedKeys notEmpty ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasChanges

	^isNewCollection or: [ changes maIncludesWhere: [ :each | each notEmpty ] ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasRemoved

	^(changes includesKey: #removed) and: [ self removed notEmpty ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
hasRemovedIndexes

	^(changes includesKey: #removedIndexes) and: [ self removedIndexes notEmpty ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
includes: anObject

	^self hasAdditions ifTrue: [ self added includesKey: anObject ] ifFalse: [ false ]
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
isNewCollection

	^isNewCollection
! !

!MaLargeCollectionChanges methodsFor: 'testing'!
requiresServerRefresh

	^self hasAddedIndexes or: [ self hasRemovedIndexes or: [ self isNewCollection ] ]
! !

!MaLargeCollectionChanges methodsFor: 'private testing'!
hasNewIndexValues

	^changes includesKey: #newIndexValues
! !

!MaLargeCollectionChanges methodsFor: 'private initializing'!
initialize

	super initialize.
	changes _ Dictionary new.
	isNewCollection _ false
! !

!MaLargeCollectionChanges methodsFor: 'private actions'!
serializeChangedIndexValuesUsing: aMaObjectSerializer

	self changedKeySpecificationsDo:
		[ :eachSet |
		eachSet do: [ :eachChangedKeySpec | eachChangedKeySpec serializeUsing: aMaObjectSerializer ] ]
! !

!MaLargeCollectionChanges methodsFor: 'private actions'!
serializeChangedKeysUsing: aMaObjectSerializer

	self changedKeySpecificationsDo:
		[ :eachValues |
		eachValues keysAndValuesDo:
			[ :eachHashIndex :eachObject |
			eachValues
				at: eachHashIndex
				put: (aMaObjectSerializer oidFor: eachObject) ] ]
! !


!MaLargeCollectionChanges class methodsFor: 'creation'!
collection: aMagmaCollection

	^self new collection: aMagmaCollection
! !

!MaLargeCollectionChanges class methodsFor: 'private creation'!
removing

	self undefineAllVirtualInstVars
! !


!MaLocalServerLink methodsFor: 'private' stamp: 'cmm 4/23/2002 23:59'!
getRepositoryController

	^localRequestServer getRepositoryController
! !


!MaObjectLinkDescription methodsFor: 'accessing'!
mainOid

	^mainOid! !

!MaObjectLinkDescription methodsFor: 'private building'!
mainOid: anInteger

	mainOid _ anInteger
! !

!MaObjectLinkDescription methodsFor: 'printing' stamp: 'cmm 2/27/2002 22:09'!
printOn: aStream

	super printOn: aStream.
	aStream 
		space;
		maPrint: self mainOid
! !


!MaByteObjectLinkDescription methodsFor: 'accessing'!
bytes

	^bytes! !

!MaByteObjectLinkDescription methodsFor: 'building'!
bytes: aStringOrByteArray

	bytes _ aStringOrByteArray
! !


!MaFirstClassObjectLinkDescription methodsFor: 'building'!
addLink: oidInteger

	linkedOids add: oidInteger
! !

!MaFirstClassObjectLinkDescription methodsFor: 'private initializing'!
initialize

	super initialize.
	linkedOids _ OrderedCollection new
! !

!MaFirstClassObjectLinkDescription methodsFor: 'accessing'!
linkedOids

	^linkedOids! !


!MaObjectLinkDescription class methodsFor: 'creation'!
mainOid: anInteger

	^self new mainOid: anInteger
! !


!MaObjectSerializer methodsFor: 'accessing'!
classesSetOid

	^self oidFor: self classIdManager classesSet
! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 5/30/2002 08:33'!
materializeAllClassDefinitions

	self classIdManager materializeAllClassDefinitions! !

!MaObjectSerializer methodsFor: 'magma'!
assignPermenantLoidsFrom: aDictionary
	"aDictionary (oldOid -> newOid)."

	aDictionary keysAndValuesDo:
		[ :eachTemp :eachPerm |
		self oidManager
			permanentLoidFor: eachTemp
			is: eachPerm ]
! !

!MaObjectSerializer methodsFor: 'building'!
classesSet: aSet

	self classIdManager classesSet: aSet
! !


!MaOdbmsClassDefinition methodsFor: 'converting'!
asSimpleStorage

	^MaStorageForClass
		class: self classObject
		id: self id
! !

!MaOdbmsClassDefinition methodsFor: 'private building' stamp: 'cmm 7/18/2002 00:04'!
buildFrom: aClass

	self globalName: aClass name.
	instVarNames _ aClass maAllInstVarNames
! !

!MaOdbmsClassDefinition methodsFor: 'testing' stamp: 'cmm 7/18/2002 00:03'!
hasSameDefinitionAs: aClass

	self className = aClass name ifFalse: [ ^false ].
	(self maAllInstVarNames maMatchesElementsOf: aClass maAllInstVarNames) ifFalse: [ ^false ].
	^true
! !

!MaOdbmsClassDefinition methodsFor: 'private initializing'!
initialize

	super initialize.
	self version: 1
! !

!MaOdbmsClassDefinition methodsFor: 'accessing'!
maAllInstVarNames
	^instVarNames! !

!MaOdbmsClassDefinition methodsFor: 'accessing'!
namedInstSize
	^self maAllInstVarNames size! !

!MaOdbmsClassDefinition methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:11'!
upgradeBlock

	self maMarked: 'bug'.
	"Big bug!!  The upgrade block will most likely reference a class that is not part of the server image.  This will prevent the server from even being able to open the repository, just because someone upgraded a class.  Rats!!  This has to be fixed once we're in VI4.."
	^upgradeBlock! !

!MaOdbmsClassDefinition methodsFor: 'accessing'!
version

	^version! !

!MaOdbmsClassDefinition methodsFor: 'creation'!
newForNextVersion

	^(self class
		className: self className
		id: self id)
			version: self version + 1
! !

!MaOdbmsClassDefinition methodsFor: 'building'!
upgradeBlock: twoArgBlock

	upgradeBlock _ twoArgBlock
! !

!MaOdbmsClassDefinition methodsFor: 'building'!
version: anInteger

	version _ anInteger
! !


!MaOdbmsClassDefinition class methodsFor: 'creation' stamp: 'cmm 1/24/2002 14:17'!
className: aSymbol id: anInteger

	^(super
		className: aSymbol
		id: anInteger)
			buildFrom: (Smalltalk classNamed: aSymbol)
! !


!MaOdbmsClassIdManager methodsFor: 'private building'!
addNewClass: aClass withId: anInteger

	classesSet add: aClass.
	^super
		addNewClass: aClass
		withId: anInteger
! !

!MaOdbmsClassIdManager methodsFor: 'private building' stamp: 'cmm 3/27/2002 23:10'!
classStorageClass

	^MaOdbmsClassDefinition
! !

!MaOdbmsClassIdManager methodsFor: 'private building'!
initialize

	super initialize.
	classesSet _ Set new
! !

!MaOdbmsClassIdManager methodsFor: 'accessing'!
classesSet
	"A Set of all classes known by the receiver.  Any not defined in
	this Smalltalk image (which will happen on the server, the domain classes
	won't be there) will be represented as a MaStorageForClass."

	^classesSet
! !

!MaOdbmsClassIdManager methodsFor: 'building'!
classesSet: aSet

	classesSet _ aSet
! !

!MaOdbmsClassIdManager methodsFor: 'special-case' stamp: 'cmm 5/30/2002 23:17'!
materializeAllClassDefinitions
	"Why are we doing this?  When another user adds the first instance of a new class to the repository, its definition is recorded in this dictionary.  When this client refreshes, it can only possibly get a proxy to the new definition.  This results in a problem with the very next database read, because to materialize any objects, the classDefinitions have to be checked, forcing a materialization of the proxy.  This inner-materialization is not allowed because it disrupts our single ObjectSerializer."

	self classDefinitionsById do: [ :each | each size ]
! !


!MaOdbmsClassIdManager class methodsFor: 'initializing' stamp: 'cmm 7/16/2002 21:50'!
initialize
	"Called from postscript."

	MaDefaultClassIdManager initialize.
	self minimumClasses: (superclass minimumClasses copyWith: MaRepositoryConnectionRequest)! !


!MaOdbmsProxy class methodsFor: 'creation'!
session: aMagmaSession oid: anInteger

	^self new
		session: aMagmaSession;
		oid: anInteger
! !


!MaOidCalculator class methodsFor: 'accessing'!
indexPositionForLoid: anInteger

	^anInteger - self baseLoid
! !

!MaOidCalculator class methodsFor: 'accessing'!
loidForFilePositionIndexPosition: anInteger

	^self baseLoid + anInteger
! !

!MaOidCalculator class methodsFor: 'accessing'!
specialValueForUnusedHashIndexEntry

	^self startOfNonIntegerSpecialObjectsObjectSpace + 65541
! !

!MaOidCalculator class methodsFor: 'testing'!
isOidForNewObject: anInteger

	^anInteger >= MaOidCalculator newOidMinimum
! !

!MaOidCalculator class methodsFor: 'debugging'!
infoFor: loidInteger

	| obj |

	loidInteger >= self newOidMinimum ifTrue: [ ^'new object' ].
	obj _
		self
			objectWithOid: loidInteger
			ifNone: [ ^self indexPositionForLoid: loidInteger ].
	^'(' , obj printString , ')'
! !


!MaReadStrategy methodsFor: 'private creation'!
depthArrayOfSize: arraySize

	| array |

	array _ (Array new: arraySize).
	1
		to: arraySize
		do:
			[ :index |
			array
				at: index
				put: 0 ].
	^array
! !

!MaReadStrategy methodsFor: 'accessing'!
depthOfAttribute: attributeIndex onClassWithId: classId
	"Answer the depth that the attribute at attributeIndex should be traversed into
	from the current depth."

	| depth |

	^(self == SystemReadStrategy or:
		[ (depth _
			SystemReadStrategy
				depthOfAttribute: attributeIndex
				onClassWithId: classId) = 0 ])
					ifTrue:
						[ depths
							maAt: classId
							ifPresent:
								[ :depthAnswer |
								depthAnswer isInteger
									ifTrue:
										[ depthAnswer ]
									ifFalse:
										[ depthAnswer at: attributeIndex ] ]
							ifAbsent: [ 0 ] ]
					ifFalse:
						[ depth ]
! !

!MaReadStrategy methodsFor: 'private building'!
forAttribute: instVarIndex onAny: aClass readToDepth: anInteger

	(depths
		at: aClass
		ifAbsentPut: [ self depthArrayOfSize: aClass instSize ])
			at: instVarIndex
			put: anInteger
! !

!MaReadStrategy methodsFor: 'building' stamp: 'cmm 5/1/2002 23:18'!
forAttributeNamed: aString onAny: aClass readToDepth: anInteger

	(aClass instVarNames includes: aString)
		ifFalse:
			[ MagmaUserError signal: aString , ' is not an attribute of ' , aClass name ].
	self
		forAttribute: (aClass instVarNames indexOf: aString)
		onAny: aClass
		readToDepth: anInteger
! !

!MaReadStrategy methodsFor: 'building'!
readToDepth: anInteger for: aClass

	depths
		at: aClass
		put: anInteger
! !

!MaReadStrategy methodsFor: 'building'!
readToDepth: anInteger forAnyKindOf: aClass

	aClass withAllSubclasses do:
		[ :each |
		self
			readToDepth: anInteger
			for: each ]
! !

!MaReadStrategy methodsFor: 'private initializing'!
initialize

	super initialize.
	"depths:  key is converted to the classId, value is either
	anInteger for depth of all instVars or an Array detailing the
	depth of each instVar."
	depths _ Dictionary new
! !

!MaReadStrategy methodsFor: 'private - converting' stamp: 'cmm 1/25/2002 16:26'!
makeReadyForUseUsing: aMaClassIdManager
	"Convert the classes in the receiver to classId's, since that is what the server goes by."

	| needsProcessing |

	needsProcessing _ false.
	depths keysAndValuesDo:
		[ :eachKey :eachValue | eachKey isInteger ifFalse: [ needsProcessing _ true ] ].
	needsProcessing ifFalse: [ ^self ].
	depths copy keysAndValuesDo:
		[ :eachClass :eachArray |
		eachClass maIsClass
			ifTrue:
				[ (aMaClassIdManager includesIdForClass: eachClass)
					ifTrue:
						[ depths
							at: (aMaClassIdManager idForClass: eachClass)
							put: (depths removeKey: eachClass) "eachArray" ]
					ifFalse:
						[ depths removeKey: eachClass ] ] ]
! !


!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 7/16/2002 20:57'!
addToBeRefreshed: aDictionary

	self toBeRefreshed addAll: aDictionary! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 7/16/2002 21:22'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection
! !

!MaRefreshViewResult methodsFor: 'building'!
toBeRefreshed: anOrderedCollection

	toBeRefreshed _ anOrderedCollection
! !

!MaRefreshViewResult methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:25'!
connection

	^connection! !

!MaRefreshViewResult methodsFor: 'private initializing' stamp: 'cmm 7/16/2002 20:12'!
initialize

	super initialize.
	self toBeRefreshed: (OrderedCollection new: 50)
! !

!MaRefreshViewResult methodsFor: 'accessing'!
permanentLoids

	^nil
! !

!MaRefreshViewResult methodsFor: 'accessing'!
sessionId

	^self connection sessionId
! !

!MaRefreshViewResult methodsFor: 'accessing'!
toBeRefreshed

	^toBeRefreshed! !

!MaRefreshViewResult methodsFor: 'accessing'!
userId

	^self connection userId
! !


!MaCommitResult methodsFor: 'converting'!
asFailedResult

	^MaFailedCommitResult new
		permanentLoids: self permanentLoids;
		toBeRefreshed: self toBeRefreshed;
		connection: self connection
! !

!MaCommitResult methodsFor: 'testing'!
hasConflicts

	^false
! !

!MaCommitResult methodsFor: 'accessing'!
permanentLoids
	"A Dictionary.  Key is the new-object loid, value is the permanent loid."

	^permanentLoids
! !

!MaCommitResult methodsFor: 'building'!
permanentLoids: aDictionary

	permanentLoids _ aDictionary
! !


!MaFailedCommitResult methodsFor: 'converting'!
asFailedResult

	^self
! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 6/26/2002 22:16'!
commitConflicts

	^commitConflicts! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:06'!
conflictMessage
	"This method demonstrates how the structure of a MaCommitResult might be utilized to
	provide a message to an end-user."

	| message |

	message _ MaTextMessage new.
	commitConflicts do:
		[ :each |
		message
			append: each connection userId;
			append: ' has committed changes to ';
			appendProperlyPluralized: 'object'
				for: each conflictingOids size;
			append: ' with ';
			appendProperlyPluralized: 'oid'
				for: each conflictingOids size;
			space;
			appendAndedList: each conflictingOids;
			append: '; ' ].
	message append:
		' while you were working on those same objects.  Please review and reapply your changes if necessary.'.
	^message text

! !

!MaFailedCommitResult methodsFor: 'accessing'!
dirtyReads

	^dirtyReads! !

!MaFailedCommitResult methodsFor: 'testing'!
hasConflicts

	^true
! !

!MaFailedCommitResult methodsFor: 'initializing' stamp: 'cmm 6/25/2002 23:49'!
initialize

	super initialize.
	commitConflicts _ OrderedCollection new.
	dirtyReads _ Dictionary new.
	largeCollectionConflicts _ Dictionary new
! !

!MaFailedCommitResult methodsFor: 'building'!
recordDirtyReadWith: aMaOdbmsClientConnection on: oidInteger

	(self dirtyReads
		at: aMaOdbmsClientConnection
		ifAbsentPut: [ OrderedCollection new ])
			add: oidInteger
! !

!MaFailedCommitResult methodsFor: 'building' stamp: 'cmm 7/16/2002 21:24'!
recordObjectConflictWith: aMagmaClientConnection on: oidInteger

	(commitConflicts
		detect: [ :each | each connection = aMagmaClientConnection ]
		ifNone: [ commitConflicts add: (MagmaCommitConflict connection: aMagmaClientConnection) ])
			addConflictingOid: oidInteger.
	^self
! !

!MaFailedCommitResult methodsFor: 'as yet unclassified' stamp: 'cmm 6/26/2002 00:33'!
populateConflictingObjectsFromOidsUsing: aMaObjectSerializer

	commitConflicts do: [ :each | each initializeConflictingObjectsUsing: aMaObjectSerializer ]
! !


!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:20'!
anchorBuffer

	^link submit: (self anchorRequest readStrategy: MaBasicReadStrategy default)
! !

!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:20'!
byteArrayFor: oid
	"Customize the bufferRequest prototype and send it to the repository."

	self readRequest
		oid: oid;
		readStrategy: session readStrategy.
	^link submit: self readRequest
! !

!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:21'!
numberOfEntriesFrom: lowKey to: highKey in: collectionOid on: attributeSymbol

	^link submit: (
		self keyIntervalInfoRequest
			collectionOid: collectionOid;
			attribute: attributeSymbol;
			lowKey: lowKey;
			highKey: highKey)
! !

!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:22'!
sizeOfLargeCollection: aMagmaCollection
	"Calls MaRepositoryController>>sizeOfLargeCollection:"

	self largeCollectionSizeRequest collectionOid: (session oidFor: aMagmaCollection).
	^link submit: self largeCollectionSizeRequest
! !

!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:22'!
upTo: anInteger objectsIn: collectionLoid fromIndex: startIndex on: attributeSymbol using: aMaReadStrategy
	"Calls upTo:oidsFromIndex:inLargeCollection:on:using:  Answers a CollectionSegment."

	^link submit: (
		self segmentByIndexRequest
			quantity: anInteger;
			collectionLoid: collectionLoid;
			lowIndex: startIndex;
			attribute: attributeSymbol;
			readStrategy: aMaReadStrategy yourself)
! !

!MaRepositoryControllerFacade methodsFor: 'accessing' stamp: 'cmm 4/1/2002 00:22'!
upTo: anInteger objectsIn: collectionLoid fromKey: lowKey to: highKey on: attributeSymbol using: aMaReadStrategy
	"Answers a CollectionSegment.  Calls upTo:oidsFrom:to:inLargeCollection:on:using:"

	^link submit: (
		self segmentByKeyRequest
			quantity: anInteger;
			collectionLoid: collectionLoid;
			lowKey: lowKey;
			highKey: highKey;
			attribute: attributeSymbol;
			readStrategy: aMaReadStrategy;
			yourself)
! !

!MaRepositoryControllerFacade methodsFor: 'actions' stamp: 'cmm 4/1/2002 00:10'!
abortTransaction
	"Answers a collection oids that were changed since the calling session last
	refreshed its view of the repository."

	^link submit: self abortTransactionRequest
! !

!MaRepositoryControllerFacade methodsFor: 'actions' stamp: 'cmm 4/16/2002 00:14'!
connectAs: aString maximumNumberOfChallengers: anInteger
	"Calls RepositoryController>>newSessionFor:numberOfChallengers:"
	| resultArray |

	link connect.
	resultArray _
		link submit: (
			self connectionRequest
				userId: aString;
				maximumNumberOfChallengers: anInteger).
	self initializeRequestPrototypesWithSessionId: resultArray first.
	^resultArray
! !

!MaRepositoryControllerFacade methodsFor: 'actions' stamp: 'cmm 4/1/2002 00:11'!
newTransaction

	^link submit: self transactionRequest
! !

!MaRepositoryControllerFacade methodsFor: 'actions' stamp: 'cmm 6/26/2002 00:32'!
submitAll: aMaCommitPackage
	"Calls submitAll:for:."

	| commitResult |
	commitResult _ link submit: (self submitRequest package: aMaCommitPackage).
	commitResult hasConflicts ifTrue:
		[ commitResult populateConflictingObjectsFromOidsUsing: session serializer ].
	^commitResult
! !

!MaRepositoryControllerFacade methodsFor: 'initializing' stamp: 'cmm 4/1/2002 00:11'!
disconnect

	link submit: self disconnectRequest
! !

!MaRepositoryControllerFacade methodsFor: 'initializing' stamp: 'cmm 4/23/2002 20:00'!
initializeRequestPrototypesWithSessionId: anInteger

	requestPrototypes _
		(Array new: 11)
			at: 1
				put: (MaReadRequest sessionId: anInteger);
			at: 2
				put: (MaRepositoryDisconnectRequest sessionId: anInteger);
			at: 3
				put: (MaWriteRequest sessionId: anInteger);
			at: 4
				put: (MaTransactionRequest sessionId: anInteger);
			at: 5
				put: (MaAbortTransactionRequest sessionId: anInteger);
			at: 6
				put: MaLargeCollectionSizeRequest new;
			at: 7
				put: (MaAnchorRequest sessionId: anInteger);
			at: 8
				put: MaKeyIntervalInfoRequest new;
			at: 9
				put: nil;
			at: 10
				put: MaSegmentByIndexRequest new;
			at: 11
				put: MaSegmentByKeyRequest new;
			yourself
! !

!MaRepositoryControllerFacade methodsFor: 'initializing' stamp: 'cmm 3/30/2002 23:26'!
link: aMaServerLink

	link _ aMaServerLink
! !

!MaRepositoryControllerFacade methodsFor: 'initializing' stamp: 'cmm 4/23/2002 20:00'!
session: aMagmaSession

	session _ aMagmaSession
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:52'!
abortTransactionRequest

	^self requestPrototypes at: 5
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
anchorRequest

	^self requestPrototypes at: 7
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
connectionRequest

	^MaRepositoryConnectionRequest new
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
disconnectRequest

	^self requestPrototypes at: 2
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 23:57'!
getRepositoryController
	"This ugly-named method is so named to minimize costs of separating out the much more important sends of #repositoryController in the server classes..  This is currently ONLY used to provide multiple local sessions connected to the same repository.."

	^link getRepositoryController! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
keyIntervalInfoRequest

	^self requestPrototypes at: 8
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
largeCollectionSizeRequest

	^self requestPrototypes at: 6
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
readRequest

	^self requestPrototypes at: 1
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
requestPrototypes

	^requestPrototypes
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:58'!
segmentByIndexRequest

	^self requestPrototypes at: 10
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:59'!
segmentByKeyRequest

	^self requestPrototypes at: 11
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:59'!
submitRequest

	^self requestPrototypes at: 3
! !

!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 4/23/2002 19:59'!
transactionRequest

	^self requestPrototypes at: 4
! !


!MaRepositoryControllerFacade class methodsFor: 'creation' stamp: 'cmm 3/30/2002 23:27'!
session: aMagmaSession link: aMaServerLink

	^self new
		session: aMagmaSession;
		link: aMaServerLink;
		yourself
! !


!MaRepositoryRequest methodsFor: 'private accessing'!
repositoryController

	^repositoryController! !

!MaRepositoryRequest methodsFor: 'private accessing'!
sessionId

	^sessionId! !

!MaRepositoryRequest methodsFor: 'building'!
repositoryController: aMaRepositoryController

	repositoryController _ aMaRepositoryController
! !

!MaRepositoryRequest methodsFor: 'private building'!
sessionId: anInteger

	sessionId _ anInteger
! !


!MaAbstractReadRequest methodsFor: 'accessing'!
readStrategy

	^readStrategy! !

!MaAbstractReadRequest methodsFor: 'building'!
readStrategy: aString

	readStrategy _ aString
! !


!MaLargeCollectionSegmentRequest methodsFor: 'accessing'!
attribute

	^attribute! !

!MaLargeCollectionSegmentRequest methodsFor: 'accessing'!
collectionLoid

	^collectionLoid! !

!MaLargeCollectionSegmentRequest methodsFor: 'accessing'!
quantity

	^quantity! !

!MaLargeCollectionSegmentRequest methodsFor: 'building'!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaLargeCollectionSegmentRequest methodsFor: 'building'!
collectionLoid: anInteger

	collectionLoid _ anInteger
! !

!MaLargeCollectionSegmentRequest methodsFor: 'building'!
quantity: anInteger

	quantity _ anInteger
! !


!MaLargeCollectionSizeRequest methodsFor: 'accessing'!
collectionOid

	^collectionOid! !

!MaLargeCollectionSizeRequest methodsFor: 'building'!
collectionOid: anInteger

	collectionOid _ anInteger
! !


!MaKeyIntervalInfoRequest methodsFor: 'accessing'!
attribute

	^attribute! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing'!
highKey

	^highKey! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing'!
lowKey

	^lowKey! !

!MaKeyIntervalInfoRequest methodsFor: 'building'!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaKeyIntervalInfoRequest methodsFor: 'building'!
highKey: anInteger

	highKey _ anInteger
! !

!MaKeyIntervalInfoRequest methodsFor: 'building'!
lowKey: anInteger

	lowKey _ anInteger
! !


!MaReadRequest methodsFor: 'accessing'!
oid

	^oid! !

!MaReadRequest methodsFor: 'building'!
oid: anInteger

	oid _ anInteger
! !


!MaRepositoryConnectionRequest methodsFor: 'accessing'!
maximumNumberOfChallengers

	^maximumNumberOfChallengers! !

!MaRepositoryConnectionRequest methodsFor: 'accessing'!
userId

	^userId! !

!MaRepositoryConnectionRequest methodsFor: 'building'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MaRepositoryConnectionRequest methodsFor: 'building'!
userId: aString

	userId _ aString
! !


!MaRepositoryRequest class methodsFor: 'creation'!
sessionId: anInteger

	^self new sessionId: anInteger
! !


!MaRequestServer methodsFor: 'private' stamp: 'cmm 4/23/2002 23:59'!
getRepositoryController

	^requestProcessor! !


!MaRootAnchor methodsFor: 'accessing'!
object

	^object! !

!MaRootAnchor methodsFor: 'building'!
object: anObject

	object _ anObject
! !


!MaRootAnchor class methodsFor: 'creation'!
object: anObject

	^self new object: anObject
! !


!MaSegmentByIndexRequest methodsFor: 'accessing'!
lowIndex

	^lowIndex! !

!MaSegmentByIndexRequest methodsFor: 'building'!
lowIndex: anInteger

	lowIndex _ anInteger
! !


!MaSegmentByKeyRequest methodsFor: 'accessing'!
highKey

	^highKey! !

!MaSegmentByKeyRequest methodsFor: 'accessing'!
lowKey

	^lowKey! !

!MaSegmentByKeyRequest methodsFor: 'building'!
highKey: anInteger

	highKey _ anInteger
! !

!MaSegmentByKeyRequest methodsFor: 'building'!
lowKey: anInteger

	lowKey _ anInteger
! !


!MaSegmentRequestResult methodsFor: 'accessing'!
indexOfHighestKey

	^indexOfHighestKey! !

!MaSegmentRequestResult methodsFor: 'accessing'!
indexOfLowestKey

	^startIndex
! !

!MaSegmentRequestResult methodsFor: 'building'!
indexOfHighestKey: anInteger

	indexOfHighestKey _ anInteger
! !


!MaTransaction methodsFor: 'actions' stamp: 'cmm 6/28/2002 00:33'!
backupChangedObjects

	readSet keysAndValuesDo:
		[ :eachReal :eachBackup |
		(eachReal maIsChangedFrom: eachBackup) ifTrue: [ self forceBackup: eachReal ] ]
! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 6/27/2002 23:55'!
rehashPersistentCollections

	readSet keysAndValuesDo:
		[ :eachKey :eachValue |
		eachKey maIsHashedCollection
			ifTrue:
				[ eachKey rehash.
				eachValue rehash ] ]
! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 6/27/2002 23:55'!
restore
	"restore all changed objects to their state as read from the repository."

	readSet
		keysAndValuesDo: [ :eachOriginal :eachBackup | eachOriginal maRestoreFrom: eachBackup ]
! !

!MaTransaction methodsFor: 'private actions' stamp: 'cmm 7/24/2002 20:45'!
forceBackup: anObject

	readSet
		at: anObject
		put: anObject maShallowCopy
! !

!MaTransaction methodsFor: 'accessing' stamp: 'cmm 6/27/2002 23:54'!
changedObjects

	| commitPackage |

	commitPackage _ MaCommitPackage new.
	self largeCollectionChanges do:
		[ :each |
		each hasChanges
			ifTrue:
				[ commitPackage
					addLargeCollectionChanges: each
					using: session ] ].
	readSet keysAndValuesDo:
		[ :eachCurrent :eachBackup |
		(eachCurrent maIsChangedFrom: eachBackup)
			ifTrue:
				[ commitPackage addObject: eachCurrent.
				self
					recordChangedIndexedAttributesGivenOld: eachBackup
					new: eachCurrent ] ].
	^commitPackage
! !

!MaTransaction methodsFor: 'accessing'!
largeCollectionChanges

	^largeCollectionChanges! !

!MaTransaction methodsFor: 'accessing' stamp: 'cmm 6/28/2002 00:10'!
readAndChangedObjects
	"Find all of the objects that have changed since the transaction began
	and answer them bundled in a MaCommitPackage."

	| commitPackage |

	commitPackage _ MaCommitPackage new: readSet size.
	readSet keysAndValuesDo:
		[ :eachCurrent :eachBackup |
		(eachCurrent maIsChangedFrom: eachBackup)
			ifTrue:
				[ commitPackage addObject: eachCurrent ]
			ifFalse:
				[ commitPackage addUnchangedObject: eachCurrent ] ].
	^commitPackage
! !

!MaTransaction methodsFor: 'accessing'!
recordChangedIndexedAttributesGivenOld: oldObject new: newObject

	self largeCollectionChanges do:
		[ :eachChanges |
		(eachChanges collection canIndex: oldObject)
			ifTrue:
				[ eachChanges collection indexes do:
					[ :eachIndex | | oldHashValue newHashValue |
					"If hash index value has changed.."
					(oldHashValue _ eachIndex indexHashFor: oldObject) ~=
						(newHashValue _ eachIndex indexHashFor: newObject)
							ifTrue:
								[
								"we have a potential index change!!"
								eachChanges
									move: newObject
									from: oldHashValue
									to: newHashValue
									forIndexedAttribute: eachIndex attribute ] ] ] ]
! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 6/27/2002 23:54'!
clean: anObject

	readSet
		removeKey: anObject
		ifAbsent: [ "do nothing" ]
! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 6/27/2002 23:35'!
markRead: anObject

	anObject maIsImmutable ifTrue: [ ^anObject ].
	self forceBackup: anObject.
	anObject maIsLargeCollection
		ifTrue:
			[ self monitorLargeCollectionChanges: anObject changes.
			anObject session: session ].
	^anObject
! !

!MaTransaction methodsFor: 'building'!
monitorLargeCollectionChanges: aMaLargeCollectionChanges

	self largeCollectionChanges add: aMaLargeCollectionChanges
! !

!MaTransaction methodsFor: 'private initializing' stamp: 'cmm 7/16/2002 21:45'!
initialize

	super initialize.
	readSet _ WeakIdentityKeyDictionary new.
	largeCollectionChanges _ WeakSet new
! !

!MaTransaction methodsFor: 'private building'!
session: aMagmaSession

	session _ aMagmaSession
! !


!MaTransaction class methodsFor: 'creation'!
session: aMagmaSession

	^self new session: aMagmaSession
! !


!MaValueIndexDefinition methodsFor: 'accessing'!
keySize

	^keySize! !

!MaValueIndexDefinition methodsFor: 'private building'!
keySize: anInteger

	keySize _ anInteger
! !


!MaByteSequenceIndexDefinition methodsFor: 'private accessing'!
keySize: numberOfBits

	super keySize: numberOfBits.
	meaningfulCharacters _ ((2 raisedTo: numberOfBits) log: self sizeOfCharacterSet) truncated
! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing'!
meaningfulCharacters
	"Answer the number of characters this index will use to index."	

	^meaningfulCharacters
! !


!MaAsciiStringIndexDefinition methodsFor: 'actions'!
canIndex: anObject

	^(super canIndex: anObject) and: [ (self indexObjectFor: anObject) isString ]
! !

!MaAsciiStringIndexDefinition methodsFor: 'actions' stamp: 'cmm 5/1/2002 23:15'!
validateCanIndex: anObject

	super validateCanIndex: anObject.
	(self indexObjectFor: anObject) isString
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate hashIndex value for ' , anObject printString , ' because its ' ,
					attribute , ' does not evaluate to a String.' ]
! !

!MaAsciiStringIndexDefinition methodsFor: 'accessing' stamp: 'cmm 3/4/2002 23:15'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Only ASCII values 0 - 127 are meaningful,
	all others in aString are ignored."

	| answer power |

	answer _ 0.
	power _ meaningfulCharacters - 1.
	aString do:
		[ :eachChar |
		(eachChar asciiValue
			between: 0
			and: 127)
				ifTrue:
					[ answer _ answer + (eachChar asciiValue * (self sizeOfCharacterSet raisedTo: power)).
					power _ power - 1.
					power < 0 ifTrue: [ ^answer ] ] ].
	^answer
! !

!MaAsciiStringIndexDefinition methodsFor: 'private accessing'!
sizeOfCharacterSet

	^128
! !


!MaSearchStringIndexDefinition methodsFor: 'accessing' stamp: 'cmm 7/8/2002 15:06'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Since string searches are easiest when you don't
	have to worry about case, we only use a 64 ascii character range,
	from 33 to 96.  This means we must do without the {, }, |,
	~, and space characters.  These are at 123-126 and 32.
	Characters outside of this range must be ignored.  This gives
	us an extra 5 meaningful characters on a 128-bit index while also
	providing applications a more convenient search."

	| answer index |

	answer _ 0.
	index _ 0.
	aString do:
		[ :eachChar | | conditionedChar |
		conditionedChar _ eachChar asUppercase.
		(conditionedChar asciiValue
			between: 33
			and: 96)
				ifTrue:
					[ answer _ answer + ((conditionedChar asciiValue - 32) * (keySize raisedTo: index)).
					index _ index + 1.
					(index + 1) = meaningfulCharacters ifTrue: [ ^answer ] ] ].
	^answer
! !

!MaSearchStringIndexDefinition methodsFor: 'private accessing'!
sizeOfCharacterSet

	^64
! !


!MaValueIndexDefinition class methodsFor: 'creation'!
attribute: aSymbol

	self shouldNotImplement
! !

!MaValueIndexDefinition class methodsFor: 'creation'!
attribute: aSymbol keySize: numberOfBits

	^(super attribute: aSymbol) keySize: numberOfBits
! !


!MaWriteRequest methodsFor: 'accessing'!
package

	^package! !

!MaWriteRequest methodsFor: 'building'!
package: aMaCommitPackage

	package _ aMaCommitPackage
! !


!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers

	^maximumNumberOfChallengers! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
sessionId

	^sessionId! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
userId

	^userId! !

!MagmaClientConnection methodsFor: 'building' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
sessionId: anInteger

	sessionId _ anInteger
! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
userId: aString

	userId _ aString
! !


!MagmaClientConnection class methodsFor: 'creation' stamp: 'cmm 6/26/2002 00:21'!
userId: aString sessionId: sessionIdInteger maximumNumberOfChallengers: anInteger

	^self new
		userId: aString;
		sessionId: sessionIdInteger;
		maximumNumberOfChallengers: anInteger
! !


!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:05'!
occurrencesOf: anObject

	| newOccurrences |

	newOccurrences _ self changes occurrencesOf: anObject.
	(self session isNil or:
		[ (self session isPersistent: anObject) not or: [ (self session isPersistent: self) not ] ])
			ifTrue:
				[ ^newOccurrences ].
	^(self session
		occurrencesOf: anObject
		in: self) + newOccurrences
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:05'!
sampleArray

	| answer x |

	x _ 1.
	answer _ Array new: (self size min: 2500).
	self
		slowlyDo:
			[ :each |
			answer
				at: x
				put: each.
			x = 2500 ifTrue: [ ^answer ].
			x _ x + 1 ]
		refreshEvery: 1000.
	^answer
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:05'!
size

	^self session isNil
		ifTrue:
			[ self changes deltaSize ]
		ifFalse:
			[ (self session sizeOfLargeCollection: self) + self changes deltaSize ]
! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/18/2002 15:05'!
add: anObject

	(self canIndex: anObject)
		ifFalse:
			[ MagmaUserError signal:
				anObject printString , ' cannot be added to ' , self printString ,
					' because it does not support all of the indexable attributes.' ].
	self changes
		add: anObject
		at: (indexes collect: [ :each | each indexHashFor: anObject ])
! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/18/2002 15:05'!
addAll: aCollection

	aCollection do: [ :each | self add: each ]
! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/31/2002 00:15'!
canAdd: anObject

	^self canIndex: anObject! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/18/2002 15:05'!
remove: anObject

	^self changes
		remove: anObject
		at: (indexes collect: [ :each | each indexHashFor: anObject ])
! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 7/18/2002 15:05'!
slowlyDo: oneArgBlock commitEvery: anInteger
	"It is recommended to not use this method unless you have
	made the receiver read-only (see 'Actions - beReadOnly').  Without doing
	this, additions made to the collection by other users while enumerating
	may cause you to encounter the same element more than once.
	This method should normally be used for utility scripts."

	| previousCachedSegment session |

	session _ self session.
	self maMarked: 'performance'. "Put exception-based progress-monitoring code here."
	previousCachedSegment _ self segment.
	self segment: (MaCollectionSegment new: 1100).
	session begin.
	[ (1 to: self size) do:
		[ :index |
		oneArgBlock value: (self at: index).
		index \\ anInteger = 0
			ifTrue:
				[ session
					commit;
					begin ] ].
	session commit ] ensure: [ self segment: previousCachedSegment ]
! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 7/18/2002 15:05'!
slowlyDo: oneArgBlock refreshEvery: anInteger
	"It is highly recommended to not use this method unless you have
	made the receiver read-only (see 'Actions - beReadOnly').  Without
	this, additions made to the collection by other users while enumerating
	may cause you to encounter the same element more than once.
	This method should normally be used for utility scripts."

	| previousCachedSegment |

	self maMarked: 'performance'. "Put exception-based progress-monitoring code here."
	previousCachedSegment _ self segment.
	self segment: (MaCollectionSegment new: 1100).
	[ (1 to: self size) do:
		[ :index |
		oneArgBlock value: (self at: index).
		index \\ anInteger = 0 ifTrue: [ self session refresh ] ] ] ensure: [ self segment: previousCachedSegment ]! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
addIndex: aMaIndexDefinition

	indexes add: aMaIndexDefinition.
	self changes addIndex: aMaIndexDefinition
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
asSortedReaderOn: attributeSymbol

	^self
		asSortedReaderOn: attributeSymbol
		using: self session readStrategy
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
asSortedReaderOn: attributeSymbol using: aMaReadStrategy
	"Answers a MaLargeCollectionReader."

	| index |

	index _ self indexNamed: attributeSymbol.
	^self
		readerFrom: 0
		to: index highestPossibleKey
		on: index
		readStrategy: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
canIndex: anObject

	^indexes maConform: [ :each | each canIndex: anObject ]
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
indexNamed: aString

	^indexes
		detect: [ :each | each attribute = aString ]
		ifNone:
			[ MagmaUserError signal:
				aString , ' is not an indexed attribute of large-collection with oid ' ,
					(self session oidFor: self) printString , '.' ]
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/31/2002 19:43'!
read: attributeSymbol from: startIndex to: endIndex

	^self
		read: attributeSymbol
		from: startIndex
		to: endIndex
		using: self session readStrategy! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/30/2002 23:24'!
read: attributeSymbol from: lowKey to: highKey using: aMaReadStrategy
	"Answers a MagmaCollectionReader."

	| index |

	index _ self indexNamed: attributeSymbol.
	^self
		readerFrom: (index indexHashForIndexObject: lowKey)
		to: (index indexHashForIndexObject: highKey)
		on: index
		readStrategy: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 7/18/2002 15:05'!
removeIndexOn: attributeSymbol

	indexes remove: (indexes detect: [ :each | each attribute = attributeSymbol ]).
	self changes removeIndexOn: attributeSymbol
! !

!MagmaCollection methodsFor: 'options' stamp: 'cmm 7/18/2002 15:05'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at
	a time when 'scrolling' to a new part of the collection via at:."

	self segment pageSize: anInteger! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:05'!
includes: anObject

	(self changes includes: anObject) ifTrue: [ ^true ].
	self session isNil ifTrue: [ ^false ].
	(self segment includes: anObject) ifTrue: [ ^true ].
	^(self occurrencesOf: anObject) > 0
! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:05'!
isEmpty

	^self size = 0
! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:05'!
notEmpty

	^self isEmpty not
! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 7/18/2002 15:05'!
initialize
	super initialize.
	self initializeTransients.
	self changes beNewCollection.
	indexes _ OrderedCollection new
! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 7/18/2002 15:05'!
initializeChanges

	self changes: (MaLargeCollectionChanges collection: self)
! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 7/18/2002 15:05'!
initializeSegment

	self segment: (MaCollectionSegment new: 250)! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 7/18/2002 15:05'!
initializeTransients

	self
		initializeChanges;
		initializeSegment
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
at: indexInteger
	"Only indexes can maintain any kind of order at all.  So the
	simple implentation for merging local changes to the receiver
	with the cache itself is to simply add them on to the end."

	| segment |

	segment _ self segment.
	^(segment includesIndex: indexInteger)
		ifTrue:
			[ segment at: indexInteger ]
		ifFalse:
			[ segment loadFrom: (
				self
					segmentFromIndex: indexInteger
					on: nil
					pageSize: segment pageSize).
			segment at: indexInteger ]
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
buildIndexes: aCollection
	"aCollection of MaIndexDefinitions"

	self session begin.
	self
		slowlyDo:
			[ :each |
			aCollection do:
				[ :eachIndex |
				self changes
					add: each
					at: (eachIndex indexHashFor: each)
					toIndexForAttribute: eachIndex attribute ] ]
		commitEvery: 1000
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
changes

	^self maVirtualInstVarNamed: #changes
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
changes: aMaLargeCollectionChanges

	self
		maVirtualInstVarNamed: #changes
		put: aMaLargeCollectionChanges
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
hasChanges

	^self changes notEmpty
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
indexes

	^indexes
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
maIsLargeCollection

	^true
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
maPopulateUsing: aMaObjectSerializer

	super maPopulateUsing: aMaObjectSerializer.
	self
		initializeChanges;
		setLoid: (aMaObjectSerializer oidFor: self)
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:45'!
readerFrom: lowHashIndex to: highHashIndex on: aMaHashIndex readStrategy: aMaReadStrategy
	"Answers a MagmaCollectionReader."

	| segment |

	segment _
		self
			segmentFromKey: lowHashIndex
			to: highHashIndex
			on: aMaHashIndex
			pageSize: self segment pageSize
			using: aMaReadStrategy.
	^(MagmaCollectionReader
		collection: self
		index: aMaHashIndex
		absoluteLowIndex: segment indexOfLowestKey
		absoluteHighIndex: segment indexOfHighestKey
		readStrategy: aMaReadStrategy)
			loadSegmentFrom: segment
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
resetSegment

	self segment reset
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
segment

	^self maVirtualInstVarNamed: #segment
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
segment: aMaCollectionSegment

	self
		maVirtualInstVarNamed: #segment
		put: aMaCollectionSegment
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger
	"Answer a MaCollectionSegment."

	^self
		segmentFromIndex: startIndex
		on: aMaIndexDefinition
		pageSize: anInteger
		using: self session readStrategy
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaCollectionSegment."

	^self session
		upTo: anInteger
		objectsIn: self
		fromIndex: startIndex
		on: aMaIndexDefinition
		using: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
segmentFromKey: lowHashIndexKey to: highHashIndexKey on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaIndexedCollectionSegment."

	^self session
		upTo: anInteger
		objectsIn: self
		fromKey: lowHashIndexKey
		to: highHashIndexKey
		on: aMaIndexDefinition
		using: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
session

	^self maVirtualInstVarNamed: #session
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
session: aMagmaSession

	self
		maVirtualInstVarNamed: #session
		put: aMagmaSession
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
setLoid: anInteger

	self changes collectionLoid: anInteger
! !


!MagmaCollection class methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2002 15:46'!
initialize

	MagmaCollection undefineAllVirtualInstVars.
	MagmaCollection
		defineVirtualInstVarNamed: #changes;
		defineVirtualInstVarNamed: #session;
		defineVirtualInstVarNamed: #segment.
	MaLargeCollectionChanges undefineAllVirtualInstVars.
	MaLargeCollectionChanges defineVirtualInstVarNamed: #collection.
	MagmaCollectionReader undefineAllVirtualInstVars.
	MagmaCollectionReader
		defineVirtualInstVarNamed: #segment;
		defineVirtualInstVarNamed: #session
! !

!MagmaCollection class methodsFor: 'as yet unclassified' stamp: 'cmm 7/18/2002 15:05'!
maMaterializeFrom: aMaNormalObjectBuffer

	^(super maMaterializeFrom: aMaNormalObjectBuffer)
		initializeTransients;
		yourself
! !


!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
at: indexInteger
	"The merge of local additions to the receivers segment is not perfect,
	but should be suitable for using the receiver to support a scrollble list.
	The problem comes in where you have a series of multiple, duplicate
	keys and have added some more of those keys that are still uncommitted.
	The current implementation will include all of the additions as long as their
	key is within the range of the segments highest and lowest."

	| absoluteIndex segment |

	absoluteIndex _ self absoluteIndexFor: indexInteger.
	segment _ self segment.
	^(segment includesIndex: absoluteIndex)
		ifTrue:
			[ segment at: absoluteIndex ]
		ifFalse:
			[ self segment loadFrom: (
				collection
					segmentFromIndex: (segment startingPageIndexFor: absoluteIndex)
					on: index
					pageSize: segment pageSize
					using: readStrategy).
			self mergeAdditions.
			self segment at: absoluteIndex ]
! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/30/2002 23:49'!
collection

	^collection! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
index

	^index! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at
	a time when 'scrolling' to a new part of the collection via at:."

	self segment pageSize: anInteger! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
size

	^absoluteHighIndex - absoluteLowIndex + 1
! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 7/18/2002 15:44'!
slowlyDo: oneArgBlock commitEvery: anInteger 
	"It is highly recommended to not use this method unless you have
	made the receiver read-only (see 'Actions - beReadOnly').  Without
	this, additions made to the collection by other users while enumerating
	may cause you to encounter the same element more than once.
	This method should normally be used for utility scripts."

	| previousCachedSegment |
	self maMarked: 'performance'.	"Put progress-monitoring code here (exception based?)."
	previousCachedSegment _ self segment.
	self segment: (MaCollectionSegment new: 1100).
	(1 to: self size) do: 
			[:x | 
			oneArgBlock value: (self at: x).
			x \\ anInteger = 0 ifTrue: [self session commit]].
	self segment: previousCachedSegment! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 7/18/2002 15:44'!
slowlyDo: oneArgBlock refreshEvery: anInteger
	"It is highly recommended to not use this method unless you have
	made the receiver read-only (see 'Actions - beReadOnly').  Without
	this, additions made to the collection by other users while enumerating
	may cause you to encounter the same element more than once.
	This method should normally be used for utility scripts."

	| previousCachedSegment |

	self maMarked: 'performance'. "Put progress-monitoring code here (exception based?)."
	previousCachedSegment _ self segment.
	self segment: (MaCollectionSegment new: 1100).
	(1 to: self size) do:
		[ :x |
		oneArgBlock value: (self at: x).
		(x \\ anInteger) = 0 ifTrue: [ self session refresh ] ].
	self segment: previousCachedSegment
! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:44'!
isEmpty

	^self size = 0
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
absoluteHighIndex: anInteger

	absoluteHighIndex _ anInteger
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
absoluteIndexFor: anInteger

	^anInteger + absoluteLowIndex - 1
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
absoluteLowIndex: anInteger

	absoluteLowIndex _ anInteger
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
collection: aMagmaCollection

	collection _ aMagmaCollection
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
index: aMaIndexDefinition

	index _ aMaIndexDefinition
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
loadSegmentFrom: aMaSegmentRequestResult

	self segment loadFrom: aMaSegmentRequestResult
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
mergeAdditions

	collection changes hasAdditions ifFalse: [ ^self ].
	self segment
		merge: collection changes added
		using: index
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
postInitialize

	self segment: (MaIndexedCollectionSegment sortBlock: index sortBlock)
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
readStrategy: aMaReadStrategy

	readStrategy _ aMaReadStrategy
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
segment

	^self maVirtualInstVarNamed: #segment
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
segment: aMaIndexedCollectionSegment

	self
		maVirtualInstVarNamed: #segment
		put: aMaIndexedCollectionSegment
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
session

	^collection session
! !


!MagmaCollectionReader class methodsFor: 'creation' stamp: 'cmm 7/18/2002 15:44'!
collection: aMagmaCollection index: aMaHashIndex absoluteLowIndex: absoluteLowIndex absoluteHighIndex: absoluteHighIndex readStrategy: aMaReadStrategy

	^self new
		collection: aMagmaCollection;
		index: aMaHashIndex;
		absoluteLowIndex: absoluteLowIndex;
		absoluteHighIndex: absoluteHighIndex;
		readStrategy: aMaReadStrategy;
		postInitialize
! !

!MagmaCollectionReader class methodsFor: 'private creation' stamp: 'cmm 7/18/2002 15:44'!
removing

	self undefineAllVirtualInstVars
! !


!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingObjects

	^conflictingObjects
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingOids

	^conflictingOids
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/25/2002 23:47'!
connection

	^connection! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/25/2002 23:47'!
userId

	^connection userId! !

!MagmaCommitConflict methodsFor: 'initializing' stamp: 'cmm 6/26/2002 00:00'!
initialize

	conflictingOids _ OrderedCollection new
! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 00:00'!
addConflictingOid: oidInteger

	conflictingOids add: oidInteger
! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/25/2002 23:54'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 22:46'!
initializeConflictingObjectsUsing: aMaObjectSerializer

	conflictingObjects _ OrderedCollection new.
	conflictingOids 
		do: 
			[ :each | 
			aMaObjectSerializer 
				objectWithOid: each
				ifFound: [ :foundObj | conflictingObjects add: foundObj ]
				ifAbsent: [ "do nothing" ] ]! !


!MagmaCommitConflict class methodsFor: 'creation' stamp: 'cmm 6/25/2002 23:54'!
connection: aMagmaClientConnection

	^self new connection: aMagmaClientConnection! !


!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:18'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe

	^refreshPersistentObjectsEvenWhenChangedOnlyByMe! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:19'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe: aBoolean

	refreshPersistentObjectsEvenWhenChangedOnlyByMe _ aBoolean! !

!MagmaPreferences methodsFor: 'initializing' stamp: 'cmm 7/16/2002 00:22'!
initialize

	self 
		refreshPersistentObjectsEvenWhenChangedOnlyByMe: true! !


!MagmaPreferences class methodsFor: 'as yet unclassified' stamp: 'cmm 7/16/2002 00:24'!
debugProxies

	^DebugProxies! !

!MagmaPreferences class methodsFor: 'as yet unclassified' stamp: 'cmm 7/25/2002 22:31'!
debugProxies: aBoolean

	DebugProxies _ aBoolean! !

!MagmaPreferences class methodsFor: 'as yet unclassified' stamp: 'cmm 7/16/2002 00:24'!
initialize

	self debugProxies: false! !


!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 8/1/2002 19:10'!
create: fileNameString root: anObject

	| session |
	self new createRepositoryAt: fileNameString.
	session _ MagmaSession openLocal: fileNameString.
	session
		connectAs: 'paula';
		root: anObject;
		disconnect! !


!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/25/2002 00:06'!
isPersistent: anObject

	^(self serializer hasOidFor: anObject) and: [ (MaOidCalculator isOidForNewObject: (self oidFor: anObject)) not ]! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/17/2002 22:57'!
objectWithOid: anInteger ifAbsent: aBlock

	^serializer
		objectWithOid: anInteger
		ifAbsent: aBlock! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/17/2002 22:54'!
oidFor: anObject

	^self serializer oidFor: anObject! !

!MagmaSession methodsFor: 'accessing'!
preferences

	^preferences! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:17'!
preferences: aMagmaPreferences

	preferences _ aMagmaPreferences! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 4/24/2002 23:42'!
root
	"Every Magma repository has a single root object off which every other object directly or indirectly hangs.  This method answers it."

	^self anchor object
! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 4/24/2002 22:22'!
closeRepository
	"Be sure to call this method if, and only if, you are connected locally (you should call disconnect first).  If you are remote, you can disconnect."

	self getRepositoryController close
! !

!MagmaSession methodsFor: 'connections'!
connectAs: aString

	^self
		connectAs: aString
		maximumNumberOfChallengers: nil
! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 7/15/2002 23:53'!
connectAs: aString maximumNumberOfChallengers: anInteger

	| resultArray |
self maMarked: 'dev'.  "You need to perform verifications that self class magmaVersion = the server version, also that all of the class definitions are congruent with the local image."
	self serializer reset.
	resultArray _
		facade
			connectAs: aString
			maximumNumberOfChallengers: anInteger.
	"resultArray is a special, non-well-formed object with the following structure:

	at: 1 - id of the new session
	at: 2 - Set of MaStorageForClass'' to load into the local class map..

We digress from proper objectification of a session result only because
we want to maintain a minimum set of classes necessary to acquire the class
map itself, for once we acqure that, we can do anything.  Prior to that, however,
we are limited to the only the classes that are ''basic'' classes according to the
MaDefaultClassIdManager."
	self
		id: (resultArray at: 1);
		loadClassesSetFrom: (resultArray at: 2);
		loadClassDefinitionsFrom: (resultArray at: 3);
		loadLargeCollectionsFrom: (resultArray at: 4).
	^self
! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 3/30/2002 22:46'!
disconnect

	self isConnected
		ifTrue:
			[ facade disconnect.
			self id: nil ]
! !

!MagmaSession methodsFor: 'connections'!
isConnected

	^self id notNil
! !

!MagmaSession methodsFor: 'initializing' stamp: 'cmm 7/28/2002 20:56'!
root: anObject
	"You should not start a transaction to set the root."

	| anchor |
	anchor _ self anchor.
	anchor object ifNotNil: [ Warning signal: 'Are you sure you want to wipe out the entire database for ', anObject printString, '?' ].
	self commit: [ anchor object: anObject ]! !

!MagmaSession methodsFor: 'large collections'!
addLargeCollection: aMagmaCollection
	"The receivers largeCollections collection is the same one that is part of
	the systemRoot."

	aMagmaCollection changes collectionLoid: (self oidFor: aMagmaCollection).
	largeCollections add: aMagmaCollection.
	transaction monitorLargeCollectionChanges: aMagmaCollection changes
! !

!MagmaSession methodsFor: 'large collections' stamp: 'cmm 7/18/2002 18:05'!
numberOfEntriesFrom: lowKey to: highKey in: aMagmaCollection on: attributeSymbol

	^facade
		numberOfEntriesFrom: lowKey
		to: highKey
		in: (self oidFor: aMagmaCollection)
		on: attributeSymbol
! !

!MagmaSession methodsFor: 'large collections' stamp: 'cmm 7/18/2002 18:06'!
occurrencesOf: anObject in: aMagmaCollection

	^facade
		numberOfEntriesFrom: (self oidFor: anObject)
		to: (self oidFor: anObject)
		in: (self oidFor: aMagmaCollection)
		on: nil
! !

!MagmaSession methodsFor: 'large collections' stamp: 'cmm 7/18/2002 18:06'!
upTo: anInteger objectsIn: aMagmaCollection fromIndex: startIndex on: aMaIndexDefinition using: aMaReadStrategy
	"Answer a MaCollectionSegment or aMaIndexedCollectionSegment."

	| segmentResult indexAttribute |

	indexAttribute _ aMaIndexDefinition notNil ifTrue: [ aMaIndexDefinition attribute ].
	segmentResult _
		facade
			upTo: anInteger
			objectsIn: (self oidFor: aMagmaCollection)
			fromIndex: startIndex
			on: indexAttribute
			using: aMaReadStrategy.
	self materializeObjectsIn: segmentResult.
	aMaIndexDefinition notNil
		ifTrue:
			[ segmentResult
				lowKey: (aMaIndexDefinition indexHashFor: segmentResult firstCachedElement);
				highKey: (aMaIndexDefinition indexHashFor: segmentResult lastCachedElement) ].
	^segmentResult
! !

!MagmaSession methodsFor: 'large collections' stamp: 'cmm 7/18/2002 18:06'!
upTo: anInteger objectsIn: aMagmaCollection fromKey: lowKey to: highKey on: aMaIndexDefinition using: aMaReadStrategy

	| segment |

	segment _
		facade
			upTo: anInteger
			objectsIn: (self oidFor: aMagmaCollection)
			fromKey: lowKey
			to: highKey
			on: aMaIndexDefinition attribute
			using: aMaReadStrategy.
	self materializeObjectsIn: segment.
	segment isEmpty
		ifFalse:
			[ segment
				lowKey: (aMaIndexDefinition indexHashFor: segment firstCachedElement);
				highKey: (aMaIndexDefinition indexHashFor: segment lastCachedElement) ].
	^segment
! !

!MagmaSession methodsFor: 'read strategies'!
readDeep

	self readStrategy: MaBasicReadStrategy deep
! !

!MagmaSession methodsFor: 'read strategies'!
readDefault

	self initializeReadStrategy
! !

!MagmaSession methodsFor: 'read strategies' stamp: 'cmm 4/24/2002 23:41'!
readStrategy
	"This is the current readStrategy that will be used for proxy materializations.  See MaReadStrategy for more information."

	^readStrategy! !

!MagmaSession methodsFor: 'read strategies'!
readStrategy: aMaReadStrategy
	"Once the readStrategy is set, aMaReadStrategy is converted to use class ids.."

	readStrategy _ aMaReadStrategy makeReadyForUseUsing: self serializer classIdManager
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 7/16/2002 00:16'!
abort

	"This guard is needed for when we initially connect to the repository because we can't abort before the connection is made."
	self isConnected
		ifTrue:
			[ preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
				ifTrue: [ transaction restore ].
			self refresh ]
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 7/16/2002 00:16'!
begin

	preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
		ifTrue:
			[ transaction restore ].
	self refreshViewUsing: facade newTransaction
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 6/28/2002 00:14'!
commit

	| commitPackage commitResult |

	commitPackage _ self newCommitPackageFor: transaction.
	commitResult _ facade submitAll: commitPackage.
	commitResult hasConflicts not ifTrue: [ transaction backupChangedObjects ].
	commitPackage hasNewIndexes
		ifTrue:
			[ | backupPackage |
			backupPackage _ commitPackage copyWithNewLargeCollectionChanges.
			self refreshViewUsing: commitResult.
			backupPackage newIndexesDo:
				[ :eachCollection :eachIndexes |
				eachCollection buildIndexes: eachIndexes ] ]
		ifFalse:
			[ self refreshViewUsing: commitResult ].
	^commitResult
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 6/24/2002 23:54'!
commit: aBlock

	self begin.
	aBlock value.
	^self commit
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 7/16/2002 22:03'!
commitCleanTransaction

	self maMarked: 'dev'.
	"You need to implement clean transactions once you figure out whether they make any practical sense.."
	self refreshViewUsing: (self submitAllReadAndChangedDuring: transaction).

! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/29/2002 01:01'!
anchor

	^self materializeObject: self anchorBuffer
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/30/2002 22:46'!
anchorBuffer

	^facade anchorBuffer
! !

!MagmaSession methodsFor: 'private'!
assignPermanentLoidsFrom: aMaRefreshViewResult

	self serializer assignPermenantLoidsFrom: aMaRefreshViewResult permanentLoids.
	aMaRefreshViewResult permanentLoids do:
		[ :each | | persistentObject |
		(persistentObject _
			self serializer
				objectWithOid: each
				ifAbsent: [ nil ])
					notNil
						ifTrue:
							[ transaction markRead: persistentObject ] ]
! !

!MagmaSession methodsFor: 'private'!
dontRefresh: anObject

	"Used only during creation of the initial repository.  Should not be used
	by applications."

	transaction forceBackup: anObject
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/1/2002 00:54'!
facade: MaRepositoryControllerFacade

	facade _ MaRepositoryControllerFacade
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/17/2002 23:20'!
getRepositoryController
	"This method should only be needed when you want to have multiple sessions in the same image accessing the same repository.  This situation is NOT part of the Magma unit tests, so use at your own risk."

	^facade getRepositoryController
! !

!MagmaSession methodsFor: 'private'!
id

	^id! !

!MagmaSession methodsFor: 'private'!
id: anInteger

	id _ anInteger
! !

!MagmaSession methodsFor: 'private'!
imageDefinitionIncludesLargeCollection: aMagmaCollection

	^largeCollections includes: aMagmaCollection
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/16/2002 00:19'!
initialize

	super initialize.
	transaction _ MaTransaction session: self.
	preferences _ MagmaPreferences new.
	self
		initializeSerializer;
		initializeReadStrategy
! !

!MagmaSession methodsFor: 'private'!
initializeReadStrategy

	self readStrategy: MaBasicReadStrategy default
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/25/2002 00:01'!
initializeSerializer

	serializer _
		(MaObjectSerializer new: 100000)
			toCreateProxies:
				[ :oid |
				MaOdbmsProxy
					session: self
					oid: oid ];
			classIdManager: MaOdbmsClassIdManager new.
	serializer traversalStrategy
		traverseWhen:
			[ :path :parent :index |
			path last maIsImmutableInBuffer not and:
				[ path size <= 2 "we only need capture the first level, but don't forget the dummy OC container!!"
					or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ];
		valueWhen:
			[ :path :parent :index |
			path size <= 2 or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ]
! !

!MagmaSession methodsFor: 'private'!
largeCollections: aSet
	"When we serialize changed objects, we add any LargeCollections
	we encounter directly to the sessions allLargeCollections Set, which
	is the same set referenced by the MaStorageForObjectRepository.
	If it is truly a new LargeCollection, the Set will be recognized as
	changed and will get committed."

	largeCollections _ aSet
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/18/2002 00:02'!
loadClassDefinitionsFrom: aByteArray

	| classDefinitions |

	self validateClassDefinitions: (classDefinitions _ self materializeObject: aByteArray).
	self serializer classDefinitions: classDefinitions
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/29/2002 01:06'!
loadClassesSetFrom: aByteArray

	self serializer classesSet: (self materializeObject: aByteArray)
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/29/2002 01:01'!
loadLargeCollectionsFrom: aByteArray

	self largeCollections: (self materializeObject: aByteArray)
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/29/2002 01:05'!
materialize: aByteArray

	^self materializeObject: aByteArray
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/29/2002 01:00'!
materializeObject: aByteArray

	self serializer byteArray: aByteArray.
	^transaction markRead: (
		self serializer materializeGraphDo:
			[ :each | each maIsBufferedObjectProxy 
				ifFalse: 
					[ transaction markRead: each.
					each maPostmaterialize ] ])
! !

!MagmaSession methodsFor: 'private'!
materializeObjectsIn: aMaCollectionSegment

	aMaCollectionSegment objects doWithIndex:
		[ :eachBuffer :index |
		aMaCollectionSegment objects
			at: index
			put: (self materialize: eachBuffer) ]
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/13/2002 00:05'!
materializedObject

	^transaction markRead: (
		self serializer materializeGraphDo:
			[ :each | each maIsBufferedObjectProxy 
				ifFalse: 
					[ transaction markRead: each.
					each maPostmaterialize ] ])
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 2/11/2002 00:55'!
moveChangesToClassesSetToFrontIn: changedObjects
	"This is necessary to handle the scenario where another client has added
	an instance of a new class and has also changed an object reference
	present in *this* image to point to a new instance of that class.  In
	that scenario, when this client refreshes, unless the refresh of the classesSet
	occurs first, it will not be able to refresh the instance of the new class because
	it won't have been defined in the classIdManager.  Remember, when adding
	it to the classesSet, it will be a proxy (which cannot respond to hash) which
	will cause it to go get the real class, causing it to then be defined in the
	classIdManager."

	| classesSetIndex classesSetLoid |

	classesSetLoid _ self serializer classesSetOid.
	changedObjects doWithIndex:
		[ :each :index | each mainOid = classesSetLoid ifTrue: [ classesSetIndex _ index ] ].
	classesSetIndex notNil
		ifTrue:
			[ changedObjects addFirst: (changedObjects removeAt: classesSetIndex) ]
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/8/2002 13:36'!
newCommitPackageFor: aMaTransaction
	"It is possible to that we will serialize up to three times.  If we add a new LargeCollection that 
also adds instances of a new class, the first serialization will detect the new LargeCollection, the second notices the new classes, the third gets everything right.."

	| commitPackage mustReserialize |

	commitPackage _ aMaTransaction changedObjects.
	mustReserialize _ commitPackage serializeObjectsUsing: self.
	^mustReserialize
		ifTrue:
			[ self newCommitPackageFor: aMaTransaction ]
		ifFalse:
			[ commitPackage ]
! !

!MagmaSession methodsFor: 'private'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^oneArgBlock value: (
		self serializer
			objectWithOid: anInteger
			ifAbsent: [ ^aBlock value ])
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/30/2002 22:46'!
realObjectFor: oid

	^self materialize: (facade byteArrayFor: oid)
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/24/2002 23:54'!
refresh

	self refreshViewUsing: facade abortTransaction
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 6/29/2002 16:34'!
refreshAll: changedObjects
	"changedObjects is a collection of MaObjectLinks.  For each one that the receiver
	still has its mainOid, set all of its instVars to the proper objects according to its
	connectedOids.  If a connectedOid is no longer in the client, substitute with a proxy."

	| needToRehash |

	needToRehash _ false.
	self moveChangesToClassesSetToFrontIn: changedObjects.
	changedObjects do:
		[ :each |
		self
			objectWithOid: each mainOid
			ifFound:
				[ :object |
				object
					maRefreshTo: each
					using: self.
				transaction markRead: object.
				(object class methodDictionary includesKey: #hash) ifTrue: [ needToRehash _ true ] ]
			ifAbsent: [ "do nothing" ] ].
	needToRehash ifTrue: [ self rehashForRefresh ]
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/7/2002 22:10'!
refreshViewUsing: aMaRefreshViewResult

	aMaRefreshViewResult permanentLoids notNil
		ifTrue:
			[ self assignPermanentLoidsFrom: aMaRefreshViewResult ].
	self refreshAll: aMaRefreshViewResult toBeRefreshed.
	serializer materializeAllClassDefinitions.
	transaction largeCollectionChanges 
		do: 
			[ :each | 
			each reset.  
			each collection resetSegment ]
! !

!MagmaSession methodsFor: 'private'!
rehashForRefresh

	"Transactions must be done first if you expect isPersistent
	to work correctly."

	transaction rehashPersistentCollections.
	self serializer rehashForRefresh
! !

!MagmaSession methodsFor: 'private'!
serializer

	^serializer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/30/2002 22:46'!
sizeOfLargeCollection: aMagmaCollection

	^facade sizeOfLargeCollection: aMagmaCollection
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/30/2002 22:45'!
submitAllReadAndChangedDuring: aMaTransaction
	"Prepare and send aMaCommitPackage to the repository for committal.
	If any there are any new classes in this commitPackage, they will
	get added *during* the serialization process, not before.  So if we added new
	classes, we have to re-serialize again to make sure we got them all."

	| numberOfClassesBefore numberOfClassesAfter commitPackage hasNewLargeCollections |

	numberOfClassesBefore _ self serializer classIdManager numberOfClasses.
	commitPackage _ aMaTransaction readAndChangedObjects.
	hasNewLargeCollections _ commitPackage serializeObjectsUsing: self serializer.
	numberOfClassesAfter _ self serializer classIdManager numberOfClasses.
	(hasNewLargeCollections or: [ numberOfClassesAfter > numberOfClassesBefore ])
		ifTrue:
			[ commitPackage _
				aMaTransaction readAndChangedObjects serializeObjectsUsing: self serializer ].
	^facade submitAll: commitPackage
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 7/18/2002 00:02'!
validateClassDefinitions: aDictionary

	aDictionary do:
		[ :eachColl |
		(eachColl last hasSameDefinitionAs: eachColl last classObject)
			ifFalse:
				[ MagmaClassConflictNotification signal:
					eachColl last className ,
						' in this image does not have the same definition as the latest version defined in this repository.' ] ]
! !


!MagmaSession class methodsFor: 'creation' stamp: 'cmm 4/8/2002 23:22'!
hostAddress: aByteArray port: anInteger

	| newSession |
	^(newSession _ self new) facade: 
		(MaRepositoryControllerFacade
			session: newSession
			link:
				(MaRemoteServerLink
					hostAddress: aByteArray
					port: anInteger
					bufferSize: 2000000))
! !

!MagmaSession class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:52'!
magmaVersion

	^1! !


!MagmaClassConflictNotification methodsFor: 'framework' stamp: 'cmm 7/17/2002 23:47'!
defaultAction

	^(PopUpMenu labels: ' OK ') startUpWithCaption: self message! !

!MagmaClassConflictNotification methodsFor: 'framework' stamp: 'cmm 7/18/2002 00:01'!
isResumable

	^true! !

!MagmaClassConflictNotification methodsFor: 'private' stamp: 'cmm 7/17/2002 23:50'!
initialize

	conflictingDefinitions _ OrderedCollection new! !

!MagmaClassConflictNotification methodsFor: 'accessing' stamp: 'cmm 7/17/2002 23:57'!
message

	| stream |
	stream _ (WriteStream on: String new)
		nextPutAll: 'This repository defines the following classes as follows.  Your definitions are either different or missing, making reliable access to this repository impossible.  You must define these classes as follows to connect to this repository:'.
	conflictingDefinitions do:
		[ :each |
		stream
			cr; tab;
			nextPutAll: each className;
			space;
			nextPutAll: each maAllInstVarNames printString ].
	^stream contents! !

!MagmaClassConflictNotification methodsFor: 'building' stamp: 'cmm 7/17/2002 23:51'!
addConflict: aMaOdbmsClassDefinition

	conflictingDefinitions add: aMaOdbmsClassDefinition! !


!MagmaClassConflictNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 7/17/2002 23:49'!
new

	^super new initialize! !


!SequenceableCollection methodsFor: 'testing'!
maIsChangedFrom: anotherCollection

	self size ~= anotherCollection size ifTrue: [ ^true ].
	1
		to: self size
		do: [ :index | (self at: index) ~~ (anotherCollection at: index) ifTrue: [ ^true ] ].
	^false
! !


!ArrayedCollection methodsFor: 'building' stamp: 'cmm 3/4/2002 00:11'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession

	aMaObjectLinkDescription linkedOids doWithIndex:
		[ :eachOid :eachIndex |
		self
			at: eachIndex
			put: (
				aMagmaSession serializer
					objectWithOid: eachOid
					ifAbsent: [ aMagmaSession serializer proxyFor: eachOid ]) ]
! !

!ArrayedCollection methodsFor: 'building'!
maRestoreFrom: anArrayedCollection

	anArrayedCollection doWithIndex:
		[ :each :eachIndex |
		self
			at: eachIndex
			put: each ]
! !


!ByteArray methodsFor: 'building' stamp: 'cmm 3/4/2002 00:12'!
maRefreshTo: aMaByteObjectLinkDescription using: aMagmaSession

	1
		to: self size
		do:
			[ :index |
			self
				at: index
				put: (aMaByteObjectLinkDescription bytes at: index) ]
! !

!ByteArray methodsFor: 'testing'!
maIsChangedFrom: aByteArray

	^self ~= aByteArray
! !

!ByteArray methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:55'!
maIsImmutable

	^self size = 0
! !


!CompiledMethod methodsFor: 'testing' stamp: 'cmm 2/23/2002 16:36'!
maIsImmutable

	^true
! !


!Interval methodsFor: 'building' stamp: 'cmm 3/4/2002 00:18'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession
	"Duplicate implementation from Object."

	1
		to: self maInstSize
		do:
			[ :instVarIndex | | oid |
			self
				instVarAt: instVarIndex
				put: (
					aMagmaSession serializer
						objectWithOid: (oid _ aMaObjectLinkDescription linkedOids at: instVarIndex)
						ifAbsent: [ aMagmaSession serializer proxyFor: oid ]) ]
! !

!Interval methodsFor: 'building'!
maRestoreFrom: anObject
	"Duplicate implementation from Object."

	1
		to: self maInstSize
		do:
			[ :instVarIndex |
			self
				instVarAt: instVarIndex
				put: (anObject instVarAt: instVarIndex) ]
! !


!Set methodsFor: 'testing'!
maIsChangedFrom: anotherCollection

	^(self maConsistsOf: anotherCollection) not
! !


!Dictionary methodsFor: 'testing'!
maIsChangedFrom: anotherDictionary

	self size = anotherDictionary size ifFalse: [ ^true ].
	self keysAndValuesDo:
		[ :eachKey :eachValue |
		(anotherDictionary includesKey: eachKey) ifFalse: [ ^true ].
		(anotherDictionary at: eachKey) == eachValue ifFalse: [ ^true ] ].
	^false
! !

!Dictionary methodsFor: 'building' stamp: 'cmm 3/30/2002 21:21'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession
	"The linkedOids in aMaObjectLinkDescription are in key->value pairs."

	| hasProxies aUniqueObject |
	aUniqueObject _ ''.
	hasProxies _ false.
	1
		to: aMaObjectLinkDescription linkedOids size
		by: 2
		do:
			[ :eachLoid |
			(aMagmaSession serializer
				objectWithOid: eachLoid
				ifAbsent: [ aUniqueObject ]) == aUniqueObject
					ifTrue: [ hasProxies _ true ] ].
	hasProxies
		ifTrue:
			[ aMagmaSession readStrategy: (MaBasicReadStrategy minimumDepth: 2).
			aMagmaSession realObjectFor: (aMagmaSession oidFor: self) ].
	self keysAndValuesRemove: [ :k :v | true ].
	1
		to: aMaObjectLinkDescription linkedOids size
		by: 2
		do:
			[ :eachKeyIndex | | eachKey eachValue transformationBlock |
			eachKey _ aMaObjectLinkDescription linkedOids at: eachKeyIndex.
			eachValue _ aMaObjectLinkDescription linkedOids at: eachKeyIndex + 1.
			transformationBlock _
				[ :oid |
					aMagmaSession serializer
						objectWithOid: oid
						ifAbsent: [ aMagmaSession serializer proxyFor: oid ] ].
			self
				at: (transformationBlock value: eachKey)
				put: (transformationBlock value: eachValue) ]
! !

!Dictionary methodsFor: 'building' stamp: 'cmm 5/29/2002 00:42'!
maRestoreFrom: aDictionary

	self keysAndValuesRemove: [ :k :v | true ].
	aDictionary keysAndValuesDo:
		[ :eachKey :eachValue |
		self
			at: eachKey
			put: eachValue ]
! !


!SortedCollection methodsFor: 'testing'!
maIsChangedFrom: anotherCollection

	self sortBlock ~~ anotherCollection sortBlock ifTrue: [ ^true ].
	^super maIsChangedFrom: anotherCollection
! !

!SortedCollection methodsFor: 'building' stamp: 'cmm 7/16/2002 22:14'!
maPreserialize
	"Can't store blocks until VI4.."

	self sortBlock: nil! !


!String methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:54'!
maIsImmutable

	^self size = 0
! !

!String methodsFor: 'building' stamp: 'cmm 1/25/2002 00:35'!
maIsChangedFrom: anotherString

	^self ~= anotherString
! !

!String methodsFor: 'building' stamp: 'cmm 3/4/2002 00:36'!
maRefreshTo: aMaByteObjectLinkDescription using: aMagmaSession

	1
		to: self size
		do:
			[ :index |
			self
				at: index
				put: (Character value: (aMaByteObjectLinkDescription bytes at: index)) ]
! !


!Symbol methodsFor: 'testing'!
maIsChangedFrom: aSymbol

	"Symbols cannot be changed."

	^false
! !

!Symbol methodsFor: 'testing'!
maIsImmutable

	^true
! !

!Symbol methodsFor: 'building' stamp: 'cmm 7/11/2002 00:28'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession
	"Never try to refresh a Symbol.  They cannot change."
! !


!MagmaClassConflictNotification reorganize!
('framework' defaultAction isResumable)
('private' initialize)
('accessing' message)
('building' addConflict:)
!


!MagmaSession class reorganize!
('creation' hostAddress:port: openLocal: repositoryController:)
('accessing' magmaVersion)
!


!MagmaSession reorganize!
('accessing' isPersistent: objectWithOid:ifAbsent: oidFor: preferences preferences: root)
('connections' closeRepository connectAs: connectAs:maximumNumberOfChallengers: disconnect isConnected)
('initializing' root:)
('large collections' addLargeCollection: numberOfEntriesFrom:to:in:on: occurrencesOf:in: upTo:objectsIn:fromIndex:on:using: upTo:objectsIn:fromKey:to:on:using:)
('read strategies' readDeep readDefault readStrategy readStrategy:)
('transactions' abort begin commit commit: commitCleanTransaction)
('private' anchor anchorBuffer assignPermanentLoidsFrom: dontRefresh: facade: getRepositoryController id id: imageDefinitionIncludesLargeCollection: initialize initializeReadStrategy initializeSerializer largeCollections: loadClassDefinitionsFrom: loadClassesSetFrom: loadLargeCollectionsFrom: materialize: materializeObject: materializeObjectsIn: materializedObject moveChangesToClassesSetToFrontIn: newCommitPackageFor: objectWithOid:ifFound:ifAbsent: realObjectFor: refresh refreshAll: refreshViewUsing: rehashForRefresh serializer sizeOfLargeCollection: submitAllReadAndChangedDuring: upgradeMagmaPerson validateClassDefinitions:)
!

MagmaPreferences initialize!

!MagmaPreferences reorganize!
('accessing' refreshPersistentObjectsEvenWhenChangedOnlyByMe refreshPersistentObjectsEvenWhenChangedOnlyByMe:)
('initializing' initialize)
!


!MagmaCommitConflict class reorganize!
('creation' connection:)
!


!MagmaCommitConflict reorganize!
('accessing' conflictingObjects conflictingOids connection userId)
('initializing' initialize)
('private' addConflictingOid: connection: initializeConflictingObjectsUsing:)
!

MagmaCollectionReader removeSelector: #copyFrom:to:!
MagmaCollectionReader removeSelector: #copyFrom:to:using:!
MagmaCollectionReader removeSelector: #copyFromKey:to:!

!MagmaCollectionReader reorganize!
('accessing' at: collection index pageSize: size)
('enumerating' slowlyDo:commitEvery: slowlyDo:refreshEvery:)
('testing' isEmpty)
('private' absoluteHighIndex: absoluteIndexFor: absoluteLowIndex: collection: index: loadSegmentFrom: mergeAdditions postInitialize readStrategy: segment segment: session)
!

MagmaCollection initialize!
MagmaCollection removeSelector: #copyFromKey:to:named:!
MagmaCollection removeSelector: #copyFromKey:to:named:using:!

!MagmaCollection reorganize!
('accessing' occurrencesOf: sampleArray size)
('add / remove' add: addAll: canAdd: remove:)
('enumerating' slowlyDo:commitEvery: slowlyDo:refreshEvery:)
('indexing' addIndex: asSortedReaderOn: asSortedReaderOn:using: canIndex: indexNamed: read:from:to: read:from:to:using: removeIndexOn:)
('options' pageSize:)
('testing' includes: isEmpty notEmpty)
('initializing' initialize initializeChanges initializeSegment initializeTransients)
('private' at: buildIndexes: changes changes: hasChanges indexes maIsLargeCollection maPopulateUsing: readerFrom:to:on:readStrategy: resetSegment segment segment: segmentFromIndex:on:pageSize: segmentFromIndex:on:pageSize:using: segmentFromKey:to:on:pageSize:using: session session: setLoid:)
!


!MaRepositoryControllerFacade reorganize!
('accessing' anchorBuffer byteArrayFor: numberOfEntriesFrom:to:in:on: sizeOfLargeCollection: upTo:objectsIn:fromIndex:on:using: upTo:objectsIn:fromKey:to:on:using:)
('actions' abortTransaction connectAs:maximumNumberOfChallengers: newTransaction submitAll:)
('initializing' disconnect initializeRequestPrototypesWithSessionId: link: session:)
('private' abortTransactionRequest anchorRequest connectionRequest disconnectRequest getRepositoryController keyIntervalInfoRequest largeCollectionSizeRequest readRequest requestPrototypes segmentByIndexRequest segmentByKeyRequest submitRequest transactionRequest upgradeMagmaPerson)
!


!MaFailedCommitResult reorganize!
('converting' asFailedResult)
('accessing' commitConflicts conflictMessage dirtyReads)
('testing' hasConflicts)
('initializing' initialize)
('building' recordDirtyReadWith:on: recordObjectConflictWith:on:)
('as yet unclassified' populateConflictingObjectsFromOidsUsing:)
!

MaOdbmsClassIdManager initialize!

!MaCollectionSegment reorganize!
('accessing' at: firstCachedElement lastCachedElement lastKnownSize objects pageSize startIndex startingPageIndexFor:)
('building' lastKnownSize: loadFrom: objects: pageSize: startIndex:)
('testing' includes: includesIndex: isEmpty)
('private' high initializeCollection isLoaded low remoteHigh reset)
!

MaBasicReadStrategy initialize!
"Postscript:
"
MagmaCollection initialize.
MaBasicReadStrategy initialize.
MaOdbmsClassIdManager initialize.
MagmaPreferences initialize!

