'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 1 August 2002 at 7:10:35 pm'!
"Change Set:		MagmaTester
Date:			28 July 2002
Author:			Chris Muller

This change set tests functionality of Magma, an object database."!

MaObject subclass: #MaDeltaObject
	instanceVariableNames: 'comparator buffer1 buffer2 object1 object2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaTestCase subclass: #MaHashIndexRecordTester
	instanceVariableNames: 'currentRecordLevel records '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaTestCase subclass: #MaHashIndexTester
	instanceVariableNames: 'oids nextOid sortedKeys predictedSize index '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaObject subclass: #MaObjectGraphComparer
	instanceVariableNames: 'serializer1 serializer2 object1 object2 buffers1 buffers2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!

!MaObjectGraphComparer commentStamp: '<historical>' prior: 0!
Attempts to compare two object graphs to see if they match.  Not perfect.!

MaRepositoryRequest subclass: #MaUpgradeMagmaPersonRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
Magnitude subclass: #MagmaCalendarTime
	instanceVariableNames: 'date time milliseconds '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!

!MagmaCalendarTime commentStamp: '<historical>' prior: 0!
I represent a calendar time; either a duration represented in units of a Gregorian calendar (days, hours, minutes, seconds, etc.) or a point on the timeline of the Gregorian calendar.

I support full arithmetic with other CalendarTimes and Integers as it makes sense.  For example, dividing 30 minutes by 3 makes sense, but not May 19th, 1969.

I have fairly efficient storage, a single integer of the total number of milliseconds that have elapsed since my base time, 1/1/1901 @ 12:00am.
!

MaSingleton subclass: #MagmaFixtureFactory
	instanceVariableNames: 'allNonCollectionSamples '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaObject subclass: #MagmaMailingAddress
	instanceVariableNames: 'street zip '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaObject subclass: #MagmaOrganization
	instanceVariableNames: 'name address '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaObject subclass: #MagmaPerson
	instanceVariableNames: 'name address spouse birthday '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaObject subclass: #MagmaPersonName
	instanceVariableNames: 'first middle last '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MaNetworkTestCase subclass: #MagmaTestCase
	instanceVariableNames: 'repositoryController clientSession oldVersionTimeStamps testIsOver localRoot magmaServerAddress '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!

!MagmaTestCase commentStamp: '<historical>' prior: 0!
This class tests Magma functionality.
!

MagmaTestCase subclass: #MagmaCollectionTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-SUnit tests'!
MagmaCalendarTime class
	instanceVariableNames: ''!

!MaDeltaObject methodsFor: 'private actions'!
addDifferenceLabeled: aString representative1: repObject1 representative2: repObject2 to: aDictionary

	aDictionary
		at: aString
		put: (
			Array
				with: repObject1
				with: repObject2)
! !

!MaDeltaObject methodsFor: 'private actions'!
addDifferencesIn: attributeSymbol to: aDictionary

	^self
		addDifferencesIn: attributeSymbol
		to: aDictionary
		as: attributeSymbol asString
! !

!MaDeltaObject methodsFor: 'private actions'!
addDifferencesIn: attributeSymbol to: aDictionary as: aString

	| attr1 attr2 |

	(attr1 _ buffer1 perform: attributeSymbol) ~= (attr2 _ buffer2 perform: attributeSymbol)
		ifTrue:
			[ self
				addDifferenceLabeled: aString
				representative1: attr1
				representative2: attr2
				to: aDictionary.
			^true ].
	^false
! !

!MaDeltaObject methodsFor: 'accessing'!
buffer1

	^buffer1! !

!MaDeltaObject methodsFor: 'accessing'!
buffer2

	^buffer2! !

!MaDeltaObject methodsFor: 'accessing'!
object1

	^object1! !

!MaDeltaObject methodsFor: 'accessing'!
object2

	^object2! !

!MaDeltaObject methodsFor: 'building'!
buffer1: aMaObjectBuffer

	buffer1 _ aMaObjectBuffer
! !

!MaDeltaObject methodsFor: 'building'!
buffer2: aMaObjectBuffer

	buffer2 _ aMaObjectBuffer
! !

!MaDeltaObject methodsFor: 'building'!
object1: anObject

	object1 _ anObject
! !

!MaDeltaObject methodsFor: 'building'!
object2: anObject

	object2 _ anObject
! !

!MaDeltaObject methodsFor: 'private building'!
comparator: aMaObjectGraphComparer

	comparator _ aMaObjectGraphComparer
! !

!MaDeltaObject methodsFor: 'private accessing' stamp: 'cmm 4/21/2002 23:11'!
differences

	| differences class1 class2 |

	differences _ Dictionary new.
	(buffer1 isNil or: [ buffer2 isNil ])
		ifTrue:
			[ self
				addDifferenceLabeled: 'presence'
				representative1: buffer1
				representative2: buffer2
				to: differences ].
	(self
		addDifferencesIn: #class
		to: differences
		as: 'bufferType')
			ifTrue:
				[ ^differences "no point in comparing any further if these are different" ].
	self
		addDifferencesIn: #physicalSize
			to: differences;
		addDifferencesIn: #logicalSize
			to: differences.
	class1 _ comparator serializer1 classIdManager classForId: buffer1 classId.
	class2 _ comparator serializer2 classIdManager classForId: buffer2 classId.
	class1 = class2
		ifFalse:
			[ self
				addDifferenceLabeled: 'class'
				representative1: class1
				representative2: class2
				to: differences.
			^differences "no point in continuing.." ].
	buffer1 isNormalObjectBuffer
		ifTrue:
			[ class1 "like I said, we know class1=class2 at this point.."
				maAddDataDifferencesBetween: buffer1
				and: buffer2
				to: differences
				using: comparator ]
		ifFalse:
			[ "byteObjectBuffers have no need to detail the comparisons, as the
			receiver already has object1 and object2" ].
	^differences
! !

!MaDeltaObject methodsFor: 'testing'!
hasDifferences

	(self buffer1 isNil or: [ self buffer2 isNil ]) ifTrue: [ ^true ].
	^self differences notEmpty
! !


!MaHashIndex methodsFor: 'debugging'!
upTo: countInteger keysFrom: startKey

	| result answerIndex |

	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 1.
	self
		entriesFrom: startKey
		do:
			[ :currentRecord :index :level |
			(currentRecord hasEntryAtByteArrayIndex: index)
				ifTrue:
					[ result
						at: answerIndex
						put: (currentRecord keyAtByteArrayIndex: index).
					answerIndex _ answerIndex + 1 ] ]
		until: [ :currentRecord :index :level | answerIndex > countInteger ].
	"Need to check in case of a small index (say only 9 entries?)."
	^answerIndex < countInteger
		ifTrue:
			[ result
				copyFrom: 1
				to: answerIndex - 1 ]
		ifFalse:
			[ result ]
! !


!MaHashIndexRecord methodsFor: 'accessing'!
numberOfEntries

	^numberOfEntries
! !


!MaHashIndexRecordTester methodsFor: 'initializing'!
initialize

	super initialize.
	currentRecordLevel _ 1.
	records _ ((1 to: 25) collect: [ :each | self newHashIndexRecord ])
! !

!MaHashIndexRecordTester methodsFor: 'private actions'!
navigateRecordsFrom: startRecord toLevel: maxLevel do: oneArgBlock until: conditionBlock
	"We start at the first record in the 'records' fixture, each of its children
	is records at: 2, it's children records at: 3, etc."

	| level traversalBlock |

	level _ 1.
	records
		at: 1
		put: startRecord.
	traversalBlock _
		[ :currentRecord |
			level <= maxLevel
				ifTrue:
					[ oneArgBlock value: currentRecord.
					0
						to: currentRecord numberOfEntries - 1
						do:
							[ :entryIndex |
							(conditionBlock
								value: level
								value: currentRecord)
									ifFalse:
										[ level _ level + 1.
										(records at: level)
											beFrom: (currentRecord lowestKeyAtIndex: entryIndex)
											to: (currentRecord highestKeyAtIndex: entryIndex).
										traversalBlock value: (records at: level) ] ] ].
			level _ level - 1 ].
	traversalBlock value: (records at: 1)
! !

!MaHashIndexRecordTester methodsFor: 'creation'!
newHashIndexRecord

	^(MaHashIndexRecord
		keySize: 64
		numberOfEntries: 100)
			beFrom: 0
			to: (2 raisedTo: 64) - 1
! !

!MaHashIndexRecordTester methodsFor: 'creation' stamp: 'cmm 1/27/2002 23:13'!
newHighKeyRecord

	^self
		newRecordFrom: 18446744073709551615 - 10000
		to: 18446744073709551615
! !

!MaHashIndexRecordTester methodsFor: 'creation' stamp: 'cmm 1/27/2002 23:12'!
newLowKeyRecord

	^self
		newRecordFrom: 0
		to: (2 raisedTo: 64) - 1.
! !

!MaHashIndexRecordTester methodsFor: 'creation' stamp: 'cmm 1/27/2002 23:12'!
newMidKeyRecord

	^self
		newRecordFrom: 13281655733070877164
		to: 13466123173807972679
! !

!MaHashIndexRecordTester methodsFor: 'private creation'!
newRecordFrom: lowKey to: highKey

	^(MaHashIndexRecord
		keySize: 64
		numberOfEntries: 100)
			beFrom: lowKey
			to: highKey
! !

!MaHashIndexRecordTester methodsFor: 'tests' stamp: 'cmm 4/17/2002 23:38'!
testHighKeyRecords

	self verifyRecord: self newHighKeyRecord
! !

!MaHashIndexRecordTester methodsFor: 'tests' stamp: 'cmm 4/17/2002 23:39'!
testLowKeyRecords

	self verifyRecord: self newLowKeyRecord
! !

!MaHashIndexRecordTester methodsFor: 'tests' stamp: 'cmm 4/17/2002 23:39'!
testMidKeyRecords

	self verifyRecord: self newMidKeyRecord
! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 4/17/2002 23:36'!
verifyConsecutiveContiguousKeyRangesOn: aMaHashIndexRecord

	0
		to: aMaHashIndexRecord numberOfEntries - 2
		do:
			[ :index |
			self should:
				[ aMaHashIndexRecord canHoldDuplicateKeys
					ifTrue:
						[
						((aMaHashIndexRecord lowestKeyAtIndex: index + 1) -
							(aMaHashIndexRecord highestKeyAtIndex: index))
								between: 0
								and: 1 ]
					ifFalse:
						[
						((aMaHashIndexRecord lowestKeyAtIndex: index + 1) -
							(aMaHashIndexRecord highestKeyAtIndex: index)) = 1 ] ] ]
! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 4/17/2002 23:37'!
verifyEntryIndexAndRangeEndpointCongruenceOn: aMaHashIndexRecord

	0
		to: aMaHashIndexRecord numberOfEntries - 1
		do:
			[ :index |
			self should:
				[ | key |
				index
					between: (
						aMaHashIndexRecord
							entryIndexFor: (key _ aMaHashIndexRecord lowestKeyAtIndex: index))
					and: (aMaHashIndexRecord highestEntryIndexFor: key) ].
			self should:
				[ | key |
				index
					between: (
						aMaHashIndexRecord
							entryIndexFor: (key _ aMaHashIndexRecord highestKeyAtIndex: index))
					and: (aMaHashIndexRecord highestEntryIndexFor: key) ] ]
! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 4/17/2002 23:38'!
verifyRecord: aMaHashIndexRecord

	| numberOfRecordsTested |
	numberOfRecordsTested _ 0.
	self
		navigateRecordsFrom: aMaHashIndexRecord
		toLevel: 11
		do:
			[ :currentRecord |
			self
				verifyConsecutiveContiguousKeyRangesOn: currentRecord;
				verifyEntryIndexAndRangeEndpointCongruenceOn: currentRecord ]
		until: [ :level :currentRecord | (numberOfRecordsTested _ numberOfRecordsTested + 1) >= 5000 ].
	numberOfRecordsTested _ 0.
	self
		navigateRecordsFrom: aMaHashIndexRecord
		toLevel: 3
		do:
			[ :currentRecord |
			self
				verifyConsecutiveContiguousKeyRangesOn: currentRecord;
				verifyEntryIndexAndRangeEndpointCongruenceOn: currentRecord ]
		until: [ :level :currentRecord | (numberOfRecordsTested _ numberOfRecordsTested + 1) >= 5000 ]
! !


!MaHashIndexTester methodsFor: 'private actions'!
addKey: keyInteger

	| oid |

	self index
		add: (oid _ self getNextOid)
		at: keyInteger.
	sortedKeys add: keyInteger.
	(oids
		at: keyInteger
		ifAbsentPut: [ OrderedCollection new ])
			add: oid.
	predictedSize _ predictedSize + 1.
	^oid
! !

!MaHashIndexTester methodsFor: 'private actions'!
addKeys: anArray

	^anArray collect: [ :each | self addKey: each ]
! !

!MaHashIndexTester methodsFor: 'private actions'!
removeKey: keyInteger

	^self
		removeKey: keyInteger
		at: 1
! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 2/11/2002 00:53'!
removeKey: keyInteger at: anInteger

	self index
		remove: ((oids at: keyInteger) removeAt: anInteger)
		at: keyInteger.
	sortedKeys remove: keyInteger.
	(self oids at: keyInteger) isEmpty ifTrue: [ self oids removeKey: keyInteger ].
	predictedSize _ predictedSize - 1
! !

!MaHashIndexTester methodsFor: 'private tests'!
addKeysToIndex: anInteger

	| r lowest highest big |

	r _ Random new.
	big _ ((2 raisedTo: 64) - 1).
	highest _ 0.
	lowest _ MaPositive infinity.
	anInteger timesRepeat:
		[ | n |
		n _ (r next * big) asInteger.
		n < lowest ifTrue: [ lowest _ n ].
		n > highest ifTrue: [ highest _ n ].
		self addKey: n ]
! !

!MaHashIndexTester methodsFor: 'private tests'!
verifyIndex

	self
		verifySize;
		verifyKeys;
		verifyKeyValuePairs;
		verifyKeyQuantities;
		verifyIndexPositions
! !

!MaHashIndexTester methodsFor: 'private tests'!
verifyIndexPositions

	| allOids |

	allOids _ self allOids.
	(self index
		upTo: allOids size
		oidsFromIndex: 1)
			maConsistsOf: allOids
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 4/17/2002 23:56'!
verifyInsertionOfDuplicateKey: keyInteger
	"Test the insertion of a many of the same key, requiring the
	receivers index to zoom all the way into that key and getting
	into the inverted records."

	25 timesRepeat: [ self addKey: keyInteger ].
	self should:
		[ (self index
			upTo: 100
			at: keyInteger)
				size = 25 ].
	275 timesRepeat: [ self addKey: keyInteger ].
	self should:
		[ (self index
			upTo: 350
			at: keyInteger)
				size = 300 ]
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 2/11/2002 00:48'!
verifyKeyQuantities

	self should:
		[ sortedKeys maConform: [ :each | (self index occurrencesOf: each) = (oids at: each) size ] ].
	self should:
		[ self index size = (
			self index
				numberOfEntriesFrom: 0
				to: sortedKeys last) ]
! !

!MaHashIndexTester methodsFor: 'private tests'!
verifyKeyValuePairs

	self indexKeys
		with: self indexOids
		do: [ :eachKey :eachOid | self should: [ (oids at: eachKey) includes: eachOid ] ]
! !

!MaHashIndexTester methodsFor: 'private tests'!
verifyKeys

	self should: [ self indexKeys maMatchesElementsOf: sortedKeys ]
! !

!MaHashIndexTester methodsFor: 'private tests'!
verifySize

	^self should: [ self index size = predictedSize ]
! !

!MaHashIndexTester methodsFor: 'private accessing'!
allOids

	^self oids
		inject: OrderedCollection new
		into:
			[ :coll :each |
			coll
				addAll: each;
				yourself ]
! !

!MaHashIndexTester methodsFor: 'private accessing'!
getNextOid

	^nextOid _ nextOid + 1
! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 1/30/2002 12:48'!
index

	^index
! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 4/24/2002 23:23'!
indexFileName

	^self environmentPath, 'test.idx'
! !

!MaHashIndexTester methodsFor: 'private accessing'!
indexKeys

	^self index
		upTo: 2500
		keysFrom: 0
! !

!MaHashIndexTester methodsFor: 'private accessing'!
indexOids

	^self index
		upTo: 2500
		oidsFrom: 0
		to: self index highestPossibleKey
! !

!MaHashIndexTester methodsFor: 'private accessing'!
oids
	"a dictionary, key->#(oids...)"
	^oids! !

!MaHashIndexTester methodsFor: 'private framework' stamp: 'cmm 2/13/2002 00:44'!
setUp

	MaHashIndex allInstances do: [ :each | each close ].
	self deleteFiles.
	index _ self newHashIndex.
	predictedSize _ 0
! !

!MaHashIndexTester methodsFor: 'private framework' stamp: 'cmm 4/16/2002 23:43'!
tearDown

	index ifNotNil: [ index close ]
! !

!MaHashIndexTester methodsFor: 'private initializing'!
deleteFiles

	self deleteFilesNamed: (Array with: self indexFileName)
! !

!MaHashIndexTester methodsFor: 'private initializing'!
initialize

	super initialize.
	oids _ Dictionary new.
	sortedKeys _ SortedCollection new.
	nextOid _ 2 raisedTo: 17  "some arbitrary number"
! !

!MaHashIndexTester methodsFor: 'private creation'!
newHashIndex

	^MaHashIndex
		create: self indexFileName
		keySize: 64
		hashRecordSize: 30
! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 4/17/2002 23:56'!
testInsertionOfEndpointKeys
	"This tests keys that fall at the endpoints of records.
	It covers the lowest and highest keys, 0 and (2^64)-1.
	Two tests cover insertion of these keys when their slots
	are open and when their slots are already filled."

	self
		verifyInsertionOfDuplicateKey: 0;
		verifyInsertionOfDuplicateKey: 184467440737095517; "another test for left-most endpoint"
		verifyInsertionOfDuplicateKey: 368934881474191032; "another right"
		verifyInsertionOfDuplicateKey: 368934881474191033; "left of next"
		verifyInsertionOfDuplicateKey: 184467440737095516; "right of previous"
		verifyInsertionOfDuplicateKey: 36028891097358743;  "right-most endpoint, inclusive key"
		verifyInsertionOfDuplicateKey: 36028889252684335;  "left-most endpoint, inclusive key"
		verifyInsertionOfDuplicateKey: (2 raisedTo: 64) - 1.
	self verifyIndex
! !

!MaHashIndexTester methodsFor: 'tests'!
testKeyInsertionIntoBroadRecords
	"A 'broad' record is one whose key range is greater than its
	numberOfEntries, thus it cannot hold duplicate keys.
	This test adds keys in an order that requires the index to
	re-sequence keys across multiple broad records."

	self
		addKeys: #(500 450 470 550 400);
		verifyIndex;
		removeKey: 500;
		verifyIndex;
		addKey: 455;
		verifyIndex.
	25 timesRepeat: [ self addKey: 470 ].
	25 timesRepeat: [ self addKey: 469 ].
	self verifyIndex.
	1
		to: 25
		do:
			[ :each |
			each even
				ifTrue:
					[ self
						removeKey: 469
						at: each // 2 ] ].
	self verifyIndex
! !

!MaHashIndexTester methodsFor: 'tests'!
testRandomKeyInsertion

	self
		addKeysToIndex: 1000;
		verifyIndex
! !


!MaObjectGraphComparer methodsFor: 'accessing'!
buffers1

	^buffers1! !

!MaObjectGraphComparer methodsFor: 'accessing'!
buffers2

	^buffers2! !

!MaObjectGraphComparer methodsFor: 'accessing'!
serializer1

	^serializer1! !

!MaObjectGraphComparer methodsFor: 'accessing'!
serializer2

	^serializer2! !

!MaObjectGraphComparer methodsFor: 'private testing'!
buffersAreLoaded

	^buffers1 notEmpty
! !

!MaObjectGraphComparer methodsFor: 'initializing'!
differences

	| answer allOids delta |

	answer _ OrderedCollection new.
	allOids _
		buffers1 keys
			addAll: buffers2 keys;
			yourself.
	delta _ MaDeltaObject comparator: self.
	allOids do:
		[ :each |
		buffers1
			maAt: each
			ifPresent:
				[ :buffer |
				delta
					buffer1: buffer;
					object1: (
						serializer1
							objectWithOid: each
							ifAbsent: [ 'not in serializer!!' ]) ]
			ifAbsent:
				[ delta
					buffer1: nil;
					object1: nil ].
		buffers2
			maAt: each
			ifPresent:
				[ :buffer |
				delta
					buffer2: buffer;
					object2: (
						serializer2
							objectWithOid: each
							ifAbsent: [ 'not in serializer!!' ]) ]
			ifAbsent:
				[ delta
					buffer2: nil;
					object2: nil ].
		delta hasDifferences ifTrue: [ answer add: delta copy ] ].
	^answer
! !

!MaObjectGraphComparer methodsFor: 'private actions'!
forceProxyMaterializationBlock
	"Answer a block that will force the materialization of any proxy
	that is used as its valued argument.  No effect for non proxy
	objects.."

	^[ :obj |
		(obj isKindOf: Dictionary)
			ifTrue:
				[ obj keysAndValuesDo:
					[ :eachKey :eachValue |
					eachKey maInstSize.
					eachValue maInstSize ] ]
			ifFalse:
				[ obj maIsCollection
					ifTrue:
						[ obj do: [ :each | each maInstSize ] ]
					ifFalse:
						[ 1
							to: obj maInstSize
							do: [ :index | (obj instVarAt: index) maInstSize ] ] ] ]
! !

!MaObjectGraphComparer methodsFor: 'private actions'!
loadBuffersFrom: aMaSerializedObjectGraph into: aDictionary

	aMaSerializedObjectGraph buffers do:
		[ :each |
		aDictionary
			at: each oid
			put: each ]
! !

!MaObjectGraphComparer methodsFor: 'private actions'!
serialize: anObject using: aMaObjectSerializer

	aMaObjectSerializer
		serializeGraph: anObject
		do: [ :eachInGraph | self forceProxyMaterializationBlock value: eachInGraph ]
! !

!MaObjectGraphComparer methodsFor: 'private initializing' stamp: 'cmm 4/21/2002 23:09'!
initialize

	super initialize.
	serializer1 _ MaObjectSerializer new.
	serializer2 _ MaObjectSerializer new.
	buffers1 _ Dictionary new.
	buffers2 _ Dictionary new
! !

!MaObjectGraphComparer methodsFor: 'testing' stamp: 'cmm 3/4/2002 01:04'!
isPossibleMatch

	^buffers1 size = buffers2 size
		and:
			[ (buffers1 collect: [ :each | serializer1 classIdManager classForId: each classId ])
				maConsistsOf: (buffers2 collect: [ :each | serializer2 classIdManager classForId: each classId ]) ]
! !

!MaObjectGraphComparer methodsFor: 'private building'!
loadBuffers

	self
		loadBuffersFrom: serializer1 graphBuffer
			into: buffers1;
		loadBuffersFrom: serializer2 graphBuffer
			into: buffers2
! !

!MaObjectGraphComparer methodsFor: 'private building'!
object1: anObject

	object1 _ anObject
! !

!MaObjectGraphComparer methodsFor: 'private building'!
object2: anObject

	object2 _ anObject
! !

!MaObjectGraphComparer methodsFor: 'private building'!
serializeObjects

	self
		serialize: object1
			using: serializer1;
		serialize: object2
			using: serializer2
! !


!MaRepositoryControllerFacade methodsFor: 'private' stamp: 'cmm 6/23/2002 16:56'!
upgradeMagmaPerson

	link submit: MaUpgradeMagmaPersonRequest new
! !


!MaUpgradeMagmaPersonRequest methodsFor: 'as yet unclassified' stamp: 'cmm 6/19/2002 23:40'!
process

	^self repositoryController upgradeMagmaPerson
! !


!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 23:22'!
* anInteger

	^self class fromMilliseconds: self totalMilliseconds * anInteger
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/6/2002 23:30'!
+ aMagmaCalendarTimeOrInteger

	^aMagmaCalendarTimeOrInteger maAddTimeStamp: self
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:49'!
- aMagmaCalendarTime

	^self class fromMilliseconds: self totalMilliseconds - aMagmaCalendarTime totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:46'!
// anIntegerOrCalendarTime

	^anIntegerOrCalendarTime maDivideIntoCalendarTime: self
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:48'!
\\ anIntegerOrCalendarTime

	^anIntegerOrCalendarTime maModuloCalendarTime: self
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:50'!
roundTo: aMagmaCalendarTime
	"aMagmaCalendarTime should be a duration.
	i.e., if the receiver is 5 minutes, 37 seconds, and aMagmaCalendarTime
	is 2 minutes, then return 6 minutes."

	^self class fromMilliseconds: (self totalMilliseconds roundTo: aMagmaCalendarTime totalMilliseconds)
! !

!MagmaCalendarTime methodsFor: 'operators' stamp: 'cmm 3/7/2002 22:50'!
truncateTo: aMagmaCalendarTime
	"aMagmaCalendarTime should be a duration.
	i.e., if the receiver is 5 minutes, 37 seconds, and duration
	is 2 minutes, then return 4 minutes."

	^self class
		fromMilliseconds: (self totalMilliseconds truncateTo: aMagmaCalendarTime totalMilliseconds)
! !

!MagmaCalendarTime methodsFor: 'comparing' stamp: 'cmm 3/6/2002 23:29'!
< aMagmaCalendarTime

	^self totalMilliseconds < aMagmaCalendarTime totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'comparing' stamp: 'cmm 3/7/2002 23:24'!
= aMagmaCalendarTime

	self == aMagmaCalendarTime ifTrue: [ ^true ].
	aMagmaCalendarTime class = MagmaCalendarTime ifFalse: [ ^false ].
	^self totalMilliseconds = aMagmaCalendarTime totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'converting'!
asDate

	^Date fromDays: self totalDays
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 22:57'!
asTime

	^Time fromSeconds: self totalSeconds
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 23:21'!
date

	^date
! !

!MagmaCalendarTime methodsFor: 'accessing'!
hash

	^self totalMilliseconds hash
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 23:26'!
milliseconds

	^milliseconds
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 23:24'!
time

	^time
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/6/2002 22:14'!
totalDays

	^self totalSeconds // MagmaCalendarTime secondsPerDay
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 23:26'!
totalMilliseconds

	^(self date asSeconds + self time asSeconds) * 1000 + self milliseconds
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/10/2002 00:38'!
totalMilliseconds: anInteger

	| d |
	d _ (Date fromSeconds: anInteger // 1000).
	self
		date: d
		time: (Time fromSeconds: (anInteger // 1000) - d asSeconds)
		milliseconds: anInteger \\ 1000
! !

!MagmaCalendarTime methodsFor: 'accessing' stamp: 'cmm 3/7/2002 23:30'!
totalSeconds

	^date asSeconds + time asSeconds
! !

!MagmaCalendarTime methodsFor: 'building' stamp: 'cmm 3/7/2002 23:00'!
date: aDate time: aTime

	^self
		date: aDate
		time: aTime
		milliseconds: 0
! !

!MagmaCalendarTime methodsFor: 'building' stamp: 'cmm 3/10/2002 00:37'!
date: aDate time: aTime milliseconds: anInteger

	date _ aDate.
	time _ aTime.
	milliseconds _ anInteger
! !

!MagmaCalendarTime methodsFor: 'building' stamp: 'cmm 3/7/2002 23:32'!
milliseconds: anInteger

	milliseconds _ anInteger
! !

!MagmaCalendarTime methodsFor: 'building'!
totalSeconds: anInteger

	self totalMilliseconds: anInteger * 1000
! !

!MagmaCalendarTime methodsFor: 'private printing' stamp: 'cmm 3/7/2002 23:32'!
isDuration
	"Returns true if the receiver most likely is representing a duration
	instead of a point in time.  Use with caution, as you may really want
	to be measuring a duration.  However, if this were a point in time, it
	would be before 1951..."

	^self totalMilliseconds < 1576800000000
! !

!MagmaCalendarTime methodsFor: 'private printing' stamp: 'cmm 7/26/2002 00:35'!
printDurationOn: aStream

	(self totalSeconds >= MagmaCalendarTime secondsPerDay)
		ifTrue:
			[ aStream
				maPrint: 
					(MaTextMessage new
						appendCount: (self date subtractDate: self class epoch)
						of: 'day';
					text);
				nextPutAll: ', ' ].
	aStream nextPutAll: self time print24
! !

!MagmaCalendarTime methodsFor: 'private printing'!
printDurationWithMillisecondsOn: aStream

	self
		printDurationOn: aStream;
		printMillisecondsOn: aStream
! !

!MagmaCalendarTime methodsFor: 'private printing'!
printMillisecondsOn: aStream

	aStream
		nextPut: $.;
		nextPutAll: (
			self milliseconds printString
				abtPadWith: $0
				upToLength: 3
				onRight: false)
! !

!MagmaCalendarTime methodsFor: 'private private - dispatch' stamp: 'cmm 3/7/2002 22:49'!
maAddTimeStamp: aMagmaCalendarTime

	^self class fromMilliseconds: self totalMilliseconds + aMagmaCalendarTime totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'private private - dispatch' stamp: 'cmm 3/7/2002 22:49'!
maDivideIntoTimeStamp: aMagmaCalendarTime

	^self class fromMilliseconds: aMagmaCalendarTime totalMilliseconds // self totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'private private - dispatch' stamp: 'cmm 3/7/2002 22:50'!
maModuloTimeStamp: aMagmaCalendarTime

	^self class fromMilliseconds: aMagmaCalendarTime totalMilliseconds \\ self totalMilliseconds
! !

!MagmaCalendarTime methodsFor: 'printing' stamp: 'cmm 3/7/2002 22:57'!
printAbbreviatedOn: aStream

	self isDuration
		ifTrue:
			[ self printDurationOn: aStream ]
		ifFalse:
			[ aStream
				maPrint: self date;
				space;
				maPrint: self time ]
! !

!MagmaCalendarTime methodsFor: 'printing'!
printOn: aStream

	super printOn: aStream.
	aStream space.
	self printAbbreviatedOn: aStream
! !

!MagmaCalendarTime methodsFor: 'creation' stamp: 'cmm 3/7/2002 23:01'!
to: aMagmaCalendarTime

	^self
		to: aMagmaCalendarTime
		by: 1 second
! !


!MagmaFixtureFactory methodsFor: 'accessing' stamp: 'cmm 7/28/2002 10:43'!
newOrganizationMailingAddresses: anInteger

	^(5 to: 5 + anInteger - 1) collect:
		[ :index |
		MagmaMailingAddress new
			street: (self streetNames at: index);
			zip: (self zipCodes at: index);
			yourself ]! !

!MagmaFixtureFactory methodsFor: 'creation' stamp: 'cmm 6/23/2002 21:35'!
knot
	"Answer an object that contains a graph of references that span every combination of class supported by Magma."

	| samples populatedDictionary |

	samples _ OrderedCollection new.
	"First build collections that support addAll:"
	#(OrderedCollection Set Bag) do:
		[ :eachClassName |
		samples add: (
			(Smalltalk classNamed: eachClassName) new
				addAll: self allCollectionSamplesHoldingNonCollections;
				yourself) ].
	"Now do Array and Dictionary"
	samples add: self allCollectionSamplesHoldingNonCollections asArray.
	populatedDictionary _ Dictionary new.
	self allCollectionSamplesHoldingNonCollections do:
		[ :each |
		populatedDictionary
			at: each
			put: populatedDictionary copy ].
	samples add: populatedDictionary.
	^samples
! !

!MagmaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:41'!
newMailingAddresses: anInteger

	^(1 to: anInteger) collect:
		[ :index |
		MagmaMailingAddress new
			street: (self streetNames at: index);
			zip: (self zipCodes at: index);
			yourself ]! !

!MagmaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:47'!
newOrganizations: anInteger
	"Answer a collection of anInteger number of MagmaPerson's."

	| organizations addresses |

	addresses _ self newOrganizationMailingAddresses: anInteger.
	organizations _ Dictionary new.
	self organizationNames
		with: addresses
		do:
			[ :eachName :eachAddress |
			organizations
				at: eachName
				put: (
					MagmaOrganization new
						name: eachName;
						address: eachAddress) ].
	^organizations! !

!MagmaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:41'!
newPersonNames: anInteger

	^(1 to: anInteger) collect:
		[ :index |
		MagmaPersonName new
			first: (self firstNames at: index);
			middle: (self middleNames at: index);
			last: (self lastNames at: index);
			yourself ]! !

!MagmaFixtureFactory methodsFor: 'creation' stamp: 'cmm 7/28/2002 10:47'!
newPersons: anInteger
	"Answer a collection of anInteger number of MagmaPerson's."

	| names addresses persons |

	persons _ OrderedCollection new: anInteger.
	names _ self newPersonNames: anInteger.
	addresses _ self newMailingAddresses: anInteger.
	names
		with: addresses
		do:
			[ :eachName :eachAddress |
			persons add: (
				MagmaPerson new
					name: eachName;
					address: eachAddress) ].
	^persons! !

!MagmaFixtureFactory methodsFor: 'future samples to support' stamp: 'cmm 6/17/2002 22:42'!
blockSamples

	^Array
		with: self simpleBlock
		with: self noArgComplexBlock
		with: self oneArgComplexBlock
		with: self threeArgComplexBlock
! !

!MagmaFixtureFactory methodsFor: 'future samples to support' stamp: 'cmm 6/17/2002 22:42'!
compiledMethodSamples

	^Array
		with: Object>>#size
		with: OrderedCollection>>#add:
		with: MagmaRepositoryController>>#createRepositoryAt:
! !

!MagmaFixtureFactory methodsFor: 'future samples to support' stamp: 'cmm 7/16/2002 22:47'!
sortedCollectionSamples

	| sentence |
self maMarked: 'dev'.
"Until we support block serialization in VI4, we don't support SortedCollections.  Once we do, though, be sure to move this method back to 'private collection samples' category.  This thing actually checks the method categories to build the knot."

	sentence _ 'the quick brown fox slyly jumped over 1029384756 lazy dogs.'.
	^Array
		with: SortedCollection new
		with: sentence asSortedCollection
		with: (
			(SortedCollection sortBlock: [ :a :b | a > b ])
				addAll: sentence substrings;
				addAll: sentence asUppercase substrings;
				yourself)
! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 6/17/2002 22:42'!
allCollectionSamplesHoldingNonCollections

	^(self methodsInCategory: 'private collection samples')
		inject: OrderedCollection new
		into:
			[ :coll :each |
			coll
				addAll: (self perform: each selector);
				yourself ]
! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 6/17/2002 22:42'!
allNonCollectionSamples

	^allNonCollectionSamples
		ifNil:
			[ allNonCollectionSamples _ (self methodsInCategory: 'private non-collection samples')
		
		inject: OrderedCollection new
				into:
					[ :coll :each |
		
			coll
						addAll: (self perform: each selector);
						yourself ] ]
		ifNotNil: [ allNonCollectionSamples ]! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:40'!
firstNames

	^#('Paula' 'Chris' 'Bif' 'Yury' 'David' 'Russ' 'Judy')! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:41'!
lastNames

	^#('Mayer' 'Muller' 'Brower' 'Katsman' 'Jackson' 'Blade' 'Muller')! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 6/17/2002 22:42'!
methodsInCategory: aString

	^MaMethodSelector new
		addClass: self class;
		selectCategories: (Array with: aString);
		methods
! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:45'!
middleNames

	^#('Leslie' 'Michael' '' '' '' '' 'Ann')! !

!MagmaFixtureFactory methodsFor: 'private accessing' stamp: 'cmm 7/28/2002 10:43'!
streetNames

	^#(
		'7547 McGee'
		'1314 E. 82nd Terr. #15'
		'4421 Springfield'
		'101 W. Meyer'
		'281 Aisle Drive'
		'2138 E. 83rd Terr.'
		'2104 E. Gregory')! !

!MagmaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 6/17/2002 22:42'!
arraySamples

	| populatedArray |

	populatedArray _ self allNonCollectionSamples asArray.
	^Array
		with: Array new
		with: (Array new: 100)
		with: populatedArray
! !

!MagmaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:42'!
dictionarySamples

	| populatedDictionary |

	populatedDictionary _ Dictionary new.
	(self allNonCollectionSamples copyWithout: nil) do:
		[ :each |
		populatedDictionary
			at: each
			put: populatedDictionary copy ].
	^Array
		with: Dictionary new
		with: populatedDictionary
! !

!MagmaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:43'!
orderedCollectionSamples

	^Array
		with: OrderedCollection new
		with: (OrderedCollection new addAll: self allNonCollectionSamples; yourself)
! !

!MagmaFixtureFactory methodsFor: 'private collection samples' stamp: 'cmm 7/8/2002 21:43'!
setSamples

	^Array
		with: Set new
		with: (Set new addAll: (self allNonCollectionSamples copyWithout: nil); yourself)
! !

!MagmaFixtureFactory methodsFor: 'private creation - domain objects' stamp: 'cmm 7/28/2002 10:45'!
zipCodes

	^#(
		'64114'
		'64131'
		'66101'
		'10201'
		'98876'
		'12345'
		'71717')! !

!MagmaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
noArgComplexBlock

	^[ | c |
		c _ OrderedCollection new.
		MaObject withAllSubclasses do: [ :each | c add: each name asLowercase ].
		c ]
! !

!MagmaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
oneArgComplexBlock

	^[ :number | number sqrt ]
! !

!MagmaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
simpleBlock

	^[ 'hello' collect: [ :each | each asUppercase ] ]
! !

!MagmaFixtureFactory methodsFor: 'private individual fixtures' stamp: 'cmm 6/17/2002 22:43'!
threeArgComplexBlock

	^[ :path :parent :index |
		Transcript
			cr;
			maTab: path size;
			nextPutAll: path last printString ]
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
atomicSamples

	^Array
		with: nil
		with: true
		with: false
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
byteArraySamples

	^Array
		with: ByteArray new
		with: (ByteArray new: 100)
		with: (0 to: 255) asByteArray
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/11/2002 00:23'!
characterSamples

	^Character allCharacters! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/9/2002 23:32'!
floatSamples

	^{ Float e.  Float halfPi.  Float infinity.  Float nan.  Float negativeZero.  Float pi.  101.10001 }! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/11/2002 00:03'!
fractionSamples

	^Array with: 3/4 with: 0-(1001/1000)! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
globalSamples

	^Array
		with: Transcript
		with: Processor
		with: Smalltalk
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
largeIntegerSamples

	^Array
		with: 100 factorial
		with: (0-100 factorial)
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
readStreamSamples

	^Array
		with: (ReadStream on: (1 to: 1000));
		with: (ReadStream on: #('chris' 'paula'))
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
readWriteStreamSamples

	^Array
		with: (ReadWriteStream on: (1 to: 1000));
		with: (ReadWriteStream on: #('chris' 'paula'))
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
smallIntegerSamples

	^Array
		with: -1212
		with: -7
		with: 0
		with: 1111
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
stringSamples

	| allCharactersString |

	allCharactersString _ (0 to: 255) asByteArray asString.
	^Array
		with: String new
		with: 'hello'
		with: allCharactersString
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 7/8/2002 21:07'!
symbolSamples

	^Array
		with: #size
		with: #with:with:with:with:
		with: #'hello there'
		"with: '' asSymbol  <- conflicts with empty String sample since, in Squeak, they're equal.."
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:46'!
userObjectsSamples

	^Array
		with: (self newPersons: 3)
		with: (self newOrganizations: 2)
! !

!MagmaFixtureFactory methodsFor: 'private non-collection samples' stamp: 'cmm 6/17/2002 22:43'!
writeStreamSamples

	^Array
		with: (WriteStream on: String new);
		with: (WriteStream on: (OrderedCollection new: 200))
! !


!MagmaMailingAddress methodsFor: 'accessing'!
street

	^street! !

!MagmaMailingAddress methodsFor: 'accessing'!
zip

	^zip! !

!MagmaMailingAddress methodsFor: 'building'!
street: aString

	street _ aString
! !

!MagmaMailingAddress methodsFor: 'building'!
zip: aString

	zip _ aString
! !


!MagmaOrganization methodsFor: 'accessing'!
address

	^address! !

!MagmaOrganization methodsFor: 'accessing'!
name

	^name! !

!MagmaOrganization methodsFor: 'building'!
address: aString

	address _ aString
! !

!MagmaOrganization methodsFor: 'building'!
name: aString

	name _ aString
! !

!MagmaOrganization methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self name
! !


!MagmaPerson methodsFor: 'accessing'!
address

	^address! !

!MagmaPerson methodsFor: 'accessing'!
birthday

	^birthday! !

!MagmaPerson methodsFor: 'accessing' stamp: 'cmm 5/27/2002 00:15'!
lastNameString

	^self name last
! !

!MagmaPerson methodsFor: 'accessing'!
name

	^name! !

!MagmaPerson methodsFor: 'accessing'!
spouse

	^spouse! !

!MagmaPerson methodsFor: 'building'!
address: aMaSstMailingAddress

	address _ aMaSstMailingAddress
! !

!MagmaPerson methodsFor: 'building'!
birthday: aMaTimeStamp

	birthday _ aMaTimeStamp
! !

!MagmaPerson methodsFor: 'building'!
name: aMagmaPersonName

	name _ aMagmaPersonName
! !

!MagmaPerson methodsFor: 'building'!
spouse: aMagmaPerson

	spouse _ aMagmaPerson.
	aMagmaPerson spouse == self ifFalse: [ aMagmaPerson spouse: self ]
! !

!MagmaPerson methodsFor: 'actions'!
marry: aMagmaPerson

	self
		spouse: aMagmaPerson;
		moveInWith: aMagmaPerson
! !

!MagmaPerson methodsFor: 'actions'!
moveInWith: aMagmaPerson

	self address: aMagmaPerson address
! !

!MagmaPerson methodsFor: 'printing' stamp: 'cmm 4/30/2002 23:10'!
maPrintAbbreviatedOn: aStream

	self name maPrintAbbreviatedOn: aStream
! !

!MagmaPerson methodsFor: 'printing'!
printAbbreviatedOn: aStream

	self name printAbbreviatedOn: aStream
! !


!MagmaPersonName methodsFor: 'accessing'!
first

	^first! !

!MagmaPersonName methodsFor: 'accessing'!
last

	^last! !

!MagmaPersonName methodsFor: 'accessing'!
middle

	^middle! !

!MagmaPersonName methodsFor: 'building'!
first: aString

	first _ aString
! !

!MagmaPersonName methodsFor: 'building'!
last: aString

	last _ aString
! !

!MagmaPersonName methodsFor: 'building'!
middle: aString

	middle _ aString
! !

!MagmaPersonName methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream
		nextPutAll: self first;
		space;
		nextPutAll: self last
! !


!MagmaRepositoryController methodsFor: 'set-up / shutdown' stamp: 'cmm 7/15/2002 22:56'!
open: fileNameString processOn: portNumber
	"Convenience method."

	isStopped ifNotNil: [ Warning signal: 'It is recommended to create a new MagmaRepositoryController instead of reusing an old one.' ].
	self open: fileNameString.
	isStopped _ false.
	[ (MaRequestServerForTcp
		requestProcessor: self
		requestByteArraySize: 2000000)

		processRequestsOn: portNumber
		until: [ self isStopped ] ] ensure: [ self close ]
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 6/23/2002 22:10'!
upgradeMagmaPerson

	| controller |

	self close.
	controller _ MagmaRepositoryController administer: repository filename asString.
	controller
		upgradeUsingDefaultBehavior: MagmaPerson;
		close.
	self open: repository filename asString.
	^nil! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/23/2002 11:26'!
isStopped

	^isStopped! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/23/2002 10:47'!
startAcceptingNewConnections

	isAcceptingConnections _ true! !

!MagmaRepositoryController methodsFor: 'console' stamp: 'cmm 6/23/2002 10:48'!
connections
	"Used for monitoring server status via some console gui."

	self maMarked: 'dev'.! !

!MagmaRepositoryController methodsFor: 'console' stamp: 'cmm 6/23/2002 10:46'!
stopAcceptingNewConnections

	isAcceptingConnections _ false! !

!MagmaRepositoryController methodsFor: 'console' stamp: 'cmm 7/16/2002 22:00'!
stopAfterRemainingTransactionsEndOrAfter: aMaCalendarTime

self maMarked: 'dev'
"This might be a useful console command.."! !

!MagmaRepositoryController methodsFor: 'console' stamp: 'cmm 7/15/2002 22:46'!
stopNow

	self stopAcceptingNewConnections.
	self close.
	isStopped _ true
! !


!MagmaSession methodsFor: 'private' stamp: 'cmm 6/19/2002 23:41'!
upgradeMagmaPerson

	facade upgradeMagmaPerson! !


!MagmaTestCase methodsFor: 'test grow an object' stamp: 'cmm 7/18/2002 23:54'!
addAndGrowObject

	| c arr |

	c _ OrderedCollection new addAll: (101 to: 108); yourself.
	arr _ Array
		with: c
		with: nil
		with: self peopleSample1.

	clientSession commit: [ clientSession root at: 'testGrowObject' put: arr ].

	"grow the collection, forcing its buffer to be moved in the file."
	clientSession commit: [ c addAll: (109 to: 139) ].

	"now put a small object in, it should reside in the old space occupied by the original c in the file."
	clientSession commit: [ (clientSession root at: 'testGrowObject') at: 2 put: '2' ]! !

!MagmaTestCase methodsFor: 'test grow an object' stamp: 'cmm 7/17/2002 22:42'!
readAndVerifyGrownObject

	| arr |
	clientSession abort. "required because of refresh bug when new classes are added.."
	arr _ clientSession root at: 'testGrowObject'.
	self should: [ arr first = (101 to: 139) asOrderedCollection ].
	self should: [ (arr at: 2) = '2' ].
	self should:
		[ self
			doesGraphOf: arr last
			match: self peopleSample1 ]! !

!MagmaTestCase methodsFor: 'test grow an object' stamp: 'cmm 7/16/2002 22:38'!
testGrowObject
	"Magma has special-case code on the server (see MaObjectFiler>>#write:index:) that checks whether an object now takes up more space than it used to.  This can occur when a variable is added to a class, or when a Collection had to grow its internal Array.  This test exercises that code."

	self
		remotePerform: #addAndGrowObject
		in: 'client1'.
	self
		remotePerform: #readAndVerifyGrownObject
		in: 'client2'! !

!MagmaTestCase methodsFor: 'test transactions' stamp: 'cmm 6/29/2002 16:57'!
performCommitAndRefreshTest

	"client1 begins a transaction in, change person 1 name to elizabeth."
	self
		remoteEvaluate:
			'| person |
			clientSession begin.
			person _ (clientSession root at: ''people'') first.
			person name first: ''elizabeth''.
			nil'
		in: 'client1'.
	"client2, changes person 3 name to smitty and also to marry person 2."
	self
		remoteEvaluate:
			'| person locations |
			locations _ clientSession root at: ''locations''.
			self should:
				[ (clientSession root at: ''people'') maConform: [ :each | locations includes: each address ] ].
			clientSession begin.
			person _ (clientSession root at: ''people'') at: 3.
			person name first: ''smitty''.
			person marry: ((clientSession root at: ''people'') at: 2).
			clientSession commit.
			nil'
		in: 'client2'.
	"client1 commit changes to person1, and should then see all changes by client2."
	self
		remoteEvaluate:
			'| people |
			people _ clientSession root at: ''people''.
			clientSession commit.
			self should: [ (people at: 2) spouse == (people at: 3) ].
			self should: [ (people at: 2) == (people at: 3) spouse ].
			self should: [ (people at: 3) name first = ''smitty'' ].
			self should: [ (people at: 1) name first = ''elizabeth'' ].
			nil'
		in: 'client1'.
	"client2 should not see client1's changes until it aborts."
	self
		remoteEvaluate:
			'| people |
			people _ clientSession root at: ''people''.
			self should: [ (people at: 1) name first = (self peopleSample1 at: 1) name first ].
			clientSession abort.
			self should: [ (people at: 1) name first = ''elizabeth'' ].
			nil'
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test transactions' stamp: 'cmm 6/29/2002 16:49'!
performCommitConflictTest

	"client1 begins a transaction, chris plans to marry paula."
	self
		remoteEvaluate:
			'| paula chris |
			clientSession begin.
			paula _ (clientSession root at: ''people'') first.
			chris _ (clientSession root at: ''people'') at: 2.
			chris marry: paula.
			nil'
		in: 'client1'.
	"client2, begins a transaction, bif tries to muscle in on paula, but he didn't make a commitment.."
	self
		remoteEvaluate:
			'| paula paulaOid bif |
			clientSession begin.
			paula _ (clientSession root at: ''people'') first.
			bif _ (clientSession root at: ''people'') last.
			bif marry: paula.
			nil'
		in: 'client2'.
	"chris makes a commitment.."
	self
		remotePerform: #commit
		in: 'client1'.
	"bif will now get a commit failure, after which it should be able to see paula's spouse changes."
	self
		remoteEvaluate:
			'| result paula chris |
			paula _ (clientSession root at: ''people'') first.
			chris _ (clientSession root at: ''people'') at: 2.
			result _ clientSession commit.
			self
				should: [ result commitConflicts size = 1 ];
				should: [ result commitConflicts first userId = ''client1'' ];
				should: [ result commitConflicts first conflictingObjects includes: paula ];
				should: [ chris spouse == paula ].
			nil'
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test transactions' stamp: 'cmm 6/26/2002 23:01'!
testTransactions
	"This tests Magma's transaction processing, its ability to detect commit conflicts, properly refresh each client image based on MagmaOptions>>refreshPersistentObjectsEvenWhenChangedOnlyByMe, detecting dirty-reads."

	self
		addPeople;
		addLocations;
		performCommitConflictTest;
		performCommitAndRefreshTest
! !

!MagmaTestCase methodsFor: 'test commit object knot' stamp: 'cmm 7/1/2002 23:53'!
addKnot

	clientSession commit:
		[ clientSession root
			at: 'a knotty object'
			put: MagmaFixtureFactory new knot ].
	^nil
! !

!MagmaTestCase methodsFor: 'test commit object knot' stamp: 'cmm 7/18/2002 23:41'!
longtestCommitKnot
"This method takes so long to run I leave it out of the standard test.  Also, the compare object graph is suspect."

	"This method tests Magma's ability to commit a tangled knot of an
	object structure by one client, then retrieved and compared, as
	best as possible, against a dynamically created version of the
	same knot in client2 (see MaObjectGraphComparer for this)."

	self
		remotePerform: #addKnot
		in: 'client1'.
	self
		remotePerform: #verifyKnot
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test commit object knot' stamp: 'cmm 7/1/2002 23:53'!
verifyKnot

	self clientSession abort.  "refresh view"
	self should:
		[ self
			doesGraphOf: (self clientSession root at: 'a knotty object')
			match: MagmaFixtureFactory new knot ].
	^nil
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 6/29/2002 16:50'!
addLocations

	self
		remoteEvaluate:
			'| people |
		
	people _ self clientSession root at: ''people''.
		
	self clientSession commit:
		
		[ self clientSession root
		
			at: ''locations''
		
			put: (people collect: [ :each | each address ]) ].
			nil'
		in: 'client1'.
	self
		remoteEvaluate:
			'clientSession abort.
			localRoot 
				at: ''locations''
				put: (clientSession root at: ''locations'').
			nil'
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 6/18/2002 22:04'!
addOldTimeStamps

	self
		remoteEvaluate:
			'self clientSession commit:
		
		[ self clientSession root
					at: ''dates''
					put: self oldVersionTimeStamps ].
			nil'
		in: 'client1'.
	self
		remoteEvaluate:
			'clientSession abort.
			localRoot
				at: ''dates''
				put: (clientSession root at: ''dates'').
			nil'
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 6/29/2002 14:42'!
addPeople

	self
		remoteEvaluate:
			'self clientSession commit:
	
			[ clientSession root
					at: ''people''
					put: self peopleSample1 ].
			nil'
		in: 'client1'.
	"make sure localRoot has it in client2."
	self
		remoteEvaluate:
			'clientSession abort.
			localRoot
				at: ''people''
				put: (clientSession root at: ''people'').
			nil'
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 4/17/2002 00:02'!
commitAllPersons
	"Add a birthday to the second person.  See if the first gets
	auto-upgraded (no change, but read)."

	| people dates |

	self maMarked: 'dev'.
"Currently, 'auto-upgrading' objects, even if they didn't change, is not
implemented.  We aren't actually changing all persons, as the name of this
method implies, but someday we should try doing the auto-upgrade."
	self connectNewClientSession.
	people _ self clientSession root at: 'people'.
	dates _ self clientSession root at: 'dates'.
	self clientSession commit: [ (people at: 2) birthday: (dates at: 2) ].
	"Everything should be upgraded at this point."
	self
		close;
		connectNewClientSession.
	self should:
		[ ((self clientSession root at: 'people') at: 2) birthday ==
			((self clientSession root at: 'dates') at: 2) ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 23:30'!
commitBirthdaysToFirstPerson
	"We should have a clientSession at this point.  Runs in client 1."

	| people dates |

	people _ clientSession root at: 'people'.
	"We had put a collection of dates.  See #addOldTimeStamps."
	dates _ clientSession root at: 'dates'.
	clientSession commit: [ people first birthday: dates first ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 23:26'!
commitBirthdaysToSomePersons
	"We should have a clientSession at this point.  Runs in client 1."

	| people dates |

	people _ clientSession root at: 'people'.
	"We had put a collection of dates.  See #addOldTimeStamps."
	dates _ clientSession root at: 'dates'.
	clientSession commit: [ people first birthday: dates first ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 7/18/2002 19:49'!
commitChangesToSomeUpgradedPersons

	self
		remotePerform: #disconnect
		in: 'client2'.
	self
		loadChangeSet: 'MagmaPerson.withBirthdayAttribute.cs';
		pushClass: MagmaPerson;
		remotePerformUpgradeMagmaPerson;
		connectClients;
		remotePerform: #commitBirthdaysToFirstPerson in: 'client1';
		remotePerform: #validateFirstBirthday in: 'client2'
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 17:55'!
loadOldVersionsOfAllClassesInAllClients

	self
		loadChangeSet: 'MagmaPerson.withoutBirthdayAttribute.cs';
		loadChangeSet: 'MagmaCalendarTime.withMultipleVariables.cs';
		pushClass: MagmaPerson;
		pushClass: MagmaCalendarTime
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 7/26/2002 00:06'!
newOldVersionTimeStamps

	^self timeStampFixtureMilliseconds collect: [ :each | MagmaCalendarTime fromMilliseconds: each ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 7/26/2002 00:07'!
newVersionTimeStamps

	^self timeStampFixtureMilliseconds collect: [ :each | MagmaCalendarTime fromMilliseconds: each ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades'!
oldVersionTimeStamps

	oldVersionTimeStamps isNil ifTrue: [ oldVersionTimeStamps _ self newOldVersionTimeStamps ].
	^oldVersionTimeStamps
! !

!MagmaTestCase methodsFor: 'test class schema upgrades'!
organizationsSample1

	^MagmaFixtureFactory current newOrganizations: 2
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 17:04'!
populateOriginalPeopleAndLocationsAndTimeStamps

	self
		addPeople;
		addLocations;
		addOldTimeStamps
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 7/18/2002 19:49'!
remotePerformUpgradeMagmaPerson

	self
		loadNewVersionOfMagmaPerson;
		pushClass: MagmaPerson.
	self
		remotePerform: #upgradeMagmaPerson
		in: 'client1'.
	"client1's session is no longer known to the server, because the server closed and reopened during the upgradeMagmaPerson.  So we just reconnect all clients."
	self connectClients
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 23:42'!
testClassSchemaUpgrades
	"This method tests Magma's ability to upgrade objects
	from one class version to another.  First, we add a 'birthday' attribute
	to persistent MagmaPersons that *also* reference an early version of MagmaCalendarTime.
	We commit changes to some of the Persons.  Then we upgrade MagmaCalendarTime
	to have a totally different implementation.  After this we commit changes to all
	of the Persons.  So some of them will require an upgrade of just the birthday attribute, others will require a double-upgrade, the birthday and the person."

	self 
		loadOldVersionsOfAllClassesInAllClients;
		populateOriginalPeopleAndLocationsAndTimeStamps;
		commitChangesToSomeUpgradedPersons.

self maMarked: 'dev'.
"To finish this test, we need true block closures.  Once VI4 is in place, we should be able to test this too..

		futuretestCommitChangesToAllPersonsAfterUpgradingCalendarTime"  
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 3/10/2002 00:46'!
timeStampFixtureMilliseconds

	^#(2157148331614 2157880260007 2764485000000)
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 7/26/2002 00:08'!
upgradeCalendarTime

	self
		administerRepository;
		loadNewVersionOfMagmaCalendarTime.
	self repositoryController
		upgrade: MagmaCalendarTime 
		with:
			[ :old :currentClass | | ts |
			ts _
				MagmaCalendarTime
					date: (old maInstVarNamed: 'date')
					time: (old maInstVarNamed: 'time').
			ts milliseconds: (old maInstVarNamed: 'milliseconds').
			currentClass basicNew
				maInstVarNamed: 'totalMilliseconds'
				put: ts totalMilliseconds ].
	self close
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 6/23/2002 11:56'!
upgradeMagmaPerson

	clientSession upgradeMagmaPerson! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 5/22/2002 23:30'!
validateFirstBirthday
	"Runs in client 2."

	| root |
	clientSession abort.
	self
		should: [ (root _ self clientSession root at: 'people') first birthday == (self clientSession root at: 'dates') first ];
		should:
			[ (root
				copyFrom: 2
				to: root size)
					maConform: [ :each | each birthday isNil ] ]
! !

!MagmaTestCase methodsFor: 'test class schema upgrades' stamp: 'cmm 4/17/2002 00:02'!
verifyTimeStampsInTestRepository
	"Client session is still open.."

	self should:
		[ (self clientSession root at: 'dates') maMatchesElementsOf: self newVersionTimeStamps ]
! !

!MagmaTestCase methodsFor: 'client' stamp: 'cmm 5/23/2002 21:12'!
clientSession
	"accessible from client1 and client2"

	^clientSession
! !

!MagmaTestCase methodsFor: 'client' stamp: 'cmm 5/7/2002 22:51'!
commit

	clientSession commit.
	^nil
! !

!MagmaTestCase methodsFor: 'client' stamp: 'cmm 5/8/2002 23:20'!
connectTo: hostAddressByteArray port: anInteger as: aString

	clientSession _ MagmaSession
		hostAddress: hostAddressByteArray
		port: anInteger.
	clientSession connectAs: aString.
	^nil
! !

!MagmaTestCase methodsFor: 'client' stamp: 'cmm 6/18/2002 22:06'!
disconnect

	clientSession ifNotNil: [ clientSession disconnect ].
	^nil! !

!MagmaTestCase methodsFor: 'client' stamp: 'cmm 5/23/2002 21:41'!
rootAt: aString put: anObject

	clientSession commit:
		[ clientSession
			rootAt: aString
			put: anObject ]
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 4/30/2002 21:27'!
administerNewRepositoryController

	^MagmaRepositoryController administer: self repositoryFileName
! !

!MagmaTestCase methodsFor: 'server'!
administerRepository

	self
		close;
		repositoryController: self administerNewRepositoryController
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 4/30/2002 22:37'!
close

	self clientSession notNil
		ifTrue: 
			[ self clientSession disconnect.
			self clientSession closeRepository ].
	self repositoryController notNil ifTrue: [ self repositoryController close ]
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 5/22/2002 15:14'!
createBaseRepository

	[ self
		deleteFiles;
		createNewRepository ] ensure: [ self close ].
	^nil "don't return self because it gets serialized, wasting time.."
! !

!MagmaTestCase methodsFor: 'server'!
createNewRepository

	self repositoryController: self newRepositoryController
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 3/4/2002 22:22'!
deleteFiles

	| extensionsToDelete |

	extensionsToDelete _ Array
		with: MaObjectFiler filePositionIndexFileExtension
		with: MaObjectFiler dataFileFileExtension
		with: MaHashIndex suggestedFileExtension.
	self deleteFilesWhere:
		[ :eachFilename |
		extensionsToDelete includes: (MaFilename fromString: eachFilename) extension ]
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 5/27/2002 20:25'!
fileNames

	^OrderedCollection
		with: self environmentPath , 'test' , '.' , MaObjectFiler filePositionIndexFileExtension
		with: self environmentPath , 'test' , '.' , MaObjectFiler dataFileFileExtension
		with: self environmentPath , '*.' , MaHashIndex suggestedFileExtension
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 6/23/2002 10:22'!
magmaServerAddress

	^magmaServerAddress
		ifNil: [ magmaServerAddress _ self class getAddressFor: 'server' ]
		ifNotNil: [ magmaServerAddress ]
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 4/30/2002 21:27'!
newRepositoryController

	^MagmaRepositoryController create: self repositoryFileName
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 4/30/2002 21:27'!
openNewRepositoryController

	^MagmaRepositoryController open: self repositoryFileName
! !

!MagmaTestCase methodsFor: 'server'!
openRepository

	self
		close;
		repositoryController: self openNewRepositoryController
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 5/23/2002 21:11'!
repositoryController
	"only accessible in the server player."

	^repositoryController
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 4/30/2002 22:38'!
repositoryController: aMaRepositoryController

	repositoryController notNil ifTrue: [ self close ].
	repositoryController _ aMaRepositoryController
! !

!MagmaTestCase methodsFor: 'server' stamp: 'cmm 5/13/2002 22:51'!
stopServer

	testIsOver _ true.
	^nil
! !

!MagmaTestCase methodsFor: 'Armored Code' stamp: 'cmm 4/24/2002 23:24'!
environmentPath

	^super environmentPath, 'magma\'
! !

!MagmaTestCase methodsFor: 'Armored Code'!
repositoryFileName

	^self fileNames at: 2
! !

!MagmaTestCase methodsFor: 'Armored Code' stamp: 'cmm 4/24/2002 23:30'!
resourcesPath

	^super resourcesPath, 'magma\'
! !

!MagmaTestCase methodsFor: 'tests waiting for VI4' stamp: 'cmm 4/23/2002 22:57'!
futuretestCommitChangesToAllPersonsAfterUpgradingCalendarTime

	self
		upgradeCalendarTime;
		commitAllPersons;
		verifyTimeStampsInTestRepository
! !

!MagmaTestCase methodsFor: 'loading code' stamp: 'cmm 4/24/2002 23:21'!
loadChangeSet: fileName

	| file |
	file _ (FileDirectory on: self resourcesPath) readOnlyFileNamed: fileName.
	[ file fileIn ] ensure: [ file close ]
! !

!MagmaTestCase methodsFor: 'loading code' stamp: 'cmm 5/22/2002 16:00'!
loadNewVersionOfMagmaCalendarTime

	self loadChangeSet: 'MagmaCalendarTime.withTotalMillisecondsVariable.cs'
! !

!MagmaTestCase methodsFor: 'loading code' stamp: 'cmm 5/22/2002 15:58'!
loadNewVersionOfMagmaPerson

	self loadChangeSet: 'MagmaPerson.withBirthdayAttribute.cs'
! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 7/2/2002 22:46'!
additionalProtocol
	"These classes are needed for the MagmaCollections tests."

	^{ MagmaPerson.  MagmaPersonName.  MagmaMailingAddress.  MagmaCalendarTime }
! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 6/21/2002 00:15'!
connectClients

	self
		remotePerform: #connectTo:port:as:
		withArguments: { self magmaServerAddress. 51969. 'client1' }
		in: 'client1'.
	self
		remotePerform: #connectTo:port:as:
		withArguments: { self magmaServerAddress. 51969. 'client2' }
		in: 'client2'
! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 6/21/2002 00:06'!
disconnectClients

	self playersDo: 
		[ :each |
			each
				remotePerform: #disconnect
				withArguments: #() ]
! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 7/18/2002 20:08'!
initialize

	super initialize.
	testIsOver _ false.
	localRoot _ Dictionary new
! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 7/18/2002 20:09'!
setUp

	super setUp.
	localRoot _ nil.
	self connectClients! !

!MagmaTestCase methodsFor: 'initializing' stamp: 'cmm 7/8/2002 23:51'!
tearDown

	self disconnectClients! !

!MagmaTestCase methodsFor: 'asserting' stamp: 'cmm 4/29/2002 22:33'!
graphOf: object1 shouldMatch: object2

	self should:
		[ self
			doesGraphOf: object1
			match: object2 ]
! !

!MagmaTestCase methodsFor: 'private' stamp: 'cmm 6/23/2002 23:58'!
doesGraphOf: object1 match: object2

	| comparator |
	"Assign to temp for easier debugging when you don't have a match."
	comparator _ (MaObjectGraphComparer
		object1: object1
		object2: object2).
	^comparator isPossibleMatch
! !

!MagmaTestCase methodsFor: 'private' stamp: 'cmm 5/23/2002 22:03'!
saveAndVerify: anObject at: aString

	self
		remotePerform: #rootAt:put:
		withArguments: { aString. anObject }
		in: 'client1'.
	self should:
		[ self
			remotePerform: #doesGraphOf:matchRootAt:
			withArguments: { anObject.  aString }
			in: 'clent2' ]
! !

!MagmaTestCase methodsFor: 'test objects' stamp: 'cmm 4/30/2002 23:36'!
peopleSample1

	^MagmaFixtureFactory current newPersons: 3
! !


!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
addAllToLargeCollection: aCollection at: aString

	self 
		addAllToLocalCollection: aCollection
		at: aString.
	self clientSession commit:
		[ (self clientSession root
			at: aString
			ifAbsentPut: [ MagmaCollection new ])
				addAll: aCollection ]
! !

!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
addAllToLocalCollection: aCollection at: aString

	(localRoot
		at: aString
		ifAbsentPut: [ OrderedCollection new ])
			addAll: aCollection.! !

!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
removeFromLargeCollection: anObject at: aString

	clientSession commit: [ (clientSession root at: aString) remove: anObject ]
! !

!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
removeFromLargeCollectionAtIndex: anInteger at: aString

	| objectToRemove |
clientSession abort.  "required due to a known issue."
	objectToRemove _ (clientSession root at: aString) at: anInteger.
	clientSession commit: [ (clientSession root at: aString) remove: objectToRemove ]
! !

!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
removeFromLocalCollectionAtIndex: anInteger at: aString
	"Remove whatever object occurs at anInteger in the largeCollection from the localRoot."

	(localRoot at: aString) remove: ((clientSession root at: aString) at: anInteger)
! !

!MagmaCollectionTester methodsFor: 'client' stamp: 'cmm 7/18/2002 15:40'!
verifyLargeCollectionAt: aString

	| localCollection largeCollection |

	clientSession abort.
	localCollection _ localRoot 
		at: aString
		ifAbsentPut: [ OrderedCollection new ].
	largeCollection _ self clientSession root at: aString.
	self should: [ largeCollection size = localCollection size ].
	largeCollection
		slowlyDo: [ :each | self should: [ localCollection includes: each ] ]
		refreshEvery: 100.
	localCollection do: [ :each | self should: [ largeCollection includes: each ] ].
	localCollection do: [ :each | self should: [ (largeCollection occurrencesOf: each) = 1 ] ]
! !

!MagmaCollectionTester methodsFor: 'private tests' stamp: 'cmm 7/18/2002 15:40'!
verifyIndex: attributeSymbol at: rootKeyString

	| localCollection reader uniqueKeys |
	reader _ (self clientSession root at: rootKeyString) asSortedReaderOn: attributeSymbol.
	localCollection _ localRoot at: rootKeyString.
	self
		verifyReader: reader
		against: localCollection.
	"Chop the largeCollection into thirds by key.  Verify each third.."
	uniqueKeys _
		self
			uniqueSingleKeysIn: localCollection
			using: reader index.
	[ :firstKey :lastKey |
		self
			verifyReader: reader
			from: firstKey
			to: lastKey
			against: localCollection ]
				value: uniqueKeys first
					value: (uniqueKeys at: uniqueKeys size // 3);
				value: (uniqueKeys at: uniqueKeys size // 3)
					value: (uniqueKeys at: uniqueKeys size * 2 // 3);
				value: (uniqueKeys at: uniqueKeys size * 2 // 3)
					value: (uniqueKeys at: uniqueKeys size)
! !

!MagmaCollectionTester methodsFor: 'private tests' stamp: 'cmm 7/18/2002 15:40'!
verifyReader: aMaLargeCollectionReader against: anOrderedCollection

	| localCollection largeCollection |

	self should: [ aMaLargeCollectionReader size = anOrderedCollection size ].
	localCollection _
		anOrderedCollection asSortedCollection: aMaLargeCollectionReader index sortBlock.
	largeCollection _ OrderedCollection new.
	aMaLargeCollectionReader
		slowlyDo: [ :each | largeCollection add: each ]
		refreshEvery: 100.
	self should: [ localCollection maConsistsOf: largeCollection ].
	largeCollection
		inject: 0
		into:
			[ :max :each | | hash |
			self should: [ (hash _ aMaLargeCollectionReader index indexHashFor: each) >= max ].
			hash ]
! !

!MagmaCollectionTester methodsFor: 'private tests' stamp: 'cmm 7/30/2002 23:48'!
verifyReader: aMagmaCollectionReader from: lowKeyObject to: highKeyObject against: anOrderedCollection
	"Create an additional reader based on the indexes of the lowest low and highest high keys.
	Verify this one too."

	| localCollection lowHash highHash subReader |

	lowHash _ aMagmaCollectionReader index indexHashForIndexObject: lowKeyObject.
	highHash _ aMagmaCollectionReader index indexHashForIndexObject: highKeyObject.
	localCollection _
		(anOrderedCollection select:
			[ :each |
			(aMagmaCollectionReader index indexHashFor: each)
				between: lowHash
				and: highHash ])
					asSortedCollection: aMagmaCollectionReader index sortBlock.
	subReader _
		aMagmaCollectionReader collection
			read: aMagmaCollectionReader index attribute
			from: lowKeyObject
			to: highKeyObject.
	self
		verifyReader: subReader
		against: localCollection! !

!MagmaCollectionTester methodsFor: 'creation' stamp: 'cmm 7/18/2002 15:40'!
methodSamples

	^MaObject withAllSubclasses
		inject: OrderedCollection new
		into:
			[ :coll :each |
			coll
				addAll: each methodDictionary values;
				yourself ]
! !

!MagmaCollectionTester methodsFor: 'test concurrency' stamp: 'cmm 7/18/2002 15:40'!
testConcurrency
	"One test should be to have one session change the indexes
	of a collection that another is adding objects to.  It should fail
	whether the first session (the indexer) adds the index back or
	not (because adding it back would add it to the end)."

	"this is a rare case that can wait.."
	self maMarked: 'dev'.
! !

!MagmaCollectionTester methodsFor: 'test add and remove objects' stamp: 'cmm 7/18/2002 15:40'!
testAddAndRemoveObjects

	| sample |
	sample _ self peopleSample1.
	"client1 does this"
	self
		remotePerform: #addAllToLargeCollection:at:
		withArguments: { sample. 'testAddAndRemoveObjects' }
		in: 'client1'.
	"client2 does this"
	self
		removeAtIndex: 2
		at: 'testAddAndRemoveObjects'.
	self
		performVerifyLargeCollectionAt: 'testAddAndRemoveObjects'
		in: 'client1'
! !

!MagmaCollectionTester methodsFor: 'test change index keys' stamp: 'cmm 7/18/2002 15:40'!
testChangeIndexKeys
	"Change the value of the attributes that make up keys of multiple
	indexes.  Magma should automatically detect and handle."

	self
		remotePerform: #addAllToLargeCollection:at:
		withArguments: { self peopleSample1. 'testChangeIndexKeys' }
		in: 'client1'.

	"make sure localRoot has the same instances in client2."
	self
		remoteEvaluate:
			'| mc |
			clientSession abort.
			mc _ clientSession root at: ''testChangeIndexKeys''.
			localRoot at: ''testChangeIndexKeys'' put: OrderedCollection new.
			mc
				slowlyDo: [ :each | (localRoot at: ''testChangeIndexKeys'') add: each ]
				commitEvery: 1.  "<-- opportunity to test interim commits.."
			nil'
		in: 'client2'.

	"add the index in client1."
	self
		remoteEvaluate: 
			'| mc |
			mc _ clientSession root at: ''testChangeIndexKeys''.
			clientSession commit:
				[ mc addIndex:
					(MaSearchStringIndexDefinition
						attribute: #lastNameString
						keySize: 64) ].
			nil'
		in: 'client1'.

	"verify the index in client2."
	self
		remoteEvaluate:
			'| chris paula |
			clientSession abort.
			paula _ (localRoot at: ''testChangeIndexKeys'') first.
			chris _ (localRoot at: ''testChangeIndexKeys'') at: 2.
			clientSession commit: [ chris marry: paula ].  "Paula lastName changes.."
			self
				verifyIndex: #lastNameString
				at: ''testChangeIndexKeys''.
			nil'
		in: 'client2'
! !

!MagmaCollectionTester methodsFor: 'private' stamp: 'cmm 7/18/2002 15:40'!
addAll: aCollection at: aString

	self
		remotePerform: #addAllToLargeCollection:at:
		withArguments: { aCollection. aString }
		in: 'client1'.
	self
		remotePerform: #addAllToLocalCollection:at:
		withArguments: { aCollection.  aString }
		in: 'client2'
! !

!MagmaCollectionTester methodsFor: 'private' stamp: 'cmm 7/18/2002 15:40'!
performVerifyLargeCollectionAt: aString in: clientIdString

	self
		remotePerform: #verifyLargeCollectionAt:
		with: aString
		in: clientIdString! !

!MagmaCollectionTester methodsFor: 'private' stamp: 'cmm 7/18/2002 15:40'!
removeAtIndex: anInteger at: aString

	self
		remotePerform: #removeFromLocalCollectionAtIndex:at:
		withArguments: { anInteger. aString }
		in: 'client1'.
	self
		remotePerform: #removeFromLargeCollectionAtIndex:at:
		withArguments: { anInteger. aString }
		in: 'client2'! !

!MagmaCollectionTester methodsFor: 'private' stamp: 'cmm 7/18/2002 15:40'!
saveAndVerify: anObject at: aString

	self
		remotePerform: #rootAt:put:
		withArguments: { aString. anObject }
		in: 'client1'.
	self should:
		[ self
			remotePerform: #doesGraphOf:matchRootAt:
			withArguments: { anObject.  aString }
			in: 'clent2' ]
! !

!MagmaCollectionTester methodsFor: 'private' stamp: 'cmm 7/18/2002 15:40'!
uniqueSingleKeysIn: anOrderedCollection using: aMaHashIndex

	| sorted hashes sortedSingles |

	"Make sure we only get keys with no duplicates."
	sorted _ anOrderedCollection asSortedCollection: aMaHashIndex sortBlock.
	hashes _ (anOrderedCollection collect: [ :each | aMaHashIndex indexHashFor: each ]) asBag.
	sortedSingles _ sorted select: [ :each | (hashes occurrencesOf: (aMaHashIndex indexHashFor: each)) = 1 ].
	^sortedSingles collect: [ :each | aMaHashIndex indexObjectFor: each ]
! !

!MagmaCollectionTester methodsFor: 'tests waiting for VI4' stamp: 'cmm 7/18/2002 15:40'!
futuretestAccess
	"This test creates a LargeCollection of the compiled methods in MaObject and all of
	its subclasses.  We start out with no indexes, add 1/3 of the methods, add an index,
	add another third, create a second index, then the last third.  After this we access
	based on the indexes, using LargeCollectionReader objects."

	| methods |

	methods _ self methodSamples.
	self connectNewClientSession.
	self
		addAll: (
			methods
				copyFrom: 1
				to: methods size // 3)
		at: 'methods'.
	self clientSession commit:
		[ (self clientSession root at: 'methods') addIndex: (
			MaAsciiStringIndexDefinition
				attribute: #selector
				keySize: 128) ].
	self
		verifyIndex: #selector
		at: 'methods'.
	self
		addAll: (
			methods
				copyFrom: methods size // 3 + 1
				to: methods size * 2 // 3)
		at: 'methods'.
	self clientSession commit:
		[ (self clientSession root at: 'methods') addIndex: (
			MaAsciiStringIndexDefinition
				attribute: #signature
				keySize: 256) ].
	self
		addAll: (
			methods
				copyFrom: methods size * 2 // 3 + 1
				to: methods size)
		at: 'methods'.
	self
		verifyIndex: #selector
		at: 'methods'.
	self
		verifyIndex: #signature
		at: 'methods'
! !


!Object class methodsFor: 'actions'!
maAddDataDifferencesBetween: buffer1 and: buffer2 to: aDictionary using: aMaObjectGraphComparer

	(buffer1 oids maMatchesElementsOf: buffer2 oids) ifTrue: [ ^true ].
	aDictionary
		at: 'oids'
		put: (
			Array
				with: buffer1 oids
				with: buffer2 oids).
	^false
! !


!Bag class methodsFor: 'actions'!
maAddDataDifferencesBetween: buffer1 and: buffer2 to: aDictionary using: aMaObjectGraphComparer
	"Hashed collections will not maintain the same order of their oids, but they
	should at least consist of the oids in the other.  If classes aren't the same
	then there's no chance they'll be equal.
	We know buffer1 and buffer2 are MaNormalObjectBuffers."

	| missing |

	missing _ OrderedCollection new.
	(buffer1 oids maConsistsOf: buffer2 oids) ifTrue: [ ^false ].
	buffer1 oids
		maRemoveAll: buffer2 oids
		forEachAbsent: [ :obj | missing add: obj ].
	missing collect:
		[ :eachOid |
		Association
			key: eachOid
			value: (
				aMaObjectGraphComparer serializer1
					objectWithOid: eachOid
					ifAbsent: [ '(object not found)' ]) ].
	aDictionary
		at: 'in1ButNot2'
		put: missing asArray.
	missing _ OrderedCollection new.
	buffer1 oids
		maRemoveAll: buffer2 oids
		forEachAbsent: [ :obj | missing add: obj ].
	missing collect:
		[ :eachOid |
		Association
			key: eachOid
			value: (
				aMaObjectGraphComparer serializer2
					objectWithOid: eachOid
					ifAbsent: [ '(object not found)' ]) ].
	aDictionary
		at: 'in2ButNot1'
		put: missing asArray
! !


!MaDeltaObject class methodsFor: 'creation'!
comparator: aMaObjectGraphComparer

	^self new comparator: aMaObjectGraphComparer
! !


!MaObjectGraphComparer class methodsFor: 'creation'!
object1: obj1 object2: obj2

	^(self new
		object1: obj1;
		object2: obj2)
			serializeObjects;
			loadBuffers
! !


!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 23:36'!
date: aDate time: aTime

	^self
		date: aDate
		time: aTime
		milliseconds: 0
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:50'!
date: aDate time: aTime milliseconds: anInteger

	^self fromMilliseconds: (aDate asSeconds + aTime asSeconds) * 1000 + anInteger
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:51'!
epoch
	"Return a new instance of the receiver with its time set to 0.
	This is useful for timing operations."

	^self fromMilliseconds: 0
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:44'!
fromMilliseconds: anInteger

	^self new totalMilliseconds: anInteger
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 22:39'!
fromSeconds: anInteger

	"Returns a new instance of the receiver based on anInteger seconds."

	^self new totalSeconds: anInteger
! !

!MagmaCalendarTime class methodsFor: 'creation'!
fromString: aString
	"Correct form is 'yyyy/mm/dd hh:mm:ss:nnn' or 'hh:mm:ss.nnn'
	if you intend to use the new instance as a 'duration'."

	^self
		fromString: aString
		ifInvalid: [ self error: aString, ' is not formatted properly for the default, simple parser.' ]
! !

!MagmaCalendarTime class methodsFor: 'creation'!
fromString: aString ifInvalid: aBlock
	"Correct form is 'yyyy/mm/dd hh:mm:ss:nnn' or 'hh:mm:ss.nnn'
	if you intend to use the new instance as a 'duration'."

	^aString size = 12
		ifTrue:
			[ self
				fromDurationString: aString
				ifInvalid: aBlock ]
		ifFalse:
			[ self
				fromTimeStampString: aString
				ifInvalid: aBlock ]
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/7/2002 23:38'!
now
	"answer a new timestamp for the current date and time."

	^self
		date: Date today
		time: Time now
		milliseconds: 0
! !

!MagmaCalendarTime class methodsFor: 'creation' stamp: 'cmm 3/6/2002 22:13'!
secondsPerDay

	^86400
! !

!MagmaCalendarTime class methodsFor: 'creation'!
totalMilliseconds: anInteger

	^self new totalMilliseconds: anInteger
! !

!MagmaCalendarTime class methodsFor: 'creation'!
totalSeconds: anInteger

	"Returns a new instance of the receiver based on anInteger seconds."

	^self new totalSeconds: anInteger
! !

!MagmaCalendarTime class methodsFor: 'private creation' stamp: 'cmm 3/7/2002 22:51'!
durationFromStream: aReadStream plusMilliseconds: anInteger ifInvalid: aBlock
	"Correct form is hh:mm:ss.nnn."

	| hours minutes seconds subseconds |

	(hours _ (aReadStream upTo: $:) asNumber) isNil ifTrue: [ ^aBlock value ].
	(minutes _ (aReadStream upTo: $:) asNumber) isNil ifTrue: [ ^aBlock value ].
	(seconds _ (aReadStream upTo: $.) asNumber) isNil ifTrue: [ ^aBlock value ].
	(subseconds _ aReadStream upToEnd asNumber) isNil ifTrue: [ ^aBlock value ].
	subseconds > 999 ifTrue: [ ^aBlock value ].
	^self fromMilliseconds:
		anInteger + (hours * 3600 * 1000) + (minutes * 60 * 1000) + (seconds * 1000) + subseconds
! !

!MagmaCalendarTime class methodsFor: 'private creation'!
fromDurationString: aString ifInvalid: aBlock
	"Correct form is hh:mm:ss.nnn."

	| stream |

	stream _ ReadStream on: aString trimBlanks.
	^self
		durationFromStream: stream
		plusMilliseconds: 0
		ifInvalid: aBlock
! !

!MagmaCalendarTime class methodsFor: 'private creation' stamp: 'cmm 3/7/2002 22:31'!
fromTimeStampString: aString ifInvalid: aBlock
	"Correct form is yyyy/mm/dd hh:mm:ss.mmm"

	| stream year month day |

	stream _ ReadStream on: aString.
	(year _ (stream upTo: $/) asNumber) isNil ifTrue: [ ^aBlock value ].
	(month _ (stream upTo: $/) asNumber) isNil ifTrue: [ ^aBlock value ].
	(day _ (stream upTo: $ ) asNumber) isNil ifTrue: [ ^aBlock value ].
	^self
		durationFromStream: stream
		plusMilliseconds:
			(Date
				newDay: day
				month: month
				year: year)
					asSeconds * 1000
		ifInvalid: aBlock
! !

!MagmaCalendarTime class methodsFor: 'accessing'!
nextEpoch
	"Programmers in the year 10,000, sorry about this..."

	^self fromString: '9999/12/31 23:59:59.999'
! !


!MagmaTestCase class methodsFor: 'accessing' stamp: 'cmm 6/23/2002 15:44'!
additionalProtocolForRepositoryController
	"I was unable to get Squeak to listen on *two* ports in the same image reliably.  So, for the test conductor to send commands to the server image, we implement additional request protocol."

	^{ MaUpgradeMagmaPersonRequest }
! !

!MagmaTestCase class methodsFor: 'suites' stamp: 'cmm 7/18/2002 20:12'!
setUpSuite

	| builder |
	super setUpSuite.
	self
		addPlayerNamed: 'client1';
		addPlayerNamed: 'client2'.
	builder _ self new.
	builder
		remotePerform: #connectTo:port:as:
		withArguments: { builder magmaServerAddress. 51969. 'client1' }
		in: 'client1'.
	builder
		remoteEvaluate: 'clientSession root: Dictionary new. nil'
		in: 'client1'.
	builder
		remotePerform: #disconnect
		in: 'client1'
! !

!MagmaTestCase class methodsFor: 'other squeak images' stamp: 'cmm 5/27/2002 15:15'!
baseImageFilenameFor: aString

	| filenameManipulator |

	filenameManipulator _ MaFilename fromString: MaArmoredCodeOptions baseImageFileName.
	filenameManipulator baseComponent: filenameManipulator baseComponent, aString.
	^filenameManipulator asString
! !

!MagmaTestCase class methodsFor: 'other squeak images' stamp: 'cmm 5/27/2002 15:29'!
savePlayerImageNamed: aString
	"Use this to save off a copy of a base image with a name of aString.  aString should not provide the path name, just the filename.  This method will save it in ??"
	FileDirectory default
		copyFileNamed: MaArmoredCodeOptions current baseImageFileName
		toFileNamed: (self baseImageFilenameFor: aString)
! !


!Set class methodsFor: 'actions' stamp: 'cmm 7/8/2002 16:33'!
maAddDataDifferencesBetween: buffer1 and: buffer2 to: aDictionary using: aMaObjectGraphComparer
	"Hashed collections will not maintain the same order of their oids, but they
	should at least consist of the oids in the other.  If classes aren't the same
	then there's no chance they'll be equal.

	We know buffer1 and buffer2 are MaNormalObjectBuffers."

	(buffer1 oids maConsistsOf: buffer2 oids) ifTrue: [ ^false ].
	aDictionary
		at: 'oidsIn1NotIn2'
			put: (buffer1 oids reject: [ :e | buffer2 oids includes: e ]);
		at: 'oidsIn2NotIn1'
			put: (buffer2 oids reject: [ :e | buffer1 oids includes: e ])
! !


!Dictionary class methodsFor: 'actions'!
maAddDataDifferencesBetween: buffer1 and: buffer2 to: aDictionary using: aMaObjectGraphComparer
	"Hashed collections will not maintain the same order of their oids, but they
	should at least consist of the oids in the other.  If classes aren't the same
	then there's no chance they'll be equal.

	We know buffer1 and buffer2 are MaNormalObjectBuffers."

	| buffer1Keys buffer1Values buffer2Keys buffer2Values haveDifferences x |

	haveDifferences _ false.
	x _ 0.
	buffer1Keys _ buffer1 oids select: [ :each | x _ x + 1.  x odd ].
	buffer1Values _ buffer1 oids select: [ :each | x _ x + 1.  x even ].
	buffer2Keys _ buffer2 oids select: [ :each | x _ x + 1.  x odd ].
	buffer2Values _ buffer2 oids select: [ :each | x _ x + 1.  x even ].
	(buffer1Keys maConsistsOf: buffer2Keys)
		ifFalse:
			[ aDictionary
				at: 'keysIn1NotIn2'
				put: (buffer1Keys maRemoveAll: buffer2Keys forEachAbsent: [ :absent | ]; yourself).
			aDictionary
				at: 'keysIn2NotIn1'
				put: (buffer2Keys maRemoveAll: buffer1Keys forEachAbsent: [ :absent | ]; yourself).
			haveDifferences _ true ].
	(buffer1Values maConsistsOf: buffer2Values)
		ifFalse:
			[ aDictionary
				at: 'valuesIn1NotIn2'
				put: (buffer1Values maRemoveAll: buffer2Values forEachAbsent: [ :absent | ]; yourself).
			aDictionary
				at: 'valuesIn2NotIn1'
				put: (buffer2Values maRemoveAll: buffer1Values forEachAbsent: [ :absent | ]; yourself).
			haveDifferences _ true ]
! !


!MagmaTestCase class reorganize!
('accessing' additionalProtocolForRepositoryController)
('suites' setUpSuite)
('other squeak images' baseImageFilenameFor: savePlayerImageNamed:)
('initializing')
!

MagmaCollectionTester removeSelector: #verify:from:to:against:!

!MagmaTestCase reorganize!
('test grow an object' addAndGrowObject readAndVerifyGrownObject testGrowObject)
('test transactions' performCommitAndRefreshTest performCommitConflictTest testTransactions)
('test commit object knot' addKnot longtestCommitKnot verifyKnot)
('test class schema upgrades' addLocations addOldTimeStamps addPeople commitAllPersons commitBirthdaysToFirstPerson commitBirthdaysToSomePersons commitChangesToSomeUpgradedPersons loadOldVersionsOfAllClassesInAllClients newOldVersionTimeStamps newVersionTimeStamps oldVersionTimeStamps organizationsSample1 populateOriginalPeopleAndLocationsAndTimeStamps remotePerformUpgradeMagmaPerson testClassSchemaUpgrades timeStampFixtureMilliseconds upgradeCalendarTime upgradeMagmaPerson validateFirstBirthday verifyTimeStampsInTestRepository)
('client' clientSession commit connectTo:port:as: disconnect rootAt:put:)
('server' administerNewRepositoryController administerRepository close createBaseRepository createNewRepository deleteFiles fileNames magmaServerAddress newRepositoryController openNewRepositoryController openRepository repositoryController repositoryController: stopServer)
('Armored Code' environmentPath repositoryFileName resourcesPath)
('tests waiting for VI4' futuretestCommitChangesToAllPersonsAfterUpgradingCalendarTime)
('loading code' loadChangeSet: loadNewVersionOfMagmaCalendarTime loadNewVersionOfMagmaPerson)
('initializing' additionalProtocol connectClients disconnectClients initialize setUp tearDown)
('asserting' graphOf:shouldMatch:)
('private' doesGraphOf:match: saveAndVerify:at:)
('test objects' peopleSample1)
!


!MagmaFixtureFactory reorganize!
('accessing' newOrganizationMailingAddresses:)
('creation' knot newMailingAddresses: newOrganizations: newPersonNames: newPersons:)
('future samples to support' blockSamples compiledMethodSamples sortedCollectionSamples)
('private accessing' allCollectionSamplesHoldingNonCollections allNonCollectionSamples firstNames lastNames methodsInCategory: middleNames streetNames)
('private collection samples' arraySamples dictionarySamples orderedCollectionSamples setSamples)
('private creation - domain objects' zipCodes)
('private individual fixtures' noArgComplexBlock oneArgComplexBlock simpleBlock threeArgComplexBlock)
('private non-collection samples' atomicSamples byteArraySamples characterSamples floatSamples fractionSamples globalSamples largeIntegerSamples readStreamSamples readWriteStreamSamples smallIntegerSamples stringSamples symbolSamples userObjectsSamples writeStreamSamples)
!

MagmaCollectionReader removeSelector: #copyFromKey:to:using:!

!MaHashIndexRecordTester reorganize!
('initializing' initialize)
('private actions' navigateRecordsFrom:toLevel:do:until:)
('creation' newHashIndexRecord newHighKeyRecord newLowKeyRecord newMidKeyRecord)
('private creation' newRecordFrom:to:)
('tests' testHighKeyRecords testLowKeyRecords testMidKeyRecords)
('private tests' verifyConsecutiveContiguousKeyRangesOn: verifyEntryIndexAndRangeEndpointCongruenceOn: verifyRecord:)
!

MagmaFixtureFactory reset!

